// ABOUTDLG.CXX - About Dialogs object members

// Include TIER 1 objects used in this module

#define INCL_TIER_TYPES                 
#define INCL_TIER_OBJECT                
#define INCL_TIER_WINDOW                
   #define INCL_TIER_WINDOWMSGS         
#define INCL_TIER_DIALOG                
#define INCL_TIER_CONTROLWINDOW
#define INCL_TIER_BUTTON
#define INCL_TIER_DLGPROC               
#define INCL_TIER_MODALDLG              
#define INCL_TIER_DC
#define INCL_TIER_PAINT
#define INCL_TIER_GDI
#define INCL_TIER_GDIBITMAP




// Module includes .......................................................
#ifdef _TURBOL
extern "C"        {
#define __MSC
#endif // _TURBOL

#ifdef _GLOCK20L
extern "C"        {
#endif // _GLOCK20L

#ifdef _ZTC201L
extern "Pascal"   {
#endif // _ZTC201L

#include <stdio.h>       // sprintf(), fprintf()

#ifdef _GLOCK20L
                  }
#endif // _GLOCK20L

#ifdef _ZTC201L
                  }
#endif // _ZTC201L

#ifdef _TURBOL
                  }
#endif // _TURBOL


#include <tier1.hxx>     // This gets all needed includes for a Tier2 app.
#include "defines.h"     // App. common resource defines
#include "aboutdlg.hxx"  // Object definition associated with this module.  
                         



//////////////////////////////////////////////////////////////////////////////
// AboutDlg member functions (About Edit or DblClick)
//////////////////////////////////////////////////////////////////////////////
AboutDlg :: FAR AboutDlg( Window FAR *lpParentWindow ) : (lpParentWindow)
   {
   Create( IDD_ABOUT );
   }                                  




// Destructor
AboutDlg :: ~AboutDlg()
   {
   // do nothing yet!
   }




// About Dialog message handling function.
BOOL AboutDlg :: FAR DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam )
   {
      static GdiBitmap FAR  *lpBMap;
      static int             nWidth, nHeight;
      int                    x, y, cx, cy;
      int                    x1, y1, nWidth1, nHeight1;

   switch( iMessage )
      {
      case  WM_INITDIALOG:
            {
            ButtonWindow    Ok( this, IDOK, FALSE );

            lpBMap = new GdiBitmap();
            lpBMap->Load( this, IDB_TIERABOUT, FALSE );

            WinGetWindowRect( x, y, cx, cy );
            Ok.WinGetClientRect( x1, y1, nWidth1, nHeight1 );

            nWidth   = lpBMap->GetWidth();
            nHeight  = lpBMap->GetHeight();          

            WinSetWindowPosition( x, y, nWidth+11, nHeight+11+nHeight1+4 );

            WinGetClientRect( x, y, cx, cy );
            Ok.WinMove( (cx/2)-(nWidth1/2), ((cy-nHeight1)-2),
                        nWidth1, nHeight1, FALSE );    

            DlgPostMessage( this, WM_SETFOCUS, IDOK, 0L );
            }
      break;

      case  WM_PAINT:
            {
            Paint    paint( this );
            ClientDC dc( this );
            MemoryDC mdc( dc );

            if( lpBMap )
               {
               lpBMap->Select( mdc );
               lpBMap->Blt( dc, 0, 0, nWidth, nHeight, mdc, 0, 0, BITMAP_SRCCOPY );
               lpBMap->DeSelect();
               }
            }
      break;

      case  WM_COMMAND:
            switch( wParam )
               {
               case  IDOK:
                     delete lpBMap;
                     End( TRUE );
               break;
               }
      break;

      default:
         return( DlgDefMessageHandler(hDlg,iMessage,wParam,lParam) );
      }

   return( TRUE  );
   }

