/*
 *    arcnamer -- archive files and rename with A in extension
 */

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <process.h>

int usage(void);
int arcname(void);

struct find_t b_file;
unsigned char arc_name[13];
unsigned char arc_pgm[32];
unsigned char arc_parm[32];
int count = 0;

main(int argc, char **argv)
{
unsigned int errcode;
	/* check for arguments */
	if (argc == 1) {
		usage();
		exit(2);
	}
	if (argc > 2)
		strcpy(arc_pgm,argv[2]);
	else
		strcpy(arc_pgm,"ARC");

	if (argc > 3)
		strcpy(arc_parm,argv[3]);
	else
		strcpy(arc_parm,"a");

	/* find first file */
	errcode = _dos_findfirst(argv[1], _A_NORMAL, &b_file);
	if (errcode == 0) {
		arcname();
		/* find the other files */
		while(_dos_findnext(&b_file) == 0)
				arcname();
	}
	if (count)
		return(1);
	/* get credit */
	printf("\r\nArcNamer 1.0 - October 1991 - by Dana Bell\r\n");
	printf("\r\nNo files found to process\r\n");
}

int usage()
{
	printf("\r\nArcNamer 1.0\r\n");
	printf("by Dana Bell\r\n");
	printf("(for nodelists and such)\r\n");
	printf("\r\nArcNamer is used to archive files with numbered extensions.\r\n");
	printf("Archives are named with the same extension as the file except\r\n");
	printf("that the first letter is changed to an A, as NODELIST.A22.\r\n");
	printf("Usage:\r\n\tARCNAMER filespec <archive command> <options>\r\n");
	printf("Example:\r\n\tARCNAMER NODELIST.* PKARC A\r\n");
	printf("will execute the command \"PKARC A NODELIST.nnn NODELIST.Ann\"\r\n");
	printf("for any numbered nodelists in the current directory.\r\n");
	printf("\r\n<archive command> defaults to \"ARC\"\r\n");
	printf("\r\n<option> defaults to \"a\"\r\n");
	return(0);
}

int arcname()
{
int status;
int day;
char *ptr;

	strcpy(arc_name, b_file.name);
	if (( ptr = strchr(arc_name,'.')) != NULL)
		ptr[1] = 'A';
	if ((day = atoi( strchr(b_file.name,'.')+1)) == 0)
		return(0);

	count++;
	/* get credit */
	printf("\r\nArcNamer 1.0 - October 1991 - by Dana Bell\r\n");
	printf("\r\nThe filename is %s; The archive will be %s\r\n",
		b_file.name, arc_name);
	printf("The command is: %s %s %s\r\n",
		arc_pgm, arc_parm, arc_name,b_file.name);
	status = spawnlp(P_WAIT, arc_pgm,
		arc_pgm, arc_parm, arc_name,b_file.name,NULL);
	if (status == -1)
		perror("Error executing child process");
	return(1);
}
