/*  -- bbsfile.c --
**
**  file subsystem for bbs.c
*/

#include <stdio.h>
#include "pcl4c.h"
#include "ascii.h"
#include "bbs.h"

extern int TransferFlag;
extern char Buffer[1024];
extern char Directory[65];

char DTAbuffer[128];
char *Protocol[4] = {"","XMODEM","YMODEM",""};

int TopMenu(Port)
int Port;
{int Code;
 /* begin */
 while(1)
    {PutCRLF(Port);
     PutString(Port,"** Top Menu **");
     PutString(Port,"0) EXIT");
     PutString(Port,"1) Files");
     PutString(Port,"-->Choose 0 or 1: ");
     while(1)
        {if(SioBrkKey()) MyExit(0,"Aborted by user");
         Code = GetChar(Port,2*SECONDS);
         if(Code<-1) MyExit(Code,"Error in user response");
         if(Code>-1) break;
        }
     if((char)Code>='0' && (char)Code<='1') return(Code-'0');
     if(Code!=CAN) PutString(Port,"ERROR: Must answer 0 or 1 !");
    } /* end while */
} /* end TopMenu */

int FileMenu(Port)
int Port;
{int Code;
 /* begin */
 while(1)
    {PutCRLF(Port);
     PutString(Port,"** File Menu **");
     PutString(Port,"0) EXIT menu");
     PutString(Port,"1) List Download Files");
     PutString(Port,"2) DownLoad File");
     PutString(Port,"3) Upload File");
     PutString(Port,"-->Choose 0 to 3: ");
     while(1)
        {if(SioBrkKey()) MyExit(0,"Aborted by user");
         Code = GetChar(Port,2*SECONDS);
         if(Code<-1) MyExit(Code,"Error in user response");
         if(Code>-1) break;
        }
     if((char)Code>='0' && (char)Code<='3') return(Code-'0');
     if(Code!=CAN) PutString(Port,"ERROR: Must answer 0 to 3 !");
   } /* end while */
} /* end FileMenu */

int ProtocolMenu(Port)
int Port;
{int i;
 int Code;
 /* begin */
 while(1)
   {PutCRLF(Port);
    PutString(Port,"** Protocol **");
    PutString(Port,"0) EXIT Menu");
    PutString(Port,"1) XMODEM");
    PutString(Port,"2) YMODEM");
    PutString(Port,"-->Choose 0 to 2: ");
    Code = GetChar(Port,2*MINUTES);
    if(Code<0) MyExit(Code,"Error in user response");
    if((char)Code>='0' && (char)Code<='2') return(Code-'0');
    PutString(Port,"ERROR: Must answer 0 to 2 !");
   }
} /* end ProtocolMenu */

int FileSystem(Port,Code)
int Port;
int Code;
{int p;
 char Filename[15];
 char Temp[80];
 int Status;
 /* begin */
 switch(Code)
    {case 1: /* List Files */
        /* list all downloadable files */
        PutCRLF(Port);
        PutString(Port,"*** Download Files are:");
        if(!ChangeDir("DNLOAD"))
           {SayError(Port,"Missing DNLOAD subdirectory");
            break;
           }
        /* set DTA & find 1st file to list */
        setDTA(DTAbuffer);
        if(FindFirst("*.*"))
           {/* list 1st file */
            PutString(Port,&DTAbuffer[30]);
            /* list remaining files */
            while(FindNext()) PutString(Port,&DTAbuffer[30]);
           }
        ChangeDir(Directory);
        PutString(Port,"*** end list");
        PutCRLF;
        break;
     case 2: /* DownLoad files */
        if(!ChangeDir("DNLOAD"))
           {SayError(Port,"Missing DNLOAD subdirectory");
            break;
           }
        /* get filename from user */
        PutCRLF(Port);
        PutString(Port,"Enter file name: ");
        GetString(Port,Filename,13);
        /* set DTA & find file */
        setDTA(DTAbuffer);
        if(!FindFirst(Filename))
           {PutString(Port,"No such file");
            ChangeDir(Directory);
            break;
           }
        /* select protocol */
        p = ProtocolMenu(Port);
        if(p==0)
           {ChangeDir(Directory);
            break;
           }
        /* ready to start transfer */
        sprintf(Temp,"Start your %s receiver",Protocol[p]);
        PutString(Port,Temp);
        TransferFlag = TRUE;
        switch(p)
           {
            case 1: /* XMODEM */
               Status = TxyModem(Port,&DTAbuffer[30],Buffer,FALSE,FALSE);
               break;
            case 2: /* YMODEM */
               Status = TxyModem(Port,&DTAbuffer[30],Buffer,TRUE,TRUE);
               if(!Status) break;
               Filename[0] = '\0';
               TxyModem(Port,Filename,Buffer,TRUE,TRUE);
               break;
           } /* end switch(p) */
        TransferFlag = FALSE;
        if(!Status)
           {SioPutc(Port,CAN);
            SioPutc(Port,CAN);
           }
        ChangeDir(Directory);
        break;
     case 3: /* UpLoad files */
        if(!ChangeDir("UPLOAD"))
           {SayError(Port,"Missing UPLOAD subdirectory");
            break;
           }
        PutCRLF(Port);
        PutString(Port,"Upload file");
        /* select protocol */
        p = ProtocolMenu(Port);
        if(p==0)
           {ChangeDir(Directory);
            break;
           }
        /* need filename for all but YMODEM */
        if(p==3) Filename[0] = '\0';
        else
           {PutCRLF(Port);
            PutString(Port,"Enter file name: ");
            GetString(Port,Filename,13);
            setDTA(DTAbuffer);
           } /* end else */
        sprintf(Temp,"Start your %s transmitter",Protocol[p]);
        PutString(Port,Temp);
        TransferFlag = TRUE;
        switch(p)
           {
            case 1: /* XMODEM */
               Status = RxyModem(Port,Filename,Buffer,TRUE,FALSE);
               break;
            case 2: /* YMODEM */
               do
                  { /* get next file */
                    Status = RxyModem(Port,Filename,Buffer,TRUE,TRUE);
                  } while(Filename[0]!='\0');
               break;
           } /* end switch(p) */
        TransferFlag = FALSE;
        if(!Status)
           {SioPutc(Port,CAN);
            SioPutc(Port,CAN);
           }
        ChangeDir(Directory);
        break;
    } /* end switch(Code) */
 SioRxFlush(Port);
} /* end FileSystem */
