/*** bbs_io.c ***/

#include <stdio.h>
#include "pcl4c.h"
#include "ascii.h"
#include "bbs.h"

extern int TransferFlag;
extern int EchoFlag;

/*** output to serial port ***/

int PutChar(Port,ch)
int Port;
char ch;
{int Code;
 /* output character */
 Code = SioPutc(Port,ch);
 if(Code<0)
     {printf("COM%d Error: ",1+Port);
      SioError(Code);
      exit(1);
     }
 if(!TransferFlag) SioCrtWrite(ch);
 return(Code);
 }

/*** receive from serial port ***/

int GetChar(Port,Timeout)
int Port;
int Timeout;
{int Code;
 /* input character */
 Code = SioGetc(Port,Timeout);
 if(Code<-1)
     {printf("COM%d Error: ",1+Port);
      SioError(Code);
      exit(1);
     }
 if(!TransferFlag) if(Code!=-1) SioCrtWrite(Code);
 return(Code);
}

/*** output carriage return and line feed ***/

int PutCRLF(Port)
{
 PutChar(Port,CR);
 PutChar(Port,LF);
}

/*** output text string ***/

int PutString(Port,String)
int Port;
char *String;
{int i;
 PutCRLF(Port);
 for(i=0;i<strlen(String);i++)
    {/* write character to port */
     PutChar(Port,String[i]);
     /*SioDelay(1);*/
    }
} /* end PutString */

/*** receive text string ***/

int GetString(Port,Buffer,MaxLen)
int Port;
char *Buffer;
int MaxLen;
{int i = 0;
 int Code;
 int Wait = 60;
 printf("\n");
 while(1)
   {/* fetch next character from port */
    Code = GetChar(Port,Wait*SECONDS);
    if(Code==-1) return(Code);
    if(Code<0) MyExit(Code,"Error ");
    /* echo it back ? */
    if(EchoFlag) SioPutc(Port,Code);
    else SioPutc(Port,'.');
    /* carriage return ? */
    if((char)Code==CR)
       {Buffer[i] = '\0';
        return(0);
       }
    /* backspace ? */
    if((char)Code==BS)
      {if(i==0) continue;
       else i--;
      }
    else  /* stuff in string buffer */
      {Buffer[i++] = (char)Code;
       Wait = 10;
       if(i>MaxLen) return(1);
      }
   } /* end while */
} /* end GetString */

/*** display error text ***/

int SayError(Port,Msg)
int Port;
char *Msg;
{char Temp[80];
 sprintf(Temp,"ERROR: COM%d - %s",1+Port,Msg);
 PutString(Port,Temp);
} /* end SayError */

/*** display message at bottom of screen ***/

int DisplayLine(Msg,Ptr,Len)
char *Msg;
char *Ptr; /* not used */
int Len;   /* not used */
{
 printf("[%s]\n",Msg);
} /* end DisplayLine */
/*** test for break condition ***/

int TestBreak()
{if(SioBrkKey()) MyExit(0,"User pressed Ctrl-BREAK");
}