/*
File          : CAT.C    (Concatenate files and print)
Author        : p. 154 of the Kernighan and Ritchie text
                Current version and hacks by:

                    Thomas P. Devitt
                    Pseudonym Software - Data: 818-796-4197

Updated on    : July 5, 1987
Include files : stdio.h
                dos.h
                process.h
                cat.h         (external definitions, function prototypes)
Portibility   : PC/MS-DOS only
Defined in    : UNIX (All versions)
Synopsis      : CAT [ filename1 ] [...] [ filenameN ]
*/

#include <stdio.h>
#include <dos.h>
#include <process.h>
#include "cat.h"

main(int argc, char *argv[])        /* cat: concatenate files */
{
    FILE *fp;

    int  count, currentp;
    int  found = 0;

    if (argc == 1)
    {                          /* no args; copy standard input */
       found++;
       filecopy(stdin);
    }
    else
       if ( argc == 2 && argv[1][0] == '?' && argv[1][1] == 0)
       {
          help();
          exit(0);
       }
    while (--argc > 0)
    {
       count = getfnl(*++argv,fnames,sizeof(fnames),ANY);
       if (count > 0)
       {
          found++;
          if (strbpl(fpointers,300,fnames) != count)
          {
             fprintf(stderr,"\nCat: Too many file names\n");
             exit(1);
          }
          else
          {
             currentp = 0;
             while (currentp < count)
             {
                fp = fopen(fpointers[currentp], "r");
                filecopy(fp);
                fclose(fp);
                currentp++;
             }
          }
       }
    }
    if ( !found )
       fprintf(stderr,"\nCat: No matching files.\n");

    exit(0);
}

void filecopy(FILE *fp)    /* copy file fp to standard output */
{
    int c;

    while ((c = getc(fp)) != EOF)
        putc(c, stdout);
}

void help(void)
{
   register char   **dp;

   for (dp = documentation; *dp; dp++)
         printf("%s\n", *dp);
 }

