
/* ******************************************************************
 * Function name  : cmet_feet(cmet)
 *
 * Description    : This function converts centimeters to feet.
 *
 * Variables      : cmet - This variable is the input parameter and
 *                         contains the number of centimeters to be
 *                         converted.
 *
 *                  feet - This variable is the function's return
 *                         value and contains the number of feet
 *                         corresponding to the centimeter value is
 *                         "cmet".
 *
 * Example       : output = cmet_feet(5)        returns value  .164
 *                 output = cmet_feet(10)       returns value  .328
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program
 *                 must define the function cmet_feet() and the
 *                 function's return value as a double. An
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double cmet_feet();
 *
 *                 input = 15;
 *                 output = cmet_feet(input);
 *
 *
 */

double cmet_feet(cmet)
 double cmet;

{ double feet;
  feet = cmet * .0328;
  return(feet);
}

/* ******************************************************************
 * Function name  : cmet_inch(cmet)
 *
 * Description    : This function converts centimeters to inches.
 *
 * Variables      : cmet - This variable is the input parameter and
 *                         contains the number of centimeters to be
 *                         converted.
 *
 *                  inch - This variable is the function's return
 *                         value and contains the number of inches
 *                         corresponding to the centimeter value is
 *                         "cmet".
 *
 * Example       : output = cmet_inch(5)      returns value  1.97
 *                 output = cmet_inch(10)     returns value  3.94
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program
 *                 must define the function cmet_inch() and the
 *                 function's return value as a double. An
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double cmet_inch();
 *
 *                 input = 15;
 *                 output = cmet_inch(input);
 *
 *
 */

double cmet_inch(cmet)
 double cmet;

{ double inch;
  inch = cmet * .394;
  return(inch);
}

/* ******************************************************************
 * Function name  : feet_cmet(feet)
 *
 * Description    : This function converts feet to centimeters.
 *
 * Variables      : feet - This variable is the input parameter and
 *                         contains the number of feet to be
 *                         converted.
 *
 *                  cmet - This variable is the function's return
 *                         value and contains the number of
 *                         centimeters corresponding to the feet
 *                         value is "feet".
 *
 * Example       : output = feet_cmet(5)      returns value 152.4
 *                 output = feet_cmet(10)     returns value 304.8
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program
 *                 must define the function feet_cmet() and the
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double feet_cmet();
 * 
 *                 input = 15;
 *                 output = feet_cmet(input);
 *                 
 *
 */

double feet_cmet(feet)
 double feet;

{ double cmet;
  cmet = feet * 30.48;
  return(cmet);
}

/* ******************************************************************
 * Function name  : gal_liter(gal)
 *
 * Description    : This function converts gallons to liters.
 *
 * Variables      : gal  - This variable is the input parameter and
 *                         contains the number of gallons to be
 *                         converted.
 *
 *                  liter - This variable is the function's return
 *                         value and contains the number of
 *                         centimeters corresponding to the liters
 *                         value in "gal".
 *
 * Example       : output = gal_liter(5)      returns value 18.925
 *                 output = gal_liter(10)     returns value 37.85
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program
 *                 must define the function gal_liter() and the
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double gal_liter();
 * 
 *                 input = 15;
 *                 output = gal_liter(input);
 *                 
 *
 */
double gal_liter(gal)
 double gal;

{ double liter;
  liter = gal * 3.785;
  return(liter);
}

/* ******************************************************************
 * Function name  : gram_ounce(gram)
 *
 * Description    : This function converts grams to ounces.
 *
 * Variables      : gram - This variable is the input parameter and 
 *                         contains the number of grams to be
 *                         converted.
 *
 *                  ounce - This variable is the function's return
 *                         value and contains the number of 
 *                         ounces corresponding to the value 
 *                         in "gram".
 *
 * Example       : output = gram_ounce(5)      returns value .175
 *                 output = gram_ounce(10)     returns value .35
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function gram_ounce() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double gram_ounce();
 * 
 *                 input = 15;
 *                 output = gram_ounce(input);
 *                 
 *
 */

double gram_ounce(gram)
 double gram;

{ double ounce;
  ounce = gram * .035;
  return(ounce);
}

/* ******************************************************************
 * Function name  : inch_cmet(inch)
 *
 * Description    : This function converts inches to centimeters.
 *
 * Variables      : inch - This variable is the input parameter and 
 *                         contains the number of inch to be
 *                         converted.
 *
 *                  cmet - This variable is the function's return
 *                         value and contains the number of 
 *                         centimeters corresponding to the value 
 *                         in "inch".
 *
 * Example       : output = inch_cmet(5)      returns value 12.7
 *                 output = inch_cmet(10)     returns value 25.4
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function inch_cmet() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double inch_cmet();
 * 
 *                 input = 15;
 *                 output = inch_cmet(input);
 *                 
 *
 */

double inch_cmet(inch)
 double inch;

{ double cmet;
  cmet = inch * 2.54; 
  return(cmet);
}

/* ******************************************************************
 * Function name  : inch_met(inch)
 *
 * Description    : This function converts inches to centimeters.
 *
 * Variables      : inch - This variable is the input parameter and 
 *                         contains the number of inch to be
 *                         converted.
 *
 *                  met  - This variable is the function's return
 *                         value and contains the number of 
 *                         centimeters corresponding to the value 
 *                         in "inch".
 *
 * Example       : output = inch_met(5)      returns value .127
 *                 output = inch_met(10)     returns value .254
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function inch_met() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double inch_met();
 * 
 *                 input = 15;
 *                 output = inch_met(input);
 *                 
 *
 */

double inch_met(inch)
 double inch;

{ double met;
  met = inch / 39.37;
  return(met);
}

/* ******************************************************************
 * Function name  : kgram_ounce(kgram)
 *
 * Description    : This function converts kilograms to ounces.
 *
 * Variables      : kgram - This variable is the input parameter and 
 *                         contains the number of kilograms to be
 *                         converted.
 *
 *                  ounce - This variable is the function's return
 *                         value and contains the number of 
 *                         ounces corresponding to the value 
 *                         in "kgram".
 *
 * Example       : output = kgram_ounce(5)      returns value 176.36
 *                 output = kgram_ounce(10)     returns value 352.72
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function kgram_ounce() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double kgram_ounce();
 * 
 *                 input = 15;
 *                 output = kgram_ounce(input);
 *                 
 *
 */

double kgram_ounce(kgram)
 double kgram;

{ double ounce;
  ounce = kgram * 35.272;
  return(ounce);
}

/* ******************************************************************
 * Function name  : kgram_pound(kgram)
 *
 * Description    : This function converts kilograms to ounces.
 *
 * Variables      : kgram - This variable is the input parameter and 
 *                         contains the number of kilograms to be
 *                         converted.
 *
 *                  pound - This variable is the function's return
 *                         value and contains the number of 
 *                         pounds corresponding to the value 
 *                         in "kgram".
 *
 * Example       : output = kgram_pound(5)      returns value 11.025
 *                 output = kgram_pound(10)     returns value 22.05
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function kgram_pound() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double kgram_pound();
 * 
 *                 input = 15;
 *                 output = kgram_pound(input);
 *                 
 *
 */

double kgram_pound(kgram)
 double kgram;

{ double pound;
  pound = kgram * 2.205;
  return(pound);
}

/* ******************************************************************
 * Function name  : kmet_mile(kmet)
 *
 * Description    : This function converts kilometers to miles.
 *
 * Variables      : kmet - This variable is the input parameter and 
 *                         contains the number of kilometers to be
 *                         converted.
 *
 *                  mile - This variable is the function's return
 *                         value and contains the number of 
 *                         miles corresponding to the value 
 *                         in "kmet".
 *
 * Example       : output = kmet_mile(5)      returns value 3.105
 *                 output = kmet_mile(10)     returns value 6.21
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function kmet_mile() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double kmet_mile();
 * 
 *                 input = 15;
 *                 output = kmet_mile(input);
 *                 
 *
 */

double kmet_mile(kmet)
 double kmet;

{ double mile;
  mile = kmet * .621;
  return(mile);
}

/* ******************************************************************
 * Function name  : liter_gal(liter)
 *
 * Description    : This function converts liters to gallons.
 *
 * Variables      : liter - This variable is the input parameter and 
 *                         contains the number of liters to be
 *                         converted.
 *
 *                  gal  - This variable is the function's return
 *                         value and contains the number of 
 *                         gallons corresponding to the value 
 *                         in "liter".
 *
 * Example       : output = liter_gal(5)      returns value 1.32
 *                 output = liter_gal(10)     returns value 2.64
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function liter_gal() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double liter_gal();
 * 
 *                 input = 15;
 *                 output = liter_gal(input);
 *                 
 *
 */

double liter_gal(liter)
 double liter;

{ double gal;
  gal = liter * .264;
  return(gal);
}

/* ******************************************************************
 * Function name  : liter_quart(liter)
 *
 * Description    : This function converts liters to quarts.
 *
 * Variables      : liter - This variable is the input parameter and 
 *                         contains the number of liters to be
 *                         converted.
 *
 *                  quart  - This variable is the function's return
 *                         value and contains the number of 
 *                         quarts corresponding to the value 
 *                         in "liter".
 *
 * Example       : output = liter_quart(5)      returns value 5.285
 *                 output = liter_quart(10)     returns value 10.57
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function liter_quart() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double liter_quart();
 * 
 *                 input = 15;
 *                 output = liter_quart(input);
 *                 
 *
 */

double liter_quart(liter)
 double liter;

{ double quart;
  quart = liter * 1.057;
  return(quart);
}

/* ******************************************************************
 * Function name  : met_inch(met)
 *
 * Description    : This function converts meters to inches.
 *
 * Variables      : met - This variable is the input parameter and 
 *                         contains the number of meters to be
 *                         converted.
 *
 *                  inches - This variable is the function's return
 *                         value and contains the number of 
 *                         inches corresponding to the value 
 *                         in "met".
 *
 * Example       : output = met_inch(5)      returns value 196.85
 *                 output = met_inch(10)     returns value 393.7
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function met_inch() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double met_inch();
 * 
 *                 input = 15;
 *                 output = met_inch(input);
 *                 
 *
 */

double met_inch(met)
 double met;

{ double inch;
  inch = met * 39.37;
  return(inch);
}

/* ******************************************************************
 * Function name  : met_yards(yards)
 *
 * Description    : This function converts meters to yards.
 *
 * Variables      : met - This variable is the input parameter and 
 *                         contains the number of meters to be
 *                         converted.
 *
 *                  yards - This variable is the function's return
 *                         value and contains the number of 
 *                         yards corresponding to the value 
 *                         in "met".
 *
 * Example       : output = met_yards(5)      returns value 5.465
 *                 output = met_yards(10)     returns value 10.93
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function met_yards() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double met_yards();
 * 
 *                 input = 15;
 *                 output = met_yards(input);
 *                 
 *
 */

double met_yards(met)
 double met;

{ double yards;
  yards = met * 1.093;
  return(yards);
}

/* ******************************************************************
 * Function name  : mile_kmet(mile)
 *
 * Description    : This function converts miles to kilometers.
 *
 * Variables      : mile - This variable is the input parameter and 
 *                         contains the number of miles to be
 *                         converted.
 *
 *                  kmet - This variable is the function's return
 *                         value and contains the number of 
 *                         kilometers corresponding to the value 
 *                         in "mile".
 *
 * Example       : output = mile_kmet(5)      returns value 8.045
 *                 output = mile_kmet(10)     returns value 16.09
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function mile_kmet() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double mile_kmet();
 * 
 *                 input = 15;
 *                 output = mile_kmet(input);
 *                 
 *
 */

double mile_kmet(mile)
 double mile;

{ double kmet;
  kmet = mile * 1.609;
  return(kmet);
}

/* ******************************************************************
 * Function name  : ounce_gram(ounce)
 *
 * Description    : This function converts miles to kilometers.
 *
 * Variables      : ounce - This variable is the input parameter and 
 *                         contains the number of ounces to be
 *                         converted.
 *
 *                  gram - This variable is the function's return
 *                         value and contains the number of 
 *                         grams corresponding to the value 
 *                         in "ounce".
 *
 * Example       : output = ounce_gram(5)      returns value 141.75
 *                 output = ounce_gram(10)     returns value 283.50
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function ounce_gram() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double ounce_gram();
 * 
 *                 input = 15;
 *                 output = ounce_gram(input);
 *                 
 *
 */

double ounce_gram(ounce)
 double ounce;

{ double gram;
  gram = ounce * 28.35;
  return(gram);
}

/* ******************************************************************
 * Function name  : ounce_kgram(ounce)
 *
 * Description    : This function converts ounces to kilograms.
 *
 * Variables      : ounce - This variable is the input parameter and 
 *                         contains the number of ounces to be
 *                         converted.
 *
 *                  kgram - This variable is the function's return
 *                         value and contains the number of 
 *                         kilograms corresponding to the value 
 *                         in "ounce".
 *
 * Example       : output = ounce_kgram(5)      returns value .14
 *                 output = ounce_kgram(10)     returns value .28
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function ounce_kgram() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double ounce_kgram();
 * 
 *                 input = 15;
 *                 output = ounce_kgram(input);
 *                 
 *
 */

double ounce_kgram(ounce)
 double ounce;

{ double kgram;
  kgram = ounce * .028;
  return(kgram);
}

/* ******************************************************************
 * Function name  : pound_kgram(ounce)
 *
 * Description    : This function converts pounds to kilograms.
 *
 * Variables      : pound - This variable is the input parameter and 
 *                         contains the number of pounds to be
 *                         converted.
 *
 *                  kgram - This variable is the function's return
 *                         value and contains the number of 
 *                         kilograms corresponding to the value 
 *                         in "pound".
 *
 * Example       : output = pound_kgram(5)      returns value 2.27
 *                 output = pound_kgram(10)     returns value 4.54
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function pound_kgram() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double pound_kgram();
 * 
 *                 input = 15;
 *                 output = pound_kgram(input);
 *                 
 *
 */

double pound_kgram(pound)
 double pound;

{ double kgram;
  kgram = pound * .454;
  return(kgram);
}

/* ******************************************************************
 * Function name  : quart_liter(quart)
 *
 * Description    : This function converts quarts to liters.
 *
 * Variables      : quart - This variable is the input parameter and 
 *                         contains the number of quarts to be
 *                         converted.
 *
 *                  liter - This variable is the function's return
 *                         value and contains the number of 
 *                         liters corresponding to the value 
 *                         in "quart".
 *
 * Example       : output = quart_liter(5)      returns value 4.73
 *                 output = quart_liter(10)     returns value 9.46
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function quart_liter() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double quart_liter();
 * 
 *                 input = 15;
 *                 output = quart_liter(input);
 *                 
 *
 */

double quart_liter(quart)
 double quart;

{ double liter;
  liter = quart * .946;
  return(liter);
}

/* ******************************************************************
 * Function name  : yards_met(quart)
 *
 * Description    : This function converts yards to meters.
 *
 * Variables      : yards - This variable is the input parameter and 
 *                         contains the number of yards to be
 *                         converted.
 *
 *                  meter - This variable is the function's return
 *                         value and contains the number of 
 *                         meter corresponding to the value 
 *                         in "yards".
 *
 * Example       : output = yards_met(5)      returns value 4.57
 *                 output = yards_met(10)     returns value 9.14
 *
 * Rules         : This function must be passed a variable defined
 *                 as a "double". Additionally, the calling program 
 *                 must define the function yards_met() and the 
 *                 function's return value as a double. An 
 *                 example of these calling requirements is shown
 *                 below.
 *
 * Calling ex.   : double input;
 *                 double output;
 *                 double yards_met();
 * 
 *                 input = 15;
 *                 output = yards_met(input);
 *                 
 *
 */

double yards_met(yards)
 double yards;

{ double met;
  met = yards * .914;
  return(met);
}
