/* Display Protos */
void Initialize(void);
void ExitChess(void);
void TerminateSearch(void);
void InputCommand(void);
void help(void);
void EditBoard(void);
void ShowDepth(char ch);
void ShowResults(short score,unsigned short bstline[], char ch);
void SearchStartStuff(short side);
void OutputMove(void);
void ElapsedTime(short iop);
void SetTimeControl(void);
void ClrScreen(void);
void UpdateDisplay(short f,short t,short flag,short iscastle);
void GetOpenings(void);
int  parse(FILE *fd, unsigned short *mv, short side);
void GetGame(void);
void SaveGame(void);
void ListGame(void);
void Undo(void);
void ShowMessage(char *s);
void ShowSidetomove(void);
void PromptForMove(void);
void ShowCurrentMove(short pnt, short f, short t);
void ChangeAlphaWindow(void);
void ChangeBetaWindow(void);
void GiveHint(void);
void SelectLevel(void);
void ChangeSearchDepth(void);
void SetContempt(void);
void ChangeXwindow(void);

/* Main GNUChess Protos */
void main(int argc, char *argv[]);
int VerifyMove(char s[],short iop, unsigned short *mv);
void NewGame(void);
void algbr(short f,short t,short flag);
int SelectMove(short side, short iop);
void OpeningBook(void);
int search(short side,short ply,short depth,short alpha,short beta,unsigned short bstline[],short *rpt);
int evaluate(short side,short xside,short ply,short depth,short alpha,short beta);
int ProbeTTable(short side,short depth,short *alpha,short *beta,short *score);
void PutInTTable(short side,short score,short depth,short alpha,short beta,unsigned short mv);
void ZeroTTable(void);
void MoveList(short side, short ply);
void GenMoves(short ply,short sq,short side,short xside);
void LinkMove(short ply,short f,short t,short xside);
void CaptureList(short side,short xside,short ply);
int castle(short side,short kf,short kt,short iop);
void EnPassant(short xside,short f,short t,short iop);
void MakeMove(short side,struct leaf *node,short *tempb,short *tempc,short *tempsf,short *tempst);
void UnmakeMove(short side,struct leaf *node,short *tempb,short *tempc,short *tempsf,short *tempst);
void UpdateHashbd(short side,short piece,short f,short t);
void UpdatePieceList(short side,short sq,short iop);
void InitializeStats(void);
void pick(short p1, short p2);
void repetition(short *cnt);
int SqAtakd(short sq, short side);
void ataks(short side, short *a);
void ScorePosition(short side, short *score);
void ScoreLoneKing(short side,short *score);
int ScoreKPK(short side,short winner,short loser,short king1,short king2,short sq);
int ScoreKBNK(short winner,short king1,short king2);
int SqValue(short sq, short side);
void KingScan(short sq,short *s);
void BRscan(short sq,short *s,short *mob);
int trapped(short sq,short piece);
void ExaminePosition(void);
void UpdateWeights(void);
int distance(short a,short b);
void BlendBoard(short a[64],short b[64],short c[64]);
void CopyBoard(short a[64],short b[64]);
