// COLLECT.CXX - Collection class   T2             (C) Sturmer Hauss Corp 1991


#define INCL_TIER_TYPES           // data types like LONG, HWND, HANDLE


#include <tier1.hxx>
#include "collect.hxx"


//////////////////////////////////////////////////////////////////////////////
// Collection class
//////////////////////////////////////////////////////////////////////////////

Collection :: FAR Collection( void ) : ()
   {
      DWORD dwTemp;

   dwBlockSize = 0L;
   dwCount     = 0L;
   dwCurr      = 0L;
   bERR        = FALSE;

   if( SetBlockSize( 1L ) != 1L )
      {
      dwBlockSize = 0L;
      bERR        = TRUE;
      return;
      }
   
   }



Collection :: FAR ~Collection( void )
   {
   // do nothing.
   }



DWORD Collection :: FAR SetBlockSize( DWORD dwNewBlockSize )
   {
      DWORD dwTemp;

   if( dwNewBlockSize > dwBlockSize )
      {
      dwTemp = oObj.SetSize( dwNewBlockSize+1 );
      if( dwTemp == dwNewBlockSize+1 )
         {
         dwBlockSize = dwNewBlockSize;
         return( dwBlockSize );
         }
      else return( 0L );
      }

   dwBlockSize = dwNewBlockSize;
   return( dwBlockSize );
   }



BOOL Collection :: FAR Insert( void FAR *lpObject )
   {
      DWORD    dwTemp;

   if( bERR )
      return( FALSE );

   // Insert at the end of the list if not taken!
   if( oObj[dwCount] == (void FAR *)0L )
      {
      oObj.Set( dwCount, lpObject );
      dwCount++;

      // Change the size of the list if
      // dwCount is to exceed the current
      // size of the array.
      if( dwCount+1L > oObj.GetSize() )
         {
         dwTemp = oObj.SetSize( dwCount+dwBlockSize+1L );
         if( dwTemp != dwCount+dwBlockSize+1L )
            {
            return( FALSE );
            }
         }
      return( TRUE );
      }

   return( FALSE );
   }




BOOL Collection :: FAR Delete( void FAR *lpObject )
   {
      DWORD    i;
      BOOL     bFound = FALSE;

   if( bERR )
      return( FALSE );

   for( i = 0L; i < dwCount; i++ )
      {
      if( oObj[i] == lpObject && !bFound )
         {
         oObj.Set( i, (void FAR *)0L );
         dwCount--;
         bFound = TRUE;
         }

      // If the one we were looking for
      // was found then compress the list.
      // removing the null entry.
      if( bFound )
         {
         oObj.Set( i, oObj[i+1] );
         oObj.Set( i+1, (void FAR *)0L );
         }
      }

   if( bFound )
      return( TRUE );

   return( FALSE );
   }





DWORD Collection :: FAR Find( void FAR *lpObject )
   {
      DWORD    i;

   if( bERR )
      return( -1L );

   for( i = 0L; i < dwCount; i++ )
      {
      if( oObj[i] == lpObject )
         {
         return( i );
         }
      }

   return( -1L );
   }



void FAR *Collection :: FAR Get( DWORD dwIndex )
   {
   if( bERR )
      return( (void FAR *)0L );

   if( dwIndex < 0 || dwIndex >= dwCount )
      return( (void FAR *)0L );

   return( oObj[dwIndex] );
   }




int Collection :: FAR Compare( void FAR *lpObj1, void FAR *lpObj2 )
   {
   if( lpObj1 < lpObj2 )
      return( -1 );

   if( lpObj1 == lpObj2 )
      return( 0 );
   
   if( lpObj1 > lpObj2 )
      return( 1 );
   }




void FAR * Collection :: FAR Enum( void FAR *lpObject )
   {
   if( bERR )
      return( (void FAR *)0L );

   if( !lpObject )
      {
      dwCurr = 0L;
      return( oObj[dwCurr] );
      }

   if( lpObject != oObj[dwCurr] )
      dwCurr = Find( lpObject );

   if( (LONG)dwCurr == -1L )
      return( (void FAR *)0L );

   dwCurr++;
   if( dwCurr >= dwCount )
      return( (void FAR *)0L );

   return( oObj[dwCurr] );
   }
