// COLLECT.HXX - Collection class   T2             (C) Sturmer Hauss Corp 1990


#ifndef INCL_TIER_T1OBJECT
#define INCL_TIER_T1OBJECT
#include <tierobj.hxx>
#endif // INCL_TIER_T1OBJECT


#ifndef INCL_TIER_OBJECTARRAY
#define INCL_TIER_OBJECTARRAY
#include <objarr.hxx>
#endif // INCL_TIER_OBJECTARRAY



#ifndef CLASS_COLLECTION
#define CLASS_COLLECTION


//////////////////////////////////////////////////////////////////////////////
// Collection class
//////////////////////////////////////////////////////////////////////////////
class THUGE Collection : public T1Object
   {
   protected:
      ObjectArray       oObj;
      DWORD             dwCount;      // Number of elements
      DWORD             dwCurr;       // Used only for Enum pos.
      DWORD             dwBlockSize;  // Default block size for alloc.
      BOOL              bERR;

   public:
      FAR   Collection( void );
      FAR  ~Collection( void );

   DWORD       FAR   GetCount( void ) { return( dwCount); }

   // Set the default alloc size.  This is the number of
   // array elements that will be allocated or reallocated
   // when needed. (Default is 10L).  Will return 0L on 
   // failure. Will return dwNewBlockSize on success.
   DWORD       FAR   SetBlockSize( DWORD dwNewBlockSize );

   BOOL        FAR   Insert( void FAR *lpObject );
   BOOL        FAR   Delete( void FAR *lpObject );
   DWORD       FAR   Find( void FAR *lpObject ); 
   void FAR   *FAR   Get( DWORD dwIndex );

   // Compare should return less that 0 if lpObj1 < lpObj2,
   // 0 if they are equal, and greater than 0 if lpObj1 > lObj2.
   virtual
   int         FAR   Compare( void FAR *lpObj1, void FAR *lpObj2 );


   // On the first call to Enum, lpObject should be null to start at the top
   // of the collection.  After that just pass returned object back to Enum().
   // It will return null if no more found.
   void FAR *  FAR   Enum( void FAR *lpObject );
   };


#endif // CLASS_COLLECTION
