#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <alloc.h>
#include <mem.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>
#include <dos.h>

#include "fred.h"

extern int Debug;

/*  Allocate space for a string */
char *AllocateString(size_t size)
{
 char *ptr;

 ptr = malloc(size+1);
 if(ptr == NULL){
  fprintf(stderr, "ERROR: AllocateString out of memory\n");
  fprintf(stderr, "Asked for %d, only had %u\n", size, coreleft());
  exit(2);
 EndIf

 return ptr;
}

/*  Allocate space for a string from FAR */
char far *FarAllocateString(size_t size)
{
 char far *ptr;

 ptr = farmalloc(size+1);
 if(ptr == NULL){
  fprintf(stderr, "ERROR: FarAllocateString out of memory\n");
  fprintf(stderr, "Asked for %d, only had %ul\n", size, farcoreleft());
  exit(2);
 EndIf

 return ptr;
}

void DeallocateString(char *ptr)
{
 free(ptr);
}

#ifdef __COMPACT__ || __LARGE__
void DumpFidos(struct tofidos far *ptr)
#endif
#ifdef __SMALL__ || __MEDIUM__
void DumpFidos(struct tofidos *ptr)
#endif

{
 int i = 0;
 while(1){
  fprintf(stderr,"============== Record #%d =============\n", i++);
  fprintf(stderr, "uucpname = %s\n", ptr->uucpname);
  fprintf(stderr, "fidoname = %s\n", ptr->fidoname);
  fprintf(stderr, "count    = %d\n", ptr->count);
  if(ptr->next == NULL) break;
  ptr = ptr->next;
 EndWhile
}

int VerifyNode(char *string, struct nodeaddr *n)
{
 if(Debug)
  fprintf(stderr,"Verifying node: %s\n", string);

 if(sscanf(string, "%d:%d/%d.%d", &n->zone, &n->net, &n->node, &n->point) != 4){
  return -1;
 }
 return 0;
}

/**/
/* Generate a unique name from the system time with the specified .EXT */
/**/

char *UniqueName(char *ext)
{
 char tmp[33];
 static char uname[16];
 int i;

 ltoa(time(NULL), tmp, 10);

 /* Get the last 8 digits */
 if(strlen(tmp) < 8){
  fprintf(stderr, "ERROR: Your clock seems to be set VERY wrong!\n");
  fprintf(stderr, "       Set your clock and try it again.\n");
  exit(2);
 }

 strcpy(uname, &tmp[strlen(tmp) - 8]);
 strcat(uname, ".");
 strcat(uname, ext);

 return uname;
}

/**/
/* Open a file for read or write */
/**/
FILE *OpenFile(char *file, char *mode)
{
 FILE *fp;

 fp = fopen(file, mode);
 if(fp == NULL){
  fprintf(stderr, "ERROR: Can't open file %s.\n", file);
  exit(4);
 EndIf

 return fp;
}


