/* CTEXT(C) Copyright by Bill Buckels 1990


   creates a scrolling C program from an ascii file.
   line length is truncated to 78 characters.
   directly accepts wordstar documents.

   (strips high order bits)

   the scrolling program contains several video
   functions and can be used as basis for development
   of expanded versions.



*/

#include <stdio.h>

#define QUOTE   '\x22'
#define SLASH   '\x5c'
#define CTRLZ   '\x1a'
#define CRETURN '\x0d'
#define LFEED   '\x0A'
#define ENN     '\x6e'
#define PRIME   '\x25'
#define DELETE  '\x7f'


void write_tokenized_CODE(name1,name2)
char *name1, name2;
{

char c;
int row;
int highcount=66;
int margin;
int charcount=0;
long linecount=0;
unsigned long int count=0;
unsigned long int target;

FILE *f1, *f2;


if ( (f1 = fopen(name1, "r") ) == NULL)
        {
            perror("Sorry...");
            exit(0);
        }

 target = (filelength(fileno(f1))); /* size in bytes of input file */

 f2 = fopen(name2,"w");

      printf("Writing Header...\n");
      printf("      ->  ");
      printf("%s\n",strupr(name2));

fprintf(f2,"/*\n\n%s was created using CTEXT(C) V1.0.0\n",strupr(name2));
fprintf(f2,"(C) Copyright 1990 by Bill Buckels\n\n");
fprintf(f2,"CTEXT(C) converts ascii documents to executable C language Source Code\n");
fprintf(f2,"\n");
fprintf(f2,"This Source File Format was developed using Mix Power C Version 2.0\n");
fprintf(f2,"and Has also Been Tested Successfully\n");
fprintf(f2,"With Turbo C Version 2.01, Quick C Version 1.01 and Microsoft C Version 5.1\n");
fprintf(f2,"\n");
fprintf(f2,"%s is The C Source Code for the ",strupr(name2));
fprintf(f2,".Exe Version of %s\n\n",strupr(name1));
fprintf(f2,"\tThank you for using CTEXT(C).\n\n");
fprintf(f2,"\t Bill Buckels,  Starving Programmer\n");
fprintf(f2,"\t 982 Hector Avenue\n");
fprintf(f2,"\t Winnipeg, Manitoba, Canada R3M 2G6\n\n");
fprintf(f2,"\tPhone (204) 452-2815\n\*/\n\n");
fprintf(f2,"/* color definitions */\n");
fprintf(f2,"\n");
fprintf(f2,"#define BLACK     0\n");
fprintf(f2,"#define BLUE      1\n");
fprintf(f2,"#define GREEN     2\n");
fprintf(f2,"#define CYAN      3\n");
fprintf(f2,"#define RED       4\n");
fprintf(f2,"#define MAGENTA   5\n");
fprintf(f2,"#define BROWN     6\n");
fprintf(f2,"#define WHITE     7\n");
fprintf(f2,"#define GRAY      8\n");
fprintf(f2,"#define LBLUE     9\n");
fprintf(f2,"#define LGREEN    10\n");
fprintf(f2,"#define LCYAN     11\n");
fprintf(f2,"#define LRED      12\n");
fprintf(f2,"#define LMAGENTA  13\n");
fprintf(f2,"#define YELLOW    14\n");
fprintf(f2,"#define BWHITE    15\n");
fprintf(f2,"\n");
fprintf(f2,"#define ESCKEY     '\\x1b' /* character generated by the Esc key            */\n");
fprintf(f2,"#define FUNCKEY    '\\x00' /* first character generated by function keys    */\n");
fprintf(f2,"#define UPARROW    'H'    /* second character generated by up-arrow key    */\n");
fprintf(f2,"#define DOWNARROW  'P'    /* second character generated by down-arrow key  */\n");
fprintf(f2,"#define PGUP       'I'    /* second character generated by page up key     */\n");
fprintf(f2,"#define PGDOWN     'Q'    /* second character generated by page down key   */\n");
fprintf(f2,"\n");
fprintf(f2,"#define BLANK     32\n");
fprintf(f2,"#define FAT       219\n");
fprintf(f2,"#define SINGLE    1\n");
fprintf(f2,"#define DOUBLE    2\n");
fprintf(f2,"\n");
fprintf(f2,"#define CGA 3\n");
fprintf(f2,"#define HERCULES 99\n");
fprintf(f2,"int ADAPTER = CGA;\n");
fprintf(f2,"\n");
fprintf(f2,"#include <dos.h>\n");
fprintf(f2,"\n");
fprintf(f2,"#undef MK_FP\n");
fprintf(f2,"#undef poke\n");
fprintf(f2,"\n");
fprintf(f2,"/* undefine the above if they exist      */\n");
fprintf(f2,"/* all compilers start on equal footing  */\n");
fprintf(f2,"\n");
fprintf(f2,"/* macros to poke into memory */\n");
fprintf(f2,"/* dynamically cast a far pointer from segment and offset info */\n");
fprintf(f2,"#define MK_FP(seg,off) ((char far *)(((long)(seg) << 16) | (off)))\n");
fprintf(f2,"/* write an integer at a memory location */\n");
fprintf(f2,"#define poke(a,b,c) (*((int  far*)MK_FP((a),(b))) = (int)(c))\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"unsigned int biosequip()\n");
fprintf(f2,"{\n");
fprintf(f2,"    union REGS inregs,outregs;\n");
fprintf(f2,"\n");
fprintf(f2,"    int86(0x11,&inregs,&outregs); /* get equipment list from the bios */\n");
fprintf(f2,"    return outregs.x.ax;\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"void cursoroff(void)\n");
fprintf(f2,"{\n");
fprintf(f2,"   union REGS regs;\n");
fprintf(f2,"\n");
fprintf(f2,"   regs.h.ah = 0x01;\n");
fprintf(f2,"   regs.x.cx = 0x2000;\n");
fprintf(f2,"   int86(0x10,&regs,&regs);\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"void cursoron(void)\n");
fprintf(f2,"{\n");
fprintf(f2,"   union REGS regs;\n");
fprintf(f2,"\n");
fprintf(f2,"   regs.h.ah = 0x01;\n");
fprintf(f2,"   regs.x.cx = 0x0607;\n");
fprintf(f2,"   int86(0x10,&regs,&regs);\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"void cls(int BACK,int FRONT)\n");
fprintf(f2,"{\n");
fprintf(f2,"	union REGS reg;\n");
fprintf(f2,"\n");
fprintf(f2,"	reg.h.ah = 6;\n");
fprintf(f2,"	reg.h.al = 0;\n");
fprintf(f2,"	reg.h.ch = 0;\n");
fprintf(f2,"	reg.h.cl = 0;\n");
fprintf(f2,"	reg.h.dh = 24;\n");
fprintf(f2,"	reg.h.dl = 79;\n");
fprintf(f2,"    reg.h.bh = (BACK << 4) + FRONT;\n");
fprintf(f2,"	int86(0x10, &reg, &reg);\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"int colorset(bground, palette)\n");
fprintf(f2,"unsigned char bground, palette;\n");
fprintf(f2,"{\n");
fprintf(f2,"    union REGS rin,rout;\n");
fprintf(f2,"    \n");
fprintf(f2,"    if(ADAPTER==HERCULES) return 0;\n");
fprintf(f2,"    rin.h.ah = 11;\n");
fprintf(f2,"    rin.h.bh = 0;\n");
fprintf(f2,"    rin.h.bl = bground;\n");
fprintf(f2,"    int86(0x10,&rin,&rout);\n");
fprintf(f2,"    rin.h.bh = 1;\n");
fprintf(f2,"    rin.h.bl = palette;\n");
fprintf(f2,"    int86(0x10,&rin,&rout);\n");
fprintf(f2,"    return 0;\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"void DMC(int Row, int Column, unsigned BYTE, int BACK, int FRONT, int QUANT)\n");
fprintf(f2,"{\n");
fprintf(f2,"    /*  DMA replacement for writechs function */\n");
fprintf(f2,"\n");
fprintf(f2,"    unsigned segment= 0xB000, offset;\n");
fprintf(f2,"    int One_Too_Many = (QUANT+1);\n");
fprintf(f2,"    int i, Attribute;\n");
fprintf(f2,"\n");
fprintf(f2,"    Attribute = (BACK << 4) + FRONT;\n");
fprintf(f2,"\n");
fprintf(f2,"    if(ADAPTER!=HERCULES)segment = 0xB800;    /* CGA or Equivalent */\n");
fprintf(f2,"    offset = 160 * Row + 2 * Column ;\n");
fprintf(f2,"    for (i=1; i< One_Too_Many ; i++){\n");
fprintf(f2,"        poke(segment,offset, BYTE|Attribute<<8);\n");
fprintf(f2,"        offset+=2;\n");
fprintf(f2,"        }\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"void DMM(char *String, int Row, int Column, int BACK, int FRONT)\n");
fprintf(f2,"{\n");
fprintf(f2,"    /*  DMA replacement for puts\n");
fprintf(f2,"        centre justified string    */\n");
fprintf(f2,"\n");
fprintf(f2,"    unsigned Character, segment=0xB000, offset;\n");
fprintf(f2,"    int Attribute;\n");
fprintf(f2,"\n");
fprintf(f2,"    Attribute = (BACK << 4) + FRONT;\n");
fprintf(f2,"\n");
fprintf(f2,"    Column =   ((Column+1)-(.5*(strlen(String))));\n");
fprintf(f2,"\n");
fprintf(f2,"    if(ADAPTER != HERCULES)segment = 0xB800;    /* CGA or Equivalent */\n");
fprintf(f2,"    offset = 160 * Row + 2 * Column ;\n");
fprintf(f2,"    while ((Character = *String++)!=0){\n");
fprintf(f2,"        if(Character!='\\n'){\n");
fprintf(f2,"        poke(segment,offset,Character|Attribute<<8);\n");
fprintf(f2,"        offset+=2;\n");
fprintf(f2,"        }\n");
fprintf(f2,"        }\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"void DML(char *String, int Row, int Column, int BACK, int FRONT)\n");
fprintf(f2,"{\n");
fprintf(f2,"    /*  DMA replacement for puts\n");
fprintf(f2,"        left justified string    */\n");
fprintf(f2,"    unsigned Character, segment=0xB000, offset;\n");
fprintf(f2,"    int Attribute;\n");
fprintf(f2,"\n");
fprintf(f2,"    Attribute = (BACK << 4) + FRONT;\n");
fprintf(f2,"\n");
fprintf(f2,"    if(ADAPTER!=HERCULES)segment = 0xB800; /* CGA or Equivalent */\n");
fprintf(f2,"    offset = 160 * Row + 2 * Column ;\n");
fprintf(f2,"    while ((Character = *String++)!=0){\n");
fprintf(f2,"        if(Character!='\\n'){\n");
fprintf(f2,"        poke(segment,offset, Character|Attribute<<8);\n");
fprintf(f2,"        offset +=2;\n");
fprintf(f2,"        }\n");
fprintf(f2,"    }\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"void PAINT(int *cor,int bk,int fore,unsigned char Character)\n");
fprintf(f2,"{\n");
fprintf(f2,"   int trow=cor[0],tcol=cor[1],brow=cor[2],bcol=cor[3];\n");
fprintf(f2,"   int index,linelength = ((bcol+1) - (tcol));\n");
fprintf(f2,"   for (index = (trow); index < brow+1; index++)\n");
fprintf(f2,"   DMC(index,tcol,Character,bk,fore,linelength);\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"void BORDERBOX(int *cor,int bk,int fore,unsigned char BRDR)\n");
fprintf(f2,"{\n");
fprintf(f2,"\n");
fprintf(f2,"int trow=cor[0],tcol=cor[1],brow=cor[2],bcol=cor[3];\n");
fprintf(f2,"    /* draws an outline only using a specified border character */\n");
fprintf(f2,"int index;\n");
fprintf(f2,"int homecol = (tcol+1);\n");
fprintf(f2,"int linelength = ((bcol) - (tcol+1));\n");
fprintf(f2,"\n");
fprintf(f2,"int TLcorner,TRcorner,BLcorner,BRcorner,HORT,VERT;\n");
fprintf(f2,"\n");
fprintf(f2,"          switch(BRDR){\n");
fprintf(f2,"               case DOUBLE: {\n");
fprintf(f2,"                            TLcorner = 201;\n");
fprintf(f2,"                            TRcorner = 187;\n");
fprintf(f2,"                            BLcorner = 200;\n");
fprintf(f2,"                            BRcorner = 188;\n");
fprintf(f2,"                            HORT = 205;\n");
fprintf(f2,"                            VERT = 186;\n");
fprintf(f2,"                            break;\n");
fprintf(f2,"                        }\n");
fprintf(f2,"               case SINGLE: {\n");
fprintf(f2,"                            TLcorner = 218;\n");
fprintf(f2,"                            TRcorner = 191;\n");
fprintf(f2,"                            BLcorner = 192;\n");
fprintf(f2,"                            BRcorner = 217;\n");
fprintf(f2,"                            HORT = 196;\n");
fprintf(f2,"                            VERT = 179;\n");
fprintf(f2,"                            break;\n");
fprintf(f2,"                        }\n");
fprintf(f2,"               default:    {\n");
fprintf(f2,"                            TLcorner = BRDR;\n");
fprintf(f2,"                            TRcorner = BRDR;\n");
fprintf(f2,"                            BLcorner = BRDR;\n");
fprintf(f2,"                            BRcorner = BRDR;\n");
fprintf(f2,"                            HORT = BRDR;\n");
fprintf(f2,"                            VERT = BRDR;\n");
fprintf(f2,"                        }\n");
fprintf(f2,"            }\n");
fprintf(f2,"   DMC(trow,tcol,TLcorner,bk,fore,1);         /* top */\n");
fprintf(f2,"   DMC(trow,homecol,HORT,bk,fore,linelength);\n");
fprintf(f2,"   DMC(trow,bcol,TRcorner,bk,fore,1);\n");
fprintf(f2,"   for (index = (trow+1); index < brow; index++){\n");
fprintf(f2,"       DMC(index,tcol,VERT,bk,fore,1);\n");
fprintf(f2,"       DMC(index,bcol,VERT,bk,fore,1);\n");
fprintf(f2,"       }\n");
fprintf(f2,"   DMC(brow,tcol,BLcorner,bk,fore,1);\n");
fprintf(f2,"   DMC(brow,homecol,HORT,bk,fore,linelength);\n");
fprintf(f2,"   DMC(brow,bcol,BRcorner,bk,fore,1);        /* bottom */\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"void getadaptertype(void)\n");
fprintf(f2,"{\n");
fprintf(f2,"    if(((biosequip() >>4) &3) <3)ADAPTER=CGA;\n");
fprintf(f2,"    else ADAPTER=HERCULES;\n");
fprintf(f2,"\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"char *WINTALK[]=\n{\n/* data statements */\n\n");
fprintf(f2,"/*0   */\"");

/* read in the text file */


printf("Converting...\n");
printf("      ->  ");
printf("%s",strupr(name1));
row = cursrow();

      do{  /* get a character and strip off the high bit */
           c = fgetc(f1)&0x7f;
           if (c=='\n'){/* start a new line */
                        linecount++;
                        if (charcount>=highcount){
                            highcount=charcount;
                            }
                        charcount=0;
                        fprintf(f2,"\",\n");
                        fprintf(f2,"/*%-4ld*/\"",linecount);
                        poscurs(row,0);
                        printf("%5ld",linecount);
                        }
           else { /* formatted output */
                  switch(c)
                            {
                            case QUOTE :  {
                                           if (charcount<78)
                                           {
                                           fprintf(f2,"%c%c",SLASH,QUOTE);
                                           charcount++;
                                           }
                                           break;
                                        }
                            case SLASH :  {
                                           if (charcount<78)
                                           {
                                           fprintf(f2,"%c%c",SLASH,SLASH);
                                           charcount++;
                                           }
                                           break;
                                        }
                            case PRIME :  {
                                           if (charcount<78)
                                           {
                                           fprintf(f2,"%c%c",PRIME,PRIME);
                                           charcount++;
                                           }
                                           break;
                                          }
                            case CRETURN :{
                                           break;
                                          }
                            case LFEED   : {
                                            break;
                                            }

                             case CTRLZ  : {
                                           break;
                                           }

                             case DELETE :  {
                                            break;
                                          }
                             default     :  {
                                          if(charcount<78){
                                          fputc(c,f2);
                                          charcount++;
                                              }
                                          }
                                    }
                              }
                } while (count++ != target);
                         if (charcount>=highcount){
                            highcount=charcount;
                            }
                                  /* shift the text to the center */
                           margin = 39-(highcount/2);
                           linecount++;
fprintf(f2,"\",\n");
fprintf(f2,"/*%-4ld*/",linecount);
fprintf(f2,"\"\"\n");
fprintf(f2,"/*       End of Data       */\n");
fprintf(f2,"};\n");

poscurs(row,0);
printf("%5ld Lines Converted.        \n",linecount);

/* footer information */

printf("Writing Footer...\n");
printf("      ->  ");
printf("%s",strupr(name2));

fprintf(f2,"\n");
fprintf(f2,"int UPPERLIMIT=%ld;  /* no of array elements */\n",linecount);
fprintf(f2,"int Ls=%d;            /* left side of document */\n",margin);
fprintf(f2,"\n");
fprintf(f2,"void windowtalk(void)\n");
fprintf(f2,"{\n");
fprintf(f2,"\n");
fprintf(f2,"int index = 0;\n");
fprintf(f2,"int numbers;\n");
fprintf(f2,"int cor[4];\n");
fprintf(f2,"\n");
fprintf(f2,"char c;\n");
fprintf(f2,"\n");
fprintf(f2,"      cor[0]=0;\n");
fprintf(f2,"      cor[1]=0;\n");
fprintf(f2,"      cor[2]=24;\n");
fprintf(f2,"      cor[3]=79;\n");
fprintf(f2,"\n");
fprintf(f2,"      BORDERBOX(cor,BLACK,CYAN,SINGLE);\n");
fprintf(f2,"      DMC(0,0,2,BROWN,BLACK,80);\n");
fprintf(f2,"      DMC(24,0,2,BROWN,BLACK,80);\n");
fprintf(f2,"      DMC(1,0,2,BLACK,RED,80);\n");
fprintf(f2,"      DMC(23,0,2,BLACK,RED,80);\n");
fprintf(f2,"DMM(\" What Goes Around Comes Around \",0,39,BLACK,YELLOW);\n");
fprintf(f2,"DMM(\" Use Arrow or Page Up and Down To View...  ESC to Exit \",24,39,0,15);\n");
fprintf(f2,"\n");
fprintf(f2,"      cor[0]=2;\n");
fprintf(f2,"      cor[1]=1;\n");
fprintf(f2,"      cor[2]=22;\n");
fprintf(f2,"      cor[3]=78;\n");
fprintf(f2,"\n");
fprintf(f2,"      PAINT(cor,BLACK,BWHITE,BLANK);\n");
fprintf(f2,"\n");
fprintf(f2,"      for(numbers = 2; numbers<23; numbers++){\n");
fprintf(f2,"                 DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);\n");
fprintf(f2,"                 index++ ;\n");
fprintf(f2,"                 }\n");
fprintf(f2,"\n");
fprintf(f2,"    while ((c=getch())!= ESCKEY)\n");
fprintf(f2,"        {\n");
fprintf(f2,"\n");
fprintf(f2,"        if ((c) == FUNCKEY)\n");
fprintf(f2,"            {\n");
fprintf(f2,"            c = getch(); /* get second character of key */\n");
fprintf(f2,"            switch (c) {\n");
fprintf(f2,"\n");
fprintf(f2,"            case DOWNARROW:{\n");
fprintf(f2,"                             if (index<UPPERLIMIT){\n");
fprintf(f2,"                                      index++;\n");
fprintf(f2,"                                      index=index-21;\n");
fprintf(f2,"                                      if(index<0){\n");
fprintf(f2,"                                         index =0;\n");
fprintf(f2,"                                         }\n");
fprintf(f2,"                           for(numbers = 2; numbers<23; numbers++){\n");
fprintf(f2,"                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);\n");
fprintf(f2,"                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);\n");
fprintf(f2,"                           index++ ;\n");
fprintf(f2,"                           }\n");
fprintf(f2,"                        }\n");
fprintf(f2,"                        break;\n");
fprintf(f2,"                        }\n");
fprintf(f2,"            case UPARROW:{ index--;\n");
fprintf(f2,"                             if (index<UPPERLIMIT){\n");
fprintf(f2,"                                      index=index-21;\n");
fprintf(f2,"                                      if(index<0){\n");
fprintf(f2,"                                         index =0;\n");
fprintf(f2,"                                         }\n");
fprintf(f2,"                           for(numbers = 2; numbers<23; numbers++){\n");
fprintf(f2,"                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);\n");
fprintf(f2,"                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);\n");
fprintf(f2,"                           index++ ;\n");
fprintf(f2,"                           }\n");
fprintf(f2,"                        }\n");
fprintf(f2,"                        break;\n");
fprintf(f2,"                        }\n");
fprintf(f2,"            case PGDOWN: {\n");
fprintf(f2,"                          if (index >= (UPPERLIMIT-21)){\n");
fprintf(f2,"                                      index=UPPERLIMIT-21;\n");
fprintf(f2,"                                     }\n");
fprintf(f2,"                          if(index<0){\n");
fprintf(f2,"                                      index =0;\n");
fprintf(f2,"                                     }\n");
fprintf(f2,"                          for(numbers = 2; numbers<23; numbers++){\n");
fprintf(f2,"                               DMC(numbers,1,BLANK,BLACK,BWHITE,78);\n");
fprintf(f2,"                               DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);\n");
fprintf(f2,"                               index++ ;\n");
fprintf(f2,"                             }\n");
fprintf(f2,"                        break;\n");
fprintf(f2,"                        }\n");
fprintf(f2,"            case PGUP:  {      index=index-42;\n");
fprintf(f2,"                               if(index<0){\n");
fprintf(f2,"                                         index =0;\n");
fprintf(f2,"                                         }\n");
fprintf(f2,"                           for(numbers = 2; numbers<23; numbers++){\n");
fprintf(f2,"                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);\n");
fprintf(f2,"                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);\n");
fprintf(f2,"                           index++ ;\n");
fprintf(f2,"                           }\n");
fprintf(f2,"                        break;\n");
fprintf(f2,"                        }\n");
fprintf(f2,"                   }\n");
fprintf(f2,"              }\n");
fprintf(f2,"        }\n");
fprintf(f2,"\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"main()\n");
fprintf(f2,"{\n");
fprintf(f2,"    getadaptertype();\n");
fprintf(f2,"    cls(0,14);\n");
fprintf(f2,"    colorset(1,0);\n");
fprintf(f2,"    cursoroff();\n");
fprintf(f2,"    windowtalk();\n");
fprintf(f2,"    cls(0,7);\n");
fprintf(f2," DMC(0,0,FAT,BLACK,RED,80);\n");
fprintf(f2," DMM(\"An object in motion will be heading in the wrong direction.\",0,39,4,14);\n");
fprintf(f2," cursoron();\n");
fprintf(f2," exit(0);\n");
fprintf(f2,"}\n");
fprintf(f2,"\n");
fprintf(f2,"\n");
fprintf(f2,"\n");



          printf("\n%s Created...\n",strupr(name2));
          printf("      Thanks For Using CTEXT(C)");
          fclose(f2);    fclose(f1);


}


main(int argc, char **argv)
{
    char file1[66], file2[66];
    int row;

    printf("CTEXT(C) Version 1.0.0\n");
    printf("(C) Copyright 1990 by Bill Buckels\n");

    /* dedicated to speeding up the tedious stuff */

   switch(argc)
   {
    case 3: strcpy(file1,argv[1]);
            strcpy(file2,argv[2]);
            break;
    default:
    /* User Input Function. */

     printf("        Source -> ");
     gets(file1);
     row  = cursrow();
     printf("        Target -> ");
     while (strcmp(gets(file2),file1) == NULL){
           poscurs(row,0);
           printf("ReEnter Target ->                ");
           poscurs(row,18);
           }
     poscurs((row-1),0);
     printf("                                 \n");
     printf("                                 ");
     poscurs((row-1),0);
     break;
     }
     write_tokenized_CODE(file1,file2);
     exit(0);
}


