// DEFINES.H - Multi-Edit MDI Sample Program defines and constants


// Icon defines
#define  IDI_MEFRAME                50
#define  IDI_MECHILD                51

// Bitmap defines
#define  IDB_TIERABOUT              53


// Menu positions where each childs
// title will be displayed.
#define  MENU_SHORT_POS             3
#define  MENU_LONG_POS              5

// Menu position (on the File menu) where
// appended file names from prev sessions 
// will be added.
#define MENU_AFTER_ABOUT           14


// Menu defines
#define  ID_MAINMENU                5
#define  ID_MAINMENU2               6


#define  IDM_EDITUNDO               100
#define  IDM_EDITCUT                101
#define  IDM_EDITCOPY               102
#define  IDM_EDITPASTE              103
#define  IDM_EDITCLEAR              104
#define  IDM_EDITSELECT             105
#define  IDM_EDITWRAP               106
#define  IDM_EDITTIME               107

#define  IDM_SEARCHFIND             110
#define  IDM_SEARCHNEXT             111
#define  IDM_SEARCHPREV             112


#define  IDM_WINDOWTILE             1520
#define  IDM_WINDOWCASCADE          1521
#define  IDM_WINDOWICONS            1522
#define  IDM_WINDOWCLOSEALL         1523
#define  IDM_WINDOWCHILD            1524

#define  IDM_FONTVARIABLE           130
#define  IDM_FONTFIXED              131

#define  IDM_FILENEW                230
#define  IDM_FILEOPEN               231
#define  IDM_FILESAVE               232
#define  IDM_FILESAVEAS             233
#define  IDM_FILEPRINT              234
#define  IDM_FILESETUP              235
#define  IDM_FILEMENU               236
#define  IDM_FILEEXIT               237
#define  IDM_ABOUT                  238
#define  IDM_PREVFILES              239  // This is here to give a start point.
                                         // for appended file names.


#define  IDM_HELPHELP               140
#define  IDM_HELPSPOT               141

#define  IDM_PARAMS                 150


// Accelerators
#define  ID_MEFRAME_ACCEL           170


// Dialogs
#define  IDD_FILEOPEN               200
#define  IDD_FILENAME               201
#define  IDD_FILES                  202
#define  IDD_PATH                   203
#define  IDD_DIRS                   204

// Dialog IDs
#define  IDD_ABOUT                  300

#define  IDD_SAVEAS                 500
#define  IDD_FILE                   500
#define  IDD_DIR                    501
#define  IDD_DIRLIST                502
         
#define  IDD_PRINT                  600
#define  IDD_PRINTDEVICE            601
#define  IDD_PRINTPORT              602
#define  IDD_PRINTTITLE             603
         
#define  IDD_FONT                   700
#define  IDD_FACES                  701
#define  IDD_SIZES                  702
#define  IDD_BOLD                   703
#define  IDD_ITALIC                 704
#define  IDD_FONTTITLE              705

#define  IDD_SEARCH                 710
#define  IDD_SEARCHTEXT             711
#define  IDD_CASE                   712
#define  IDD_DIRFORWARD             713
#define  IDD_DIRBACKWARD            714

#define  IDD_PARAMS                 750
#define  IDD_EXTS                   751
#define  IDD_FIXED                  752
#define  IDD_SAVEPOS                753
#define  IDD_SAVEPARAMS             754

         
         
// String Table Constants
#define  IDS_CANTOPEN               1
#define  IDS_CANTREAD               2
#define  IDS_CANTCREATE             3
#define  IDS_CANTWRITE              4
#define  IDS_ADDEXT                 5
#define  IDS_ILLFNM                 6
#define  IDS_CLOSESAVE              7
#define  IDS_CANTFIND               8
#define  IDS_HELPNOTAVAIL           9
#define  IDS_CLIENTTITLE            10
#define  IDS_UNTITLED               11
#define  IDS_PRINTJOB               12
#define  IDS_PRINTERROR             13
#define  IDS_APPNAME                14
#define  IDS_ERRMAINWIN             15
#define  IDS_ERRCLIENTWIN           16
#define  IDS_ERRPRINTER             17
#define  IDS_ERRPRNALLOC            18
#define  IDS_CANTLOAD               19
#define  IDS_CLOSESAVEUNTIT         20
#define  IDS_ERRLOWMEM              21
#define  IDS_ERR32KEDIT             22
#define  IDS_ERRMSGQUEUE            23
#define  IDS_INIFILE                24
#define  IDS_INIMODIFIED            25




// Message a child uses to tell it's frame it has been destroyed
#define  WM_CHILDKILLED             WM_USER+100

// Message a child uses to tell it's frame to specify fixed or
// variable font to subsequent children. (wParam set to TRUE/FALSE)
#define  WM_USEFIXEDFONT            WM_USER+101


// Message a child uses to tell it's frame that the apps INI has been
// edited and it needs to update its settings.
#define  WM_INICHANGED              WM_USER+102


// Message a child uses to tell it's frame that the it has saved a
// file under a new name.  The frame will add this to its file list
// of previously edited files.
#define  WM_PUSHFILE                WM_USER+103


// Window types used with the WM_CHILDKILLED message (wParam)
#define  MECHILDWIN                 1


// ID used by all edits
#define  ID_EDIT                    1000 


// Application limits
#define  DEF_MSGLEN                 256
#define  DEF_APPNAMELEN             16


// Used as a flag if me's screen size is saved as iconic
#define  ICONIC                      2  

