/*	DEMOMENU.C


 This C Language Light Bar Menu Source Code was Produced
 Using The CPOP(C) Light Bar Menu C Source Code Generator
 Copyright by Bill Buckels 1989, 1990

This Source File Format was developed using Mix Power C Version 2.0
and Has also Been Tested With Varying Degrees of Success
With Turbo C Version 2.01, Quick C Version 1.01 and Microsoft C Version 5.1

Fix-ups required for use with Turbo.(AHEM!)

Turbo C Has a Problem With The Dos Services Component,
and does Garbage although the routine still shells Command.
This is a problem that is not shared with the other C's,
nor is the fact that malloc.h is not part of Turbo's Stable.
Since Turbo C is the "ODD MAN OUT" on these, I have decided to leave
Things The Way they are rather than diddle with Conditionals.

 This Code was developed from the PopUp Menu Template
 Supplied with  Mix Power C.


 Bill Buckels, Starving Programmer
 982 Hector Avenue
 Winnipeg, Manitoba, Canada R3M 2G6

 (204) 452-2815

*/

#include <stdio.h>
#include <bios.h>
#include <dos.h>
#include <malloc.h>
#include <stdlib.h>  /* declares system function  */
#include <string.h>  /* declares strlen function  */


#define CRTWIDTH   80     /* width of the CRT  (in characters) */
#define CRTHEIGHT  25     /* height of the CRT (in characters) */
#define ENTERKEY   '\x0d' /* character generated by the Enter key */
#define ESCKEY     '\x1b' /* character generated by the Esc key */
#define FUNCKEY    '\x00' /* first character generated by function keys */
#define HOMEKEY    'G'    /* second character generated by Home key */
#define ENDKEY     'O'    /* second character generated by End key */
#define UPARROW    'H'    /* second character generated by up-arrow key */
#define DOWNARROW  'P'    /* second character generated by down-arrow key */
#define MA         0xb000 /* start of video memory for Monochrome Adapter */
#define CGA        0xb800 /* start of video memory for Color Graphics Adapter */

struct video_bytes {
    unsigned char  ch;    /* character value of video word */
    unsigned char  attr;  /* attribute value of video word */
};

union video_word {
    struct video_bytes byte;
    int word;
};


#undef MK_FP
#undef poke
#undef peek

/* undefine the above if they exist      */
/* all compilers start on equal footing  */

/* macros to poke into memory */
/* dynamically cast a far pointer from segment and offset info */
#define MK_FP(seg,off) ((char far *)(((long)(seg) << 16) | (off)))
/* write an integer at a memory location */
#define poke(a,b,c) (*((int  far*)MK_FP((a),(b))) = (int)(c))
/* read an integer */
#define peek(a,b)   (*((int  far*)MK_FP((a),(b))))

unsigned int bionicequip()
{
   union REGS inregs, outregs;

   int86(0x11,&inregs, &outregs);
   return outregs.x.ax;

}

void cls(int BACK,int FRONT)
{
    union REGS reg;

    reg.h.ah = 6;
    reg.h.al = 0;
    reg.h.ch = 0;
    reg.h.cl = 0;
    reg.h.dh = 24;
    reg.h.dl = 79;
    reg.h.bh = (BACK << 4) + FRONT;
    int86(0x10, &reg, &reg);
}

int crow()
{
    union REGS inregs,outregs;
    inregs.h.ah = 3;
    inregs.h.bh = 0;
    int86(0x10, &inregs,&outregs);
    return outregs.h.dh;
}

void pcurs(row, col)
   int row,col;
{
   union REGS reg;

   reg.h.ah = 2;
   reg.h.bh = 0;
   reg.h.dh = row;
   reg.h.dl = col;
   int86(0x10, &reg,&reg);
}


int popup(int row, int col, char *menu[])
{
    /* display a popup menu (menu[0] .. menu[n])
       within a window located at the screen position
       specified by row and col.  Use the up-arrow and
       down-arrow keys to position the cursor.  Press
       the enter key to select the option under the
       cursor.

       Returns: 0 if menu[0] selected
                1 if menu[1] selected
                    ...
               -1 if Esc key pressed                */

    int c, i, j, length, address, segment, offset, offset2;
    char NORMAL = '\x07' ;/* attribute for normal video */
    char REVERSE = '\x70' ;/* attribute for reverse video */
    char INTENSE = '\x0e' ;/* attribute for high intensity video */
    int currow, maxrow, minrow;
    int choice, bwidth, bheight, width = 0, height = 0;
    int *buffer, *bufptr;
    char *strptr, *strptr2, *(*hotkey)[];
    union video_word video;

    /* set video segment for Monochrome or Color Graphics Adaptor */
    if ((bionicequip() & 0x30) == 0x30) segment = MA;
    else { segment = CGA;
           NORMAL = '\x17' ;/* attribute for normal video */
           REVERSE = '\x02' ;/* attribute for reverse video */
           INTENSE = '\x1e' ;/* attribute for high intensity video */
           }

    /* calculate address of row and col */
    address = (row * CRTWIDTH * 2) + (col * 2);

    /* calculate width and height of menu window */
    for (i=0; menu[i] != NULL; i++) {
        length = strlen(menu[i]);
        if (length > width) width = length;
        height++;
    } /* width and height must be greater than 0 */
    if (width == 0 || height == 0) {
        printf("\n*** popup function: invalid menu argument ***\n");
        exit(0);
    }

    /* allow for a border around the text */
    bwidth = width + 2;
    bheight = height + 2;
    /* eliminate rightmost and/or bottom portion of window if too large */
    if (bwidth > CRTWIDTH - col) {
        bwidth = CRTWIDTH - col;
        width = bwidth - 2;
    }
    if (bheight > CRTHEIGHT - row) {
        bheight = CRTHEIGHT - row;
        height = bheight - 2;
    }
    /* window must be at least 3 x 3 */
    if ((bwidth < 3) || (bheight < 3)) {
        printf("\n*** popup function: invalid row or col argument ***\n");
        exit(0);
    }


    /* allocate buffer for saving area of screen beneath popup
       and array of hotkey characters */
    buffer = calloc(bwidth * bheight, 2);
    hotkey = calloc(height, sizeof(char *));
    if ((buffer == NULL) || hotkey == NULL) {
        printf("\n*** popup function: out of memory ***\n");
        exit(0);
    }

    /* make the first uppercase character in each line of
        the menu a hotkey */
    for (i=0; i < height; i++)
        (*hotkey)[i] = strpbrk(menu[i], "ABCDEFGHIJKLMNOPQRSTUVWXYZ");

    /* save area of screen that will be modified */
    currow = address;
    bufptr = buffer;
    for (i = 0; i < bheight; i++) {
        offset = currow;
        for (j = 0; j < bwidth; j++) {
            *bufptr++ = peek(segment, offset);
            offset += 2;
        }
        currow += (CRTWIDTH * 2);
    }

    /* draw menu outline */
    video.byte.attr = INTENSE;
    offset = address;
    video.byte.ch = '\xc9';                 /* upper left corner */
    poke(segment, offset, video.word);
    offset += (bwidth - 1) * 2;
    video.byte.ch = '\xbb';                 /* upper right corner */
    poke(segment, offset, video.word);
    offset = address + (bheight - 1) * CRTWIDTH * 2;
    video.byte.ch = '\xc8';                 /* lower left corner */
    poke(segment, offset, video.word);
    offset += (bwidth - 1) * 2;
    video.byte.ch = '\xbc';                 /* lower right corner */
    poke(segment, offset, video.word);
    offset = address + 2;
    offset2 = offset + (bheight - 1) * CRTWIDTH * 2;
    video.byte.ch = '\xcd';                 /* horizontal lines */
    for (i = 0; i < width; i++) {
        poke(segment, offset, video.word);
        offset += 2;
        poke(segment, offset2, video.word);
        offset2 += 2;
    }
    offset = address + CRTWIDTH * 2;
    offset2 = offset + (bwidth - 1) * 2;
    video.byte.ch = '\xba';                 /* vertical lines */
    for (i = 0; i < height; i++) {
        poke(segment, offset, video.word);
        offset += CRTWIDTH * 2;
        poke(segment, offset2, video.word);
        offset2 += CRTWIDTH * 2;
    }

    /* fill in menu text */
    minrow = address + (CRTWIDTH * 2) + 2;
    currow = minrow;
    video.byte.attr = REVERSE;
    for (i = 0; i < height; i++) {
        strptr = menu[i];
        offset = currow;
        for (j = 0; j < width; j++) {
            if (*strptr == '\0') video.byte.ch = ' ';
            else {
                if (i != 0 && strptr == (*hotkey)[i])
                    video.byte.attr = INTENSE;
                video.byte.ch = *strptr++;
            }
            poke(segment, offset, video.word);
            offset += 2;
            if (video.byte.attr == INTENSE)
                video.byte.attr = NORMAL;
        }
        video.byte.attr = NORMAL;
        maxrow = currow;
        currow += (CRTWIDTH * 2);
    }

    /* get menu choice */
    currow = minrow;
    choice = 0;
    c = getch();
    while ((c != ENTERKEY) && (c != ESCKEY)) {
        if (c == FUNCKEY) {
            c = getch(); /* get second character of key */
            j = choice;
            offset = currow;
            strptr = menu[choice];
            switch (c) {

                case HOMEKEY:
                    currow = minrow;
                    choice = 0;
                    break;

                case ENDKEY:
                    currow = maxrow;
                    choice = height - 1;
                    break;

                case DOWNARROW:
                    if (currow == maxrow) {
                        currow = minrow;
                        choice = 0;
                    }
                    else {
                        currow += CRTWIDTH * 2;
                        choice++;
                    }
                    break;

                case UPARROW:
                    if (currow == minrow) {
                        currow = maxrow;
                        choice = height - 1;
                    }
                    else {
                        currow -= CRTWIDTH * 2;
                        choice--;
                    }
                    break;

                default:
                    c = getch();
                    continue;
            }
            offset2 = currow;
            strptr2 = menu[choice];
            for (i = 0; i < width; i++) {
                video.byte.attr = NORMAL;
                if (*strptr == '\0') video.byte.ch = ' ';
                else {
                    if (strptr == (*hotkey)[j])
                        video.byte.attr = INTENSE;
                    video.byte.ch = *strptr++;
                }
                poke(segment, offset, video.word);
                offset += 2;
                if (*strptr2 == '\0') video.byte.ch = ' ';
                else video.byte.ch = *strptr2++;
                video.byte.attr = REVERSE;
                poke(segment, offset2, video.word);
                offset2 += 2;
            }
            c = getch();
        }
        else {
            for (i = 0; i < height; i++) {
                if (toupper(c) == *((*hotkey)[i])) {
                    choice = i;
                    break;
                }
            }
            if (i < height) break;
            else c = getch();
        }
    }

    /* restore saved screen area beneath popup menu */
    currow = address;
    bufptr = buffer;
    for (i = 0; i < bheight; i++) {
        offset = currow;
        for (j = 0; j < bwidth; j++) {
            poke(segment, offset, *bufptr++);
            offset += 2;
        }
        currow += (CRTWIDTH * 2);
    }

    /* free the allocated memory */
    free(buffer);
    free(hotkey);

    /* return the menu choice */
    if (c == ESCKEY) return -1;
    else return choice;
}



char *menu[] = {

   "                      Dos Services                      ",/*  choice  0  */
   "           The Chuck and Patty Graphics Demo            ",/*  choice  1  */
   " Dark Humour - The Confusing World of Computer Language ",/*  choice  2  */
   "         SATAN C COMPILER - A Programmer's Saga         ",/*  choice  3  */
   "          George Does Iran - Musical Interlude          ",/*  choice  4  */
   "         Odie and Garfield... Not In The Least...       ",/*  choice  5  */
   "           A Sorted PCX and BSAVED Image Viewer         ",/*  choice  6  */
                                      NULL         };      /* terminator */

char *command[] ={
   "",             /*  command 0  */
   "PEANUTS.EXE",  /*  command 1  */
   "LANGUAGE.EXE", /*  command 2  */
   "DEVIL.EXE",    /*  command 3  */
   "GULFBILL.EXE", /*  command 4  */
   "GARFIELD.EXE", /*  command 5  */
   "PBVIEW.EXE",   /*  command 6  */
    NULL         };      /* terminator */


void end_program(int prompt_origin)
{
    pcurs(prompt_origin,0);
    exit(0);
}

void dos_services(void)
{
    char input[81]; /* width of the crt                     */
                    /* actual dos buffer is 128 characters  */
    int status;

           {
    cls(0,14);
    pcurs(0,0);
    if (system(NULL)){
            printf("\n\t<<<  Enter a Command or Press ");
            printf("Return For Dos Shell  >>>\n");
        gets(input);
        if (strlen(input)==0){
            printf("\t<<<        type EXIT to return to ");
            printf("the Menu          >>>\n\n");
            }
        status = system(input);
        if (status == 0){
            printf("\n\n\t<<<    Pausing...Press any Key ");
            printf("to return to Menu    >>>");
            }
        else{
            printf("\n\n\t<<<   Dos Error %d. ",status);
            printf("Press any Key ...   >>>\n\n");
            }
            }
   else {   printf("\n\n\t<<<     Command.Com not ");
            printf("found.  Press any Key.      >>>\n\n");   }
            }
   getch();
 cls(0,7);
}
main()
{
    int i, choice, status, prompt_origin=(crow());

    start:
         pcurs(26,0);


        choice = popup(10,10, menu);
        switch (choice){
            case  -1:  end_program(prompt_origin);
            case  0 :  prompt_origin=0;dos_services();break;

            default :   {
                         pcurs(0,0);
                         if (strlen(command[choice])==0){
                                     break;
                                    }
                         status = system(command[choice]);
                         if (status ==0){
                                         break;
                                        }
                        }
            }
     goto start;
}



