/*

DEVIL.C was created using CTEXT(C) V1.0.0
(C) Copyright 1990 by Bill Buckels

CTEXT(C) converts ascii documents to executable C language Source Code

This Source File Format was developed using Mix Power C Version 2.0
and Has also Been Tested Successfully
With Turbo C Version 2.01, Quick C Version 1.01 and Microsoft C Version 5.1

DEVIL.C is The C Source Code for the .Exe Version of DEVIL.DOC

	Thank you for using CTEXT(C).

	 Bill Buckels,  Starving Programmer
	 982 Hector Avenue
	 Winnipeg, Manitoba, Canada R3M 2G6

	Phone (204) 452-2815
*/

/* color definitions */

#define BLACK     0
#define BLUE      1
#define GREEN     2
#define CYAN      3
#define RED       4
#define MAGENTA   5
#define BROWN     6
#define WHITE     7
#define GRAY      8
#define LBLUE     9
#define LGREEN    10
#define LCYAN     11
#define LRED      12
#define LMAGENTA  13
#define YELLOW    14
#define BWHITE    15

#define ESCKEY     '\x1b' /* character generated by the Esc key            */
#define FUNCKEY    '\x00' /* first character generated by function keys    */
#define UPARROW    'H'    /* second character generated by up-arrow key    */
#define DOWNARROW  'P'    /* second character generated by down-arrow key  */
#define PGUP       'I'    /* second character generated by page up key     */
#define PGDOWN     'Q'    /* second character generated by page down key   */

#define BLANK     32
#define FAT       219
#define SINGLE    1
#define DOUBLE    2

#define CGA 3
#define HERCULES 99
int ADAPTER = CGA;

#include <dos.h>

#undef MK_FP
#undef poke

/* undefine the above if they exist      */
/* all compilers start on equal footing  */

/* macros to poke into memory */
/* dynamically cast a far pointer from segment and offset info */
#define MK_FP(seg,off) ((char far *)(((long)(seg) << 16) | (off)))
/* write an integer at a memory location */
#define poke(a,b,c) (*((int  far*)MK_FP((a),(b))) = (int)(c))


unsigned int biosequip()
{
    union REGS inregs,outregs;

    int86(0x11,&inregs,&outregs); /* get equipment list from the bios */
    return outregs.x.ax;
}



void cursoroff(void)
{
   union REGS regs;

   regs.h.ah = 0x01;
   regs.x.cx = 0x2000;
   int86(0x10,&regs,&regs);
}


void cursoron(void)
{
   union REGS regs;

   regs.h.ah = 0x01;
   regs.x.cx = 0x0607;
   int86(0x10,&regs,&regs);
}


void cls(int BACK,int FRONT)
{
    union REGS reg;

    reg.h.ah = 6;
    reg.h.al = 0;
    reg.h.ch = 0;
    reg.h.cl = 0;
    reg.h.dh = 24;
    reg.h.dl = 79;
    reg.h.bh = (BACK << 4) + FRONT;
    int86(0x10, &reg, &reg);
}


int colorset(bground, palette)
unsigned char bground, palette;
{
    union REGS rin,rout;
    
    if(ADAPTER==HERCULES) return 0;
    rin.h.ah = 11;
    rin.h.bh = 0;
    rin.h.bl = bground;
    int86(0x10,&rin,&rout);
    rin.h.bh = 1;
    rin.h.bl = palette;
    int86(0x10,&rin,&rout);
    return 0;
}




void DMC(int Row, int Column, unsigned BYTE, int BACK, int FRONT, int QUANT)
{
    /*  DMA replacement for writechs function */

    unsigned segment= 0xB000, offset;
    int One_Too_Many = (QUANT+1);
    int i, Attribute;

    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=HERCULES)segment = 0xB800;    /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    for (i=1; i< One_Too_Many ; i++){
        poke(segment,offset, BYTE|Attribute<<8);
        offset+=2;
        }
}


void DMM(char *String, int Row, int Column, int BACK, int FRONT)
{
    /*  DMA replacement for puts
        centre justified string    */

    unsigned Character, segment=0xB000, offset;
    int Attribute;

    Attribute = (BACK << 4) + FRONT;

    Column =   ((Column+1)-(.5*(strlen(String))));

    if(ADAPTER != HERCULES)segment = 0xB800;    /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    while ((Character = *String++)!=0){
        if(Character!='\n'){
        poke(segment,offset,Character|Attribute<<8);
        offset+=2;
        }
        }
}


void DML(char *String, int Row, int Column, int BACK, int FRONT)
{
    /*  DMA replacement for puts
        left justified string    */
    unsigned Character, segment=0xB000, offset;
    int Attribute;

    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=HERCULES)segment = 0xB800; /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    while ((Character = *String++)!=0){
        if(Character!='\n'){
        poke(segment,offset, Character|Attribute<<8);
        offset +=2;
        }
    }
}


void PAINT(int *cor,int bk,int fore,unsigned char Character)
{
   int trow=cor[0],tcol=cor[1],brow=cor[2],bcol=cor[3];
   int index,linelength = ((bcol+1) - (tcol));
   for (index = (trow); index < brow+1; index++)
   DMC(index,tcol,Character,bk,fore,linelength);
}

void BORDERBOX(int *cor,int bk,int fore,unsigned char BRDR)
{

int trow=cor[0],tcol=cor[1],brow=cor[2],bcol=cor[3];
    /* draws an outline only using a specified border character */
int index;
int homecol = (tcol+1);
int linelength = ((bcol) - (tcol+1));

int TLcorner,TRcorner,BLcorner,BRcorner,HORT,VERT;

          switch(BRDR){
               case DOUBLE: {
                            TLcorner = 201;
                            TRcorner = 187;
                            BLcorner = 200;
                            BRcorner = 188;
                            HORT = 205;
                            VERT = 186;
                            break;
                        }
               case SINGLE: {
                            TLcorner = 218;
                            TRcorner = 191;
                            BLcorner = 192;
                            BRcorner = 217;
                            HORT = 196;
                            VERT = 179;
                            break;
                        }
               default:    {
                            TLcorner = BRDR;
                            TRcorner = BRDR;
                            BLcorner = BRDR;
                            BRcorner = BRDR;
                            HORT = BRDR;
                            VERT = BRDR;
                        }
            }
   DMC(trow,tcol,TLcorner,bk,fore,1);         /* top */
   DMC(trow,homecol,HORT,bk,fore,linelength);
   DMC(trow,bcol,TRcorner,bk,fore,1);
   for (index = (trow+1); index < brow; index++){
       DMC(index,tcol,VERT,bk,fore,1);
       DMC(index,bcol,VERT,bk,fore,1);
       }
   DMC(brow,tcol,BLcorner,bk,fore,1);
   DMC(brow,homecol,HORT,bk,fore,linelength);
   DMC(brow,bcol,BRcorner,bk,fore,1);        /* bottom */
}



void getadaptertype(void)
{
    if(((biosequip() >>4) &3) <3)ADAPTER=CGA;
    else ADAPTER=HERCULES;

}

char *WINTALK[]=
{
/* data statements */

/*0   */" ODE TO C",
/*1   */" author Unknown",
/*2   */"",
/*3   */" THE SATAN C Compiler",
/*4   */" (Sung to the tune of \"The Hotel California\"- The Eagles)",
/*5   */"",
/*6   */" First I tore off the wrapping, Then I took out the Disk.",
/*7   */" I never noticed the warning, Or the label that said \"RISK!\".",
/*8   */"",
/*9   */" Then I picked up the licence, And read the Guarantee,",
/*10  */" It said that all the code I'd write, Would be fully bug-free!",
/*11  */"",
/*12  */" I put the disk onto drive A, the hard disk started to smoke",
/*13  */" The smell of sulfur was everywhere, my eyes burned,I started to choke.",
/*14  */"",
/*15  */" And then my amber monitor started glowing dark green,",
/*16  */" and smoke rose as I saw the startup Screen.",
/*17  */"",
/*18  */" And it said, Welcome to the SATAN C Compiler...",
/*19  */" You'll write perfect code, it'll always load,",
/*20  */" We're so glad you bought the SATAN C Compiler,Bug Free's the Goal,",
/*21  */" It'll only cost your soul....",
/*22  */"",
/*23  */" I just stared at the terminal, I think it stared back at me,",
/*24  */" Then I laughed at the practical joke, and settled down to use this C.",
/*25  */"",
/*26  */"",
/*27  */"",
/*28  */" I wrote a HUGE multitasking Database just for fun,",
/*29  */" With built in datebook and spreadsheet to boot",
/*30  */" I never thought it would run...",
/*31  */"",
/*32  */" I knew I'd left pointers dangling, coerced types every place,",
/*33  */" My memory management problems with alloc",
/*34  */" Not even lint could erase.",
/*35  */"",
/*36  */" But I put in stub modules and prepared for the test,",
/*37  */" It compiled in half a second flat, God was I impressed!",
/*38  */"",
/*39  */" All the modules were working, Even the stubs were armed,",
/*40  */" I knew right then and there my coding was great,",
/*41  */" And my life must be charmed.",
/*42  */"",
/*43  */" Welcome to the SATAN C Compiler,",
/*44  */" you'll always write perfect code,",
/*45  */" It'll always load,",
/*46  */" But now you must pay for the SATAN C Compiler,",
/*47  */" Although it works just swell, It'll never sell!",
/*48  */"",
/*49  */"",
/*50  */" And now I sit in my Basement, Starving, Broke, and Alone,",
/*51  */" I never speak to anyone, Although I sometimes moan.",
/*52  */"",
/*53  */" But I Thought that I should warn you don't touch that disk,",
/*54  */" The One that Infernal Business Machines Labels with 'RISK!'",
/*55  */"",
/*56  */" But for me it's too late, I can't get out of this Hell,",
/*57  */" I stab at ctrl-alt-del. But I just can't Kill the Shell.",
/*58  */" All I get is one message. And The text makes me grieve.",
/*59  */" \"You can Logoff any time you like but you can never leave..\"",
/*60  */"",
/*61  */" Welcome to the SATAN C Compiler,",
/*62  */" you'll always write perfect code,",
/*63  */" It'll always load.",
/*64  */" You better not go near the SATAN C Compiler.",
/*65  */" If you do, my friend, It'll be your end....",
/*66  */"",
/*67  */"  Author Unknown",
/*68  */"",
/*69  */""
/*       End of Data       */
};

int UPPERLIMIT=69;  /* no of array elements */
int Ls=4;            /* left side of document */

void windowtalk(void)
{

int index = 0;
int numbers;
int cor[4];

char c;

      cor[0]=0;
      cor[1]=0;
      cor[2]=24;
      cor[3]=79;

      BORDERBOX(cor,BLACK,CYAN,SINGLE);
      DMC(0,0,2,BROWN,BLACK,80);
      DMC(24,0,2,BROWN,BLACK,80);
      DMC(1,0,2,BLACK,RED,80);
      DMC(23,0,2,BLACK,RED,80);
DMM(" What Goes Around Comes Around ",0,39,BLACK,YELLOW);
DMM(" Use Arrow or Page Up and Down To View...  ESC to Exit ",24,39,0,15);

      cor[0]=2;
      cor[1]=1;
      cor[2]=22;
      cor[3]=78;

      PAINT(cor,BLACK,BWHITE,BLANK);

      for(numbers = 2; numbers<23; numbers++){
                 DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                 index++ ;
                 }

    while ((c=getch())!= ESCKEY)
        {

        if ((c) == FUNCKEY)
            {
            c = getch(); /* get second character of key */
            switch (c) {

            case DOWNARROW:{
                             if (index<UPPERLIMIT){
                                      index++;
                                      index=index-21;
                                      if(index<0){
                                         index =0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);
                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                           index++ ;
                           }
                        }
                        break;
                        }
            case UPARROW:{ index--;
                             if (index<UPPERLIMIT){
                                      index=index-21;
                                      if(index<0){
                                         index =0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);
                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                           index++ ;
                           }
                        }
                        break;
                        }
            case PGDOWN: {
                          if (index >= (UPPERLIMIT-21)){
                                      index=UPPERLIMIT-21;
                                     }
                          if(index<0){
                                      index =0;
                                     }
                          for(numbers = 2; numbers<23; numbers++){
                               DMC(numbers,1,BLANK,BLACK,BWHITE,78);
                               DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                               index++ ;
                             }
                        break;
                        }
            case PGUP:  {      index=index-42;
                               if(index<0){
                                         index =0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);
                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                           index++ ;
                           }
                        break;
                        }
                   }
              }
        }

}


main()
{
    getadaptertype();
    cls(0,14);
    colorset(1,0);
    cursoroff();
    windowtalk();
    cls(0,7);
 DMC(0,0,FAT,BLACK,RED,80);
 DMM("An object in motion will be heading in the wrong direction.",0,39,4,14);
 cursoron();
 exit(0);
}



