// EDPARSER.HXX  - Very simple Edit control text string parser
//                (C) Sturmer Hauss Corp 1991


// This class will parse the text in a Multi-Line Edit control.  If the
// edit is in a dialog box you should use the DS_LOCALEDIT style.



#ifndef CLASS_EDITPARSER
#define CLASS_EDITPARSER


// Find (nDirection) flags
#define  SRCH_FORWARD         1     // Search toward end of file.
#define  SRCH_BACKWARDS      -1     // Search toward beginning of file.


// nGlobalOrLocal flags
#define  DATA_LOCAL           1     // the hEditCntrlData is local memory
#define  DATA_GLOBAL          2     // the hEditCntrlData is global memory




//////////////////////////////////////////////////////////////////////////////
// EditParser class
//////////////////////////////////////////////////////////////////////////////
class FAR EditParser
   {
   private  :
      EditWindow FAR *lpEdit;
      HANDLE          hEditData;
      int             nMemType;
      int             nDir;
      BOOL            bCase;


      BOOL  FAR   FindText( LPSTR lpszTarget, LPSTR lpszSearchStr );
      BOOL  FAR   Compare( LPSTR lpszTarget, LPSTR lpszSearchStr );

   public   :
            // You should default hEditData to 0 if you are not performing
            // an EditWindow->GetDataHandle() on a local edit. i.e. an edit
            // on the client face or an edit in a dialog box with the style
            // DS_LOCALEDIT.
            FAR      EditParser( EditWindow FAR *lpEditCntrl, HANDLE hEditCntrlData = 0, int nLocalOrGlobal = DATA_LOCAL );
            FAR     ~EditParser( void );


      // Returns 1 if found, 0 if not found and -1 if an error occurs.
      int  FAR      Find( LPSTR lpszSearchStr, int nDirection = SRCH_FORWARD, BOOL bCaseSensitive = FALSE );

   };


#endif // CLASS_EDITPARSER
