/* findfirst() and findnext() the way TurboC does them */
/* since Zortech C doesn't do them the same way        */

#include <stdio.h>
#include <dos.h>

#define ENOENT  2
#define ENMFILE 18

/* extern volatile int errno; */

struct SREGS segregs;
union REGS r;

 struct ffblk {
                        char ff_reserved[21];
                        char ff_attrib;
                        int ff_ftime;
                        int ff_fdate;
                        long ff_size;
                        char ff_name[13];
              };


int Findnext(struct ffblk *ffblk)
{
   int status;
   unsigned DTASeg, DTAOff, DSeg, CFlag, AXReg;

    /* Find current DS register */
    segread(&segregs);
    DSeg = segregs.ds;

    /* Get and save address of DiskTransferArea */
    r.h.ah = 0x2f;
    status = intdosx(&r, &r, &segregs);
    DTASeg = segregs.es;
    DTAOff = r.x.bx;

    /* Set DiskTransferArea to ffblk */
    r.h.ah = 0x1a;
    segregs.ds = DSeg;
    r.x.dx = (unsigned)ffblk;
    status = intdosx(&r, &r, &segregs);

    /* Search the directory */
    r.h.ah = 0x4f;
    status = intdosx(&r, &r, &segregs);

    /* Save CFlag and AX for later use */
    CFlag = r.x.cflag;
    AXReg = r.x.ax;

    /* Put DTA back where it was */
    r.h.ah = 0x1a;
    r.x.dx = DTAOff;
    segregs.ds = DTASeg;
    status = intdosx(&r, &r, &segregs);

    if(CFlag){
      if(AXReg == 0x12)
       errno = ENMFILE;
      else
       errno = ENOENT;

      return -1;
    }
    else
      return 0;
}

int Findfirst(char *pathname, struct ffblk *ffblk, int attrib)
{

    int status;
    unsigned DTASeg, DTAOff, DSeg, CFlag, AXReg;

    /* Find current DS register */
    segread(&segregs);
    DSeg = segregs.ds;

    /* Get and save address of DiskTransferArea */
    r.h.ah = 0x2f;
    status = intdosx(&r, &r, &segregs);
    DTASeg = segregs.es;
    DTAOff = r.x.bx;

    /* Set DiskTransferArea to ffblk */
    r.h.ah = 0x1a;
    segregs.ds = DSeg;
    r.x.dx = (unsigned)ffblk;
    status = intdosx(&r, &r, &segregs);

    /* Search the directory */
    r.h.ah = 0x4e;
    r.x.cx = attrib;
    r.x.dx = (unsigned)pathname;
    status = intdosx(&r, &r, &segregs);

    /* Save CFlag and AX for later use */
    CFlag = r.x.cflag;
    AXReg = r.x.ax;

    /* Put DTA back where it was */
    r.h.ah = 0x1a;
    r.x.dx = DTAOff;
    segregs.ds = DTASeg;
    status = intdosx(&r, &r, &segregs);

    if(CFlag){
      if(AXReg == 0x12)
       errno = ENMFILE;
      else
       errno = ENOENT;

      return -1;
    }
    else
      return 0;
}
