/**/
/********************************************************/
/*                                                      */
/*                     FRED-FU.C                        */
/*   Copyright 1990 J. W. Hance - All rights reserved   */
/*  Unpack a FTSC Mail packet and build an RFC-1036     */
/*         UseNet batched news file from it             */
/*                                                      */
/********************************************************/
/**/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <alloc.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>
#include <dos.h>
#include <mem.h>

#include "version.h"
#include "fred.h"

#ifdef TC20
#include "fixtz.h"
#endif

int Debug;

/**/
/******************** MAIN **********************/
/**/

void main(int argc, char *argv[])
{
 char *cpt, *dpt, c, *dpt1, *line, *fpt, *fpt1;
 unsigned long i, j, k;
 int flag, flag_user, bigflag, z;
 int offset, keep_origin;
 int ct, count, long_message;
 int total_processed = 0;
 int total_copied = 0;
 int total_dumped = 0;
 int total_netmail_copied = 0;
 int total_netmail_dumped = 0;
 int fflag, sendertype;
 unsigned int sequence;
 char *from_node, *to_node, *uucpname, *curgroup, *logfile;
 char *origin_node;
 char *domain, *category, *lost_path, *remember_address;
 char *tmp, *buffer, *who, *area, *config_tempdir;
 char *config_file, *too_bigs, *spool_path;
 int config_file_flag, netmail, lost;
 int left, xcount, tcount, LineBreak = 0;
 char *f0, *f1, *f2, *f3, *f4, *ftmp, *ftmp1;
 char *uufrom;

/* This may not be portable to compilers other than TC++ */
#ifdef __COMPACT__ || __LARGE__
 struct tofidos far *tofidosptr, far *firstfidosptr, far *lastfidosptr;
#endif

#ifdef __SMALL__ || __MEDIUM__
 struct tofidos *tofidosptr, *firstfidosptr, *lastfidosptr;
#endif

#ifdef __TINY__ || __HUGE__
#error Cannot COMPILE for TINY or HUGE
#endif

 struct tousers *tousersptr, *firstusersptr, *lastusersptr;
 struct tousers *UsersPtr;
 struct PktHeader *PktHeader;
 struct MsgHeader *MsgHeader;
 FILE *cffp, *logfp, *tmpfp, *seqfp, *mailfp, *ToUucpfp;
 char *tempname, *tmpstr;
 time_t t, start_time;
 char ascii_time[42], seq[5];
 char *hold_date;
 char *start_of_message, *end_of_message;
 struct date d;
 struct time tm;
 struct nodeaddr fnode, tnode, onode;
 struct Str Str;
 unsigned long filesize;
 int first_tofido = 0;
 int how_many_tofidos = 0;
 int reading_touucpfile = 0;
 unsigned long startmem, endmem;
 int touucp, result;
 char toaddress[127], Uusystem[127], Uuser[127], SmartHost[64];
 struct Sites Sites;
 int ToManySites = 0;
 int FoundSite;
 struct Dist Dist;
 int ToManyDist = 0;

 /**/
 /* Set debug mode */
 /**/

 Debug = 0; /* Off */

 Sites.howmany = 0;
 Dist.howmany = 0;

 /* Run FixTzname() if TC2.0 */
#ifdef TC20
 _FixTzname();
#endif

/* fprintf(stderr, "CORELEFT = %u\n", coreleft()); */

 /* Record Starting time */
 start_time = time(NULL);

 FredFuStartup();

 /**/
 /* Verify correct command line usage */
 /**/

 if(argc != 3){
 Usage:
  FredFuUsage();
 EndIf

 else{

 /**/
 /* Get name of config file */
 /**/
  config_file_flag = 0;

  for(ct = 1; ct < argc; ct++){
   if(strcmpi(argv[ct], "-c") == 0){
    if(config_file_flag){
     fprintf(stderr, "ERROR: Redundant '-c' switches\n");
     exit(2);
    EndIf

    else{
     config_file = AllocateString(strlen(argv[++ct]));
     strcpy(config_file, argv[ct]);
     config_file_flag++;
    EndElse
   EndIf

   else{
    goto Usage;
   EndElse
  EndFor
 EndElse

 /* Done processing command line options */

 /**/
 /* Allocate a BUFFER for use in reading the packet file */
 /* and another one for holding the output message */
 /**/

 if((cpt = malloc(FUALLOC_SIZE+sizeof(struct MsgHeader))) == NULL){
  fprintf(stderr,"ERROR: Memory allocation failed.\n");
  fprintf(stderr,"Probably not enough memory to run.\n");
  exit(3);
 EndIf

 if((dpt = malloc(FUALLOC_SIZE)) == NULL){
  fprintf(stderr,"ERROR: Memory allocation failed.\n");
  fprintf(stderr,"Probably not enough memory to run.\n");
  exit(3);
 EndIf

 if((fpt = malloc(256)) == NULL){
  fprintf(stderr,"ERROR: Memory allocation failed.\n");
  fprintf(stderr,"Probably not enough memory to run.\n");
  exit(3);
 EndIf

 /**/
 /* Now process the configuration file */
 /**/

 /* Try to open config file */
 cffp = OpenFile(config_file, "r");

 buffer = AllocateString(255);
 tofidosptr = NULL;
 tousersptr = NULL;
 flag = flag_user = 0;

 f0 = AllocateString(127);
 f1 = AllocateString(127);
 f2 = AllocateString(127);
 f3 = AllocateString(127);
 f4 = AllocateString(127);

 for(;;){

  if(reading_touucpfile){
   if(fgets(buffer, 256, ToUucpfp) == NULL){
    reading_touucpfile = 0;
    fclose(ToUucpfp);
    if(fgets(buffer, 256, cffp) == NULL)
     break;
   EndIf
  EndIf

  /* Not reading ToUucpFile */
  else{
   if(fgets(buffer, 256, cffp) == NULL)
    break;
  EndElse

  /* See if it is a comment */
  if(*buffer == '#') continue;
  else if(*buffer == ';'){
   fprintf(stderr, "!! ERROR - Config file format has changed, read docs\n");
   exit(-1);
  EndIf

  /* Otherwise look for interesting config statements */

  sscanf(buffer, "%s %s %s %s", f1, f2, f3, f4);

  if(strcmpi(f1, "mapfile") == 0){
   ToUucpfp = fopen(f2, "r");
   if(ToUucpfp == NULL)
    fprintf(stderr, "ERROR - Can't open MapFile %s\n", f2);
   else{
    reading_touucpfile = 1;
    fprintf(stderr, "-- Reading MapFile %s\n", f2);
   EndElse
  EndIf

  if(strcmpi(f1, "touucp") == 0){
   fprintf(stderr, "## You didn't update your config file, did you? ##\n");
   exit(2);
  }

  if(strcmpi(f1, "logfile") == 0){
   logfile = AllocateString(strlen(f2));
   strcpy(logfile, f2);

   /* Try to open the logfile */
   logfp = OpenFile(logfile, "a");

   t = time(NULL);
   fprintf(logfp, "\n#FRED-FU START @TM=%s+<CF=%s>\n", ctime(&t), config_file);

   continue;
  EndIf

  if(strcmpi(f1, "to_node") == 0){
   to_node = AllocateString(strlen(f2));
   strcpy(to_node, f2);
   VerifyNode(to_node, &tnode);
   continue;
  EndIf

  if(strcmpi(f1, "smarthost") == 0){
   strcpy(SmartHost, f2);
   continue;
  EndIf

  if(strcmpi(f1, "linebreak") == 0){
    LineBreak = atoi(f2);
    if((LineBreak < 0) || (LineBreak > 2048)){
     fprintf(stderr, "ERROR - %d is an ILLEGAL value for LineBreak.\n");
     exit(-1);
    EndIf
    continue;
  EndIf

  if(strcmpi(f1, "from_node") == 0){
   from_node = AllocateString(strlen(f2));
   strcpy(from_node, f2);
   VerifyNode(from_node, &fnode);
   continue;
  EndIf

  if(strcmpi(f1, "origin_node") == 0){
   origin_node = AllocateString(strlen(f2));
   strcpy(origin_node, f2);
   VerifyNode(origin_node, &onode);
   continue;
  EndIf

  if(strcmpi(f1, "uucpname") == 0){
   uucpname = AllocateString(strlen(f2));
   strcpy(uucpname, f2);
   continue;
  EndIf

  /* Where the spool files are */
  if(strcmpi(f1, "spool") == 0){
   spool_path = AllocateString(strlen(f2));
   strcpy(spool_path, f2);
   continue;
  }

  /* Where lost mail messages should go */
  if(strcmpi(f1, "lostfu") == 0){
   lost_path = AllocateString(strlen(f2));
   strcpy(lost_path, f2);
   continue;
  }

  /* What directory to use for temporary files */
  if(strcmpi(f1, "tempdir") == 0){
   config_tempdir = AllocateString(strlen(f2));
   strcpy(config_tempdir, f2);
   tempname = AllocateString(strlen(f2) + L_tmpnam);
   continue;
  EndIf

  if(strcmpi(f1, "site") == 0 && !ToManySites){
   strcpy(Sites.Site[Sites.howmany], f2);
   if(Sites.howmany == 49)
    ++ToManySites;
   else
    ++Sites.howmany;
   continue;
  EndIf

  if(strcmpi(f1, "distribution") == 0 && !ToManyDist){
   strcpy(Dist.Dist[Dist.howmany], f2);
   if(Dist.howmany == 9)
    ++ToManyDist;
   else
    ++Dist.howmany;
  EndIf

  if(strcmpi(f1, "who") == 0){
   who = AllocateString(strlen(f2));
   strcpy(who, f2);
   continue;
  EndIf

  if(strcmpi(f1, "sendertype") == 0){
   if(strcmpi(f2, "fido") == 0){
    sendertype = 0;
   EndIf
   else if(strcmpi(f2, "uucp") == 0){
    sendertype = 1 ;
   EndIf
   else{
    fprintf(stderr, "ERROR: Unknown option for SENDERTYPE in config file.\n");
    fprintf(stderr, "       Found %s, legal values are 'FIDO' and 'UUCP'\n", f2);
    exit(6);
   EndElse
   continue;
  EndIf

  if(strcmpi(f1, "domain") == 0){
   domain = AllocateString(strlen(f2));
   strcpy(domain, f2);
   continue;
  EndIf

  if(strcmpi(f1, "category") == 0){
   category = AllocateString(strlen(f2));
   strcpy(category, f2);
   continue;
  EndIf

  if(strcmpi(f1, "keep_origin") == 0){
   if(strcmpi(f2, "yes") == 0){
    keep_origin = 1;
   EndIf
   else if(strcmpi(f2, "no") == 0){
    keep_origin = 0;
   EndIf
   else{
    fprintf(stderr, "ERROR: Unknown option '%s' for KEEP_ORIGIN.\n", f2);
    exit(2);
   EndElse
   continue;
  EndIf

  /* Get the TOUUCP mappings */
  if((strcmpi(f1, "map") == 0) && ((*f2 == '<') || (*f2 == '+'))){

   lastfidosptr = tofidosptr;
   how_many_tofidos++;

#ifdef __COMPACT__ || __LARGE__
   tofidosptr = farmalloc(sizeof(struct tofidos));
   if(first_tofido == 0){
    startmem = farcoreleft();
    first_tofido++;
    fprintf(stderr, "-- You have %lu percent of your memory left (%luK of 640K) before Maps.\n",
            ((startmem*100L)/655360L), startmem/1024);
   }
#endif
#ifdef __SMALL__ || MEDIUM__
   tofidosptr = malloc(sizeof(struct tofidos));
   if(first_tofido == 0){
    startmem = (unsigned long)coreleft();
    first_tofido++;
    fprintf(stderr, "-- You have %lu percent of your memory left (%luK of 64K) before Maps.\n",
            ((startmem*100L)/65536L), startmem/1024);
   }
#endif



   if(tofidosptr == NULL){
    fprintf(stderr, "ERROR: Can't allocate memory for Maps.\n");
    exit(6);

   EndIf

   if(flag == 0){
    flag++;
    firstfidosptr = tofidosptr;
   EndIf

   lastfidosptr->next = tofidosptr;
   tofidosptr->next = NULL;

#ifdef __COMPACT__ || __LARGE__
   tofidosptr->uucpname = FarAllocateString(strlen(f3));
   strcpy(tofidosptr->uucpname, f3);
   tofidosptr->fidoname = FarAllocateString(strlen(f4));
   strcpy(tofidosptr->fidoname, f4);
#endif
#ifdef __SMALL__ || MEDIUM__
   tofidosptr->uucpname = AllocateString(strlen(f3));
   strcpy(tofidosptr->uucpname, f3);
   tofidosptr->fidoname = AllocateString(strlen(f4));
   strcpy(tofidosptr->fidoname, f4);
#endif



   tofidosptr->count = 0;

   /* See if there is a Distribution tag */
   if(strlen(f2) == 2){
    tofidosptr->dist = atoi(f2+1);
   EndIf
   else
    tofidosptr->dist = 0;

   continue;
  EndIf

  /* Get the FidoNet user -> uucp user name mappings */
  if(strcmpi(f1, "mailfu") == 0){
   lastusersptr = tousersptr;
   tousersptr = malloc(sizeof(struct tousers));
   if(tousersptr == NULL){
    fprintf(stderr, "ERROR: Can't allocate memory for tousers\n");
    exit(6);
   EndIf

   if(flag_user == 0){
    flag_user++;
    firstusersptr = tousersptr;
   EndIf

   tmp = memchr(buffer, QUOTE, 32);
   tmp = memccpy(f1, ++tmp, QUOTE, 64);
   *(tmp-1) = NULL;

   tmp = memchr(buffer, QUOTE, 32);
   tmp = memchr(++tmp, QUOTE, 64);

   sscanf(++tmp, "%s %s", f3, f2);

   lastusersptr->next = tousersptr;
   tousersptr->next = NULL;
   tousersptr->uucpname = AllocateString(strlen(f2));
   strcpy(tousersptr->uucpname, f2);
   tousersptr->fidoname = AllocateString(strlen(f1));
   strcpy(tousersptr->fidoname, f1);
   tousersptr->system = AllocateString(strlen(f3));
   strcpy(tousersptr->system, f3);
   tousersptr->count = 0;
   continue;
  EndIf

 EndWhile

 fclose(cffp);

 /* Done Reading Configuration file */

/* Report how much memory is left */
#ifdef __SMALL__ || __MEDIUM__
 endmem = (unsigned long)coreleft();
 fprintf(stderr, "-- You have %lu percent of your memory left (%luK of 64K) after Maps.\n",
            ((endmem*100L)/65536L), endmem/1024);
#endif
#ifdef __COMPACT__ || __LARGE__
 endmem = farcoreleft();
 fprintf(stderr, "-- You have %lu percent of your memory left (%luK of 640K) after Maps.\n",
            ((endmem*100L)/655360L), endmem/1024);
#endif

 fprintf(stderr, "-- Found %d Map Statements, which used %luK RAM\n",
                 how_many_tofidos, (startmem-endmem)/1024);


 /**/
 /* Need to check here that all config items are set */
 /**/

 /* Output fidos if in debug mode */
 if(Debug)
  DumpFidos(firstfidosptr);

 /* Find out what time it is */
 t = time(NULL);
 strcpy(ascii_time, ctime(&t));
 sscanf(ascii_time, "%s %s %s %s %s", f0, f1, f2, f3, f4);
 strcpy(ascii_time, f0);
 strcat(ascii_time, ", ");
 strcat(ascii_time, f2);
 strcat(ascii_time, " ");
 strcat(ascii_time, f1);
 strcat(ascii_time, " ");
 strcat(ascii_time, &f4[2]);
 strcat(ascii_time, " ");
 strcat(ascii_time, f3);
 strcat(ascii_time, " ");
 strcat(ascii_time, tzname[0]);
 /* ascii_time should now be of form Dow, dd Mmm yy hh:mm:ss Zon */

 /* Also get the numerical time from DOS */
 getdate(&d);
 gettime(&tm);

 /* Just so I can sleep nights ! */
 if(d.da_year < 2000)
  d.da_year -=1900;
 else
  d.da_year -=2000;

 /* Ok, now we have all the time we need */

 /* Read and verify that we are processing a valid FTSC mail packet */

 /* Allocate memory for the Packet header */
 PktHeader = malloc(sizeof(struct PktHeader));

 if(PktHeader == NULL){
  fprintf(stderr, "ERROR: Can't malloc() for PktHeader.\n");
  fprintf(stderr, "       Probably not enough RAM left to run\n");
  exit(2);
 EndIf

 /* Be sure we have the stdin and stdout in BINARY mode */
 setmode(fileno(stdin), O_BINARY);
 setmode(fileno(stdout), O_BINARY);

 /* And be sure that we are at the start */
 lseek(fileno(stdin), 0L, SEEK_SET);
 fseek(stdout, 0L, SEEK_SET);

 count = read(fileno(stdin), PktHeader, sizeof(struct PktHeader));
 if(count != sizeof(struct PktHeader)){
  fprintf(stderr, "ERROR: Can't read input file.\n");
  exit(2);
 EndIf

 if(PktHeader->Version != 0x0002){
  fprintf(stderr, "ERROR: Was expecting a type (2) FTSC packet.\n");
  fprintf(stderr, "       This one appeared to be type (%d).\n", PktHeader->Version);
  exit(2);
 EndIf



 /**/
 /**********************************************/
 /*      Now go through all the messages       */
 /**********************************************/
 /**/

 /* We are reading an FTSC packet and should be able to read the
    first message header now */


 count = read(fileno(stdin), cpt, FUALLOC_SIZE+sizeof(struct MsgHeader));
 if(count < sizeof(struct MsgHeader)){
  fprintf(stderr, "!! Packet appears short. No messages found.\n");
  exit(1);
 EndIf

 /* Allocate a buffer for line processing */
 /* Hopefully 2048 bytes is enough */
 line = AllocateString(2048);

 while(1){

  MsgHeader = (struct MsgHeader *)cpt;

  TryAgain:
  if(MsgHeader->Version != 0x0002){
   if(MsgHeader->Version == 0x0000){
    /* Assume end of packet */
    fprintf(stderr, "-- Found end of packet.\n");
    break;
   EndIf
   fprintf(stderr, "WARNING: Message is out of SYNC.\n");
   fprintf(stderr, "         Attempting to re-SYNC.\n");
   memmove(cpt, cpt+1, count);
   --count;
   if(count <= 0){
    fprintf(stderr, "ERROR: Lost synchronization - Defective packet.\n");
    break;
   EndIf
   goto TryAgain;
  EndIf
  else{

   /* Get past the header */
   start_of_message = cpt + sizeof(struct MsgHeader);

   /* Copy each of the Message header items out for later use */
   /* f0 = date */
   ftmp = memccpy(f0, start_of_message, 0, 20);
   start_of_message += ftmp - f0;

   /* f1 = ToUser */
   ftmp = memccpy(f1, start_of_message, 0, 36);
   start_of_message += ftmp - f1;

   /* f2 = FromUser */
   ftmp = memccpy(f2, start_of_message, 0, 36);
   start_of_message += ftmp - f2;

   /* f3 = Subject */
   ftmp = memccpy(f3, start_of_message, 0, 72);
   start_of_message += ftmp - f3;

   /* start_of_message points to first character in message */

   /* Look for NULL at end of message */
   end_of_message = memchr(start_of_message, 0,
			   count-(start_of_message-cpt));

   if(end_of_message == NULL){
    long_message = 1;
    fprintf(stderr, "NOTE: Found long message.\n");
    strcpy(tempname, config_tempdir);
    strcat(tempname, tmpnam(NULL));
    fprintf(stderr, "-- Using temporary file %s for long message processing\n",
		     tempname);

    /* Open the temporary file */
    tmpfp = OpenFile(tempname, "wb");

   EndIf
   else{
    long_message = 0;
   EndElse

   /* end_of_message points at the NULL at end of message */

   /* Find the AREA */
   if(FindArea(start_of_message,
	    long_message ? count - (start_of_message - cpt) :
	    end_of_message-start_of_message, &Str) == NULL){

     /* No area found - assume this is a NetMail message */
     touucp = 0;
     if(FindToUucp(start_of_message,
	    long_message ? count - (start_of_message - cpt) :
	    end_of_message-start_of_message, &Str) != NULL){
      touucp = 1;
      strncpy(toaddress, Str.cpt, Str.cnt);
      *(toaddress + Str.cnt) = NULL;

      /* Now get past the ToUucp: line so it doesn't get output to message */
      /* Find the first NON-Whitespace character after To: field */
      start_of_message = Str.cpt + Str.cnt;
      while(!isalnum(*start_of_message))
       ++start_of_message;

      if(start_of_message > end_of_message){
        fprintf(stderr, "ERROR: start_of_message > end_of_message\n");
        fprintf(logfp, "!CORRUPT??\n");
        exit(-1);
      }

      fprintf(stderr, "-- Found NetMail w/TOUUCP to %s.\n", toaddress);
     }
     else{
      fprintf(stderr, "-- Found NetMail to %s.\n", f1);
     }

    /* Flag that we are doing a NetMail message */
    netmail = 1; flag = 1;

    UsersPtr = FindUucpUserName(firstusersptr, f1);

    if((touucp == 0) && (UsersPtr == NULL)){
     lost = 1;
     total_netmail_dumped++;
     fprintf(stderr, "WARNING: Couldn't find MailFu for %s.\n", f1);
     fprintf(stderr, "!! Copied to directory %s\n", lost_path);
     fprintf(logfp, "!LOSTMAIL %s -> %s\n", f1, lost_path);
    EndIf
    else if(touucp == 1){
     lost = 0;
     fflag = 0;
     fprintf(stderr, "-- Found mail for %s\n", toaddress);
     result = ParsePath(toaddress, Uuser, Uusystem);

     if(result == -1){
      fprintf(stderr, "WARNING: Illegal uucp address %s.\n", toaddress);
      fprintf(stderr, "Copied to directory %s\n", lost_path);
      fprintf(logfp, "!BADADDR %s -> %s\n", toaddress, lost_path);
      lost = 1;
      total_netmail_dumped++;
     EndIf
     else{
      /* Address is DOMAIN style - must send to Smarthost */
      if(result == 0){
       fprintf(stderr, "-- Forwarding message to SmartHost %s\n", SmartHost);
       fprintf(logfp, "+SMARTHOST %s -> %s\n", toaddress, SmartHost);
       strcpy(Uusystem, SmartHost);
       total_netmail_copied++;
      EndIf
      /* Address appears normal - but must be listed in SITE table */
      else{
       FoundSite = 0;
       for(k=0; k<=Sites.howmany; k++){
        if(strcmpi(Uusystem, Sites.Site[k]) == 0){
         FoundSite = 1;
         break;
        EndIf
       EndFor
       if(FoundSite){
        lost = 0;
        fflag = 0;
        total_netmail_copied++;

       EndIf
       else{
        fprintf(stderr, "-- Forwarding message to SmartHost %s\n", SmartHost);
        fprintf(logfp, "+SMARTHOST A=%s H=%s\n", toaddress, SmartHost);
        if(result == 1){
         tmpstr = strdup(Uuser);
         strcpy(Uuser, Uusystem);
         strcat(Uuser, "!");
         strcat(Uuser, tmpstr);
         free(tmpstr);
        EndIf
        else if(result == 2){
         strcat(Uuser, "@");
         strcat(Uuser, Uusystem);
        EndIf
        else if((result == 3) || (result == 4)){
         tmpstr = strdup(Uuser);
         strcpy(Uuser, "@");
         strcat(Uuser, Uusystem);
         strcat(Uuser, ":");
         strcat(Uuser, tmpstr);
         free(tmpstr);
        EndIf

        strcpy(Uusystem, SmartHost);
       EndElse
      EndElse

      if(result != 0 && FoundSite == 1){
       fprintf(logfp, "+GATEMAIL U=%s S=%s\n", Uuser, Uusystem);
       total_netmail_copied++;
      EndIf
     EndElse
    EndIf
    else{
     strcpy(Uuser,UsersPtr->uucpname);
     strcpy(Uusystem,UsersPtr->system);
     fprintf(stderr, "-- MailFu mail addressed %s -> %s at %s\n", f1,
                      Uuser, Uusystem);
     fprintf(logfp, "+MAPMAIL U=%s S=%s\n", Uuser, Uusystem);
     total_netmail_copied++;
    EndElse

    /* Get the sequence number from the sequence file */
    sequence = GetSequenceNumber();
    sprintf(seq, "%04d", sequence);

    /* Write out the header of the uucp message */
    if(!lost)
     mailfp = WriteUucpMessageHeader(spool_path, Uusystem, Uuser, toaddress,
                     uucpname, f2, seq, who, ascii_time,
				     f0, lost, PktHeader->OriginZone,
				     MsgHeader->OriginNet,
				     MsgHeader->OriginNode,
				     domain, category, sendertype,
				     &onode);
    else
     mailfp = WriteUucpMessageHeader(lost_path, "UNKNOWN_SYSTEM",
                     "UNKNOWN_USER", toaddress,
                     uucpname, f2, seq, who,
				     ascii_time,
				     f0, lost, PktHeader->OriginZone,
				     MsgHeader->OriginNet,
				     MsgHeader->OriginNode,
				     domain, category, sendertype,
				     &onode);

    /* Write the CMD and XQT files */
    if(!lost){
     WriteCmdXQTFiles(spool_path, Uusystem, Uuser,
				  uucpname, seq);
    EndIf

   EndIf
   else{
    netmail = 0;
   EndElse

   /* Now find the proper EchoMail area to send it to from tofidos */
   tofidosptr = firstfidosptr;

   if(!netmail){

    area = AllocateString(Str.cnt);
    memcpy(area, Str.cpt, Str.cnt);
    *(area + Str.cnt) = NULL;

    flag = 0;
    do{
     if(strncmpi(Str.cpt, tofidosptr->fidoname, Str.cnt) == 0){
      flag++;
      break;
     EndIf

     /* Point to the next record */
     tofidosptr = tofidosptr->next;

    } while(tofidosptr != NULL);
   EndIf

   dpt1 = dpt;

   if(!netmail){

    /* Write the UseNet Header lines into the buffer */
    if(sendertype)
     if(strcmpi(category, "(blank)") == 0)
      dpt1 += sprintf(dpt1, "Sender: %s@%s.%s%c",
               who, uucpname, domain, LF);
     else
      dpt1 += sprintf(dpt1, "Sender: %s@%s.%s.%s%c",
               who, uucpname, domain, category, LF);
    else
     if(strcmpi(category, "(blank)") == 0)
      dpt1 += sprintf(dpt1, "Sender: %s@p%d.f%d.n%d.z%d.%s%c",
               who, onode.point, onode.node,
               onode.net, onode.zone, domain, LF);
     else
      dpt1 += sprintf(dpt1, "Sender: %s@p%d.f%d.n%d.z%d.%s.%s%c",
               who, onode.point, onode.node,
               onode.net, onode.zone, domain, category, LF);

    dpt1 += sprintf(dpt1, "Path: %s!%s%c", uucpname, who, LF);
    dpt1 += sprintf(dpt1, "Newsgroups: %s%c", tofidosptr->uucpname, LF);
    dpt1 += sprintf(dpt1, "Subject: %s%c", f3, LF);
    dpt1 += sprintf(dpt1, "Message-ID: <%ld.%d@%s.%s>%c",
			   t, total_processed, uucpname,
               domain, LF);

    if(tofidosptr->dist != 0 && tofidosptr->dist <= Dist.howmany){
     dpt1 += sprintf(dpt1, "Distribution: %s%c",
                                 Dist.Dist[tofidosptr->dist],LF);
    }

    dpt1 += sprintf(dpt1, "Date: %s %s%c%c", f0, tzname[0], LF, LF);
   EndIf

   /* Process the message a line at a time */
   ftmp1 = start_of_message;

   ProcessMessages:
   while(ftmp1 < (long_message ? (cpt + count) : (end_of_message))){
    if(*ftmp1 == NULL){
     fprintf(stderr, "BREAK\n");
     break;
    EndIf

    ftmp = memccpy(line, ftmp1, CR, ((((cpt+count)-ftmp1) < 2048) ?
                 ((cpt+count)-ftmp1) : 2048));

    /* If specified, BREAK the lines */
    if(LineBreak) DoLineBreak(LineBreak, line, ftmp-line);

    if(ftmp == NULL){
     if(long_message)
      break;
     else{
      fprintf(stderr, "==> CORRUPT Packet\n");
      /* A strange thing happened in processing the packet */
      fprintf(stderr, "==> Messages after this one may be dumped.\n");
      break;
      exit(2);
     EndElse
    EndIf

    *(ftmp-1) = NULL;

    /* Look for the Origin line to get the origin address */
    if(memcmp(line, " * Origin", 9) == 0){

     int zone, net, node, point, result;
     result = GetAddressFromOrigin(line, strlen(line),
				    &zone, &net, &node, &point);

     /* See if the Origin line was confusing */
     switch(result){
     case -1:
      zone = PktHeader->OriginZone;
      net  = MsgHeader->OriginNet;
      node = MsgHeader->OriginNode;
      point = -1;
      break;

     case 0:
      zone = PktHeader->OriginZone;
      point = -1;
      break;

     case 2:
      point = -1;
      break;

     case 3:
      break;

     default:
      fprintf(stderr, "==> Unknown result returned from GetAddressFromOrigin()\n");
      fprintf(stderr, "    This should never happen - please report this to the author.\n");
      fprintf(stderr, "RESULT CODE WAS %d\n", result);
      exit(2);
     }

     fflag = 1;
     /* Make a pseudo uucpname from the FidoNet name  */
     /* change "Joe Hance" to "Joe.Hance" or whatever */
     uufrom = AllocateString(strlen(f2));
     strcpy(uufrom, f2);
     for(z=0; z<strlen(uufrom); z++){
      if(*(uufrom+z) == SPACE)
       *(uufrom+z) = PERIOD;

     EndFor
     fpt1 = fpt;
     if((point == -1) || (point == 0))
      if(sendertype)
       if(strcmpi(category, "(blank)") == 0)
	fpt1 += sprintf(fpt, "From: %s@%s.%s (%s)%c", uufrom, uucpname,
						domain, f2, LF);
       else
	fpt1 += sprintf(fpt, "From: %s@%s.%s.%s (%s)%c", uufrom, uucpname,
						domain, category, f2, LF);
      else
       if(strcmpi(category, "(blank)") == 0)
	fpt1 += sprintf(fpt, "From: %s@f%d.n%d.z%d.%s (%s)%c",
			     uufrom, node, net, zone, domain,
			     f2, LF);
       else
	fpt1 += sprintf(fpt, "From: %s@f%d.n%d.z%d.%s.%s (%s)%c",
			     uufrom, node, net, zone, domain,
			     category, f2, LF);
     else
      if(sendertype)
       if(strcmpi(category, "(blank)") == 0)
	fpt1 += sprintf(fpt, "From: %s@%s.%s (%s)%c", uufrom, uucpname,
						domain, f2, LF);
       else
	fpt1 += sprintf(fpt, "From: %s@%s.%s.%s (%s)%c", uufrom, uucpname,
						domain, category, f2, LF);
      else
       if(strcmpi(category, "(blank)") == 0)
	fpt1 += sprintf(fpt, "From: %s@p%d.f%d.n%d.z%d.%s (%s)%c",
			     uufrom, point, node, net, zone, domain,
			     f2, LF);

       else
	fpt1 += sprintf(fpt, "From: %s@p%d.f%d.n%d.z%d.%s.%s (%s)%c",
			     uufrom, point, node, net, zone, domain,
			     category, f2, LF);

     free(uufrom);
    EndIf

    if(
       (*line != 0x01)                         &&
       (memcmp(line, "AREA:", 5) != 0)         &&
       (memcmp(line, "SEEN-BY", 7) != 0)       &&
       (memcmp(line, "--- ", 4)    != 0)       &&
       (memcmp(line, "Newsgroups:", 11) != 0)  &&
       (memcmp(line, "From:", 5) != 0)         &&
       (memcmp(line, "Path:", 5) != 0)         &&
       (memcmp(line, "Subject:", 8) != 0)      &&
       (memcmp(line, "Message-ID:", 11) != 0)  &&
       (memcmp(line, "Date:", 5) != 0)
      ){
        if(keep_origin){
         if(long_message)
          fprintf(tmpfp, "%s%c", line, LF);
         else
          dpt1 += sprintf(dpt1, "%s%c", line, LF);
        EndIf
        else{
         if(memcmp(line, " * Origin", 9) != 0){
          if(long_message)
           fprintf(tmpfp, "%s%c", line, LF);
          else
           dpt1 += sprintf(dpt1, "%s%c", line, LF);
         EndIf
        EndElse
    EndIf

    ftmp1 += ftmp - line;
    if(*ftmp1 == LF) ftmp1++;

   EndWhile

   if(long_message && (*ftmp1 != NULL)){
    /* Need to fill buffer back up */

    /* Move remainder to top of buffer */
    memmove(cpt, ftmp1, (cpt+count)-ftmp1);

    /* Now fill the buffer back up */
    tcount = (cpt+count) - ftmp1;
    count = read(fileno(stdin), cpt + tcount,
			 FUALLOC_SIZE - tcount);
    ftmp1 = cpt;
    count += tcount;
    goto ProcessMessages; /* Keep going with a full buffer */
   EndIf

   if(long_message){
    /* Get the final size of the temp file */
    fflush(tmpfp);
    filesize = filelength(fileno(tmpfp));
    fclose(tmpfp);

    tmpfp = OpenFile(tempname, "rb");
   EndIf

   /* Only write it out if a map was found */
   if(flag){
    if(!netmail){
     total_copied++;
     fprintf(stderr, "Message %5d COPIED (%s)\n", ++total_processed, area);
     if(long_message){
      fprintf(stdout, "#! rnews %ld",
		      fflag ? (filesize + (dpt1-dpt) + (fpt1-fpt)) :
                  (filesize + (dpt1-dpt)));
      fputchar(LF);
     }
     else{
      fprintf(stdout, "#! rnews %d", fflag ? ((dpt1-dpt) + (fpt1-fpt)) :
                        (dpt1-dpt));
      fputchar(LF);
     }
    EndIf

    if(netmail){
     FilterSoftCR(dpt, dpt1-dpt);
     FilterCTRLA(dpt, dpt1-dpt);
     fwrite(dpt, sizeof(char), dpt1-dpt, mailfp);
    EndIf
    else{
     if(fflag){
      FilterSoftCR(fpt, fpt1-fpt);
      FilterCTRLA(fpt, fpt1-fpt);
      fwrite(fpt, sizeof(char), fpt1-fpt, stdout);
     EndIf
     else{
      fprintf(stderr, "WARNING: Message without Origin line.\n");
     EndElse
    EndElse

    if(!netmail){
     FilterSoftCR(dpt, dpt1-dpt);
     FilterCTRLA(dpt, dpt1-dpt);
     fwrite(dpt, sizeof(char), dpt1-dpt, stdout);
    }

    if(long_message){
     /* Copy temp file to stdout using dpt as buffer */

     while((xcount = fread(dpt, sizeof(char), FUALLOC_SIZE, tmpfp)) > 0)
      if(netmail){
       FilterSoftCR(dpt, xcount);
       FilterCTRLA(dpt, xcount);
       fwrite(dpt, sizeof(char), xcount, mailfp);
      }
      else{
       FilterSoftCR(dpt, xcount);
       FilterCTRLA(dpt, xcount);
       fwrite(dpt, sizeof(char), xcount, stdout);
      }

     fclose(tmpfp);

     if(netmail)
      fclose(mailfp);

     remove(tempname);

    EndIf
    else
     fclose(mailfp);
   EndIf
   else{
    total_dumped++;
    fprintf(stderr, "Message %5d DUMPED (%s)\n", ++total_processed, area);
   EndElse

   /* Copy the existing message up to the top of the buffer */
   if(long_message)
    end_of_message = ftmp1;

   left = count - (end_of_message-cpt+1);
   memmove(cpt, end_of_message+1, left);

   count = read(fileno(stdin), cpt + left, FUALLOC_SIZE - left);

   count += left;

  EndElse

 EndWhile

 fprintf(stderr, "Total Messages Processed : %5d\n", total_processed);
 fprintf(stderr, "Total Messages Copied    : %5d\n", total_copied);
 fprintf(stderr, "Total Messages Dumped    : %5d\n", total_dumped);
 fprintf(stderr, "Total Netmail Mapped     : %5d\n", total_netmail_copied);
 fprintf(stderr, "Total Netmail NOT Mapped : %5d\n", total_netmail_dumped);
 fprintf(stderr, "Processing Speed was %d messages/minute.\n",
	 (total_processed/(1 + time(NULL) - start_time))*60);

 fprintf(logfp, "+TP<%5d> ", total_processed);
 fprintf(logfp, "TC<%5d> ", total_copied);
 fprintf(logfp, "TD<%5d> ", total_dumped);
 fprintf(logfp, "TM<%5d> ", total_netmail_copied);
 fprintf(logfp, "TN<%5d>\n", total_netmail_dumped);

 fprintf(logfp, "+TM<%5d> ",
		  time(NULL)-start_time);

 if(time(NULL)-start_time > 0){
   fprintf(logfp, "SP<%5d>\n",
	   (total_processed/(1 + time(NULL)-start_time))*60);
 EndIf

 t = time(NULL);
 fprintf(logfp, "$FRED-FU STOP @TM=%s", ctime(&t));
 fclose(logfp);

 if(total_copied == 0)
  exit(0);
 else
  exit(1);

EndMain

/*****************************************************/

