/**/
/***************************************************/
/*                                                 */
/*                     FREDSCAN.C                  */
/*                                                 */
/***************************************************/
/**/

#include <stdio.h>
#include <dir.h>
#include <dos.h>
#include <fcntl.h>
#include <process.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

#include "version.h"
#include "fred.h"

void WriteCmdXQTFilesNews(char *, char *, char *, char *);

void main(int argc, char *argv[])
{
 struct ffblk ffblk;
 int done, for_me, result, cunbatch, batch_empty;
 FILE *in, *cffp, *log;
 unsigned char *outbound_path, *spool_path, *temp_path, *buffer;
 char *logfile;
 char pathname[256], sub_path[256], temp_pathname[256];
 char inbname[256];
 char tmpname[256], filename[256], dfile[256];
 char temp_pathname_z[256], number[18];
 int config_file_flag, host_name_flag, delete_flag, ct;
 int address_flag;
 int delete_files;
 char *config_file, *host_name, *delete, *address;
 char *system, ext[5];
 char *f1, *f2, *f3, *f4, *f5, *str_dup;
 char *abits, seq[5], *uucpname;
 int nbits, site_flag, count, other;
 struct PktHeader *PktHeader;
 struct nodeaddr nodeaddr;
 unsigned int sequence;
 int NoZone = 0, UseLarge = 0;
 char FredCmd[32];
 time_t t;

 fprintf(stderr,"* FredScan Version %s ", FSVERSION);
 fprintf(stderr,"Built %s at time %s *\n", __DATE__, __TIME__);
 fprintf(stderr,"* Copyright 1990, 1991 J. W. Hance - ");
 fprintf(stderr,"All Rights Reserved *\n");

 if(argc < 9){
  fprintf(stderr, "\nUsage: FREDSCAN -c <config> -a <address> -h <host> -d <DELETE|NODELETE> -NoZone\n");
  fprintf(stderr, "Example: FREDSCAN -c config.fil -a 1:231/270.0 -h mgcind -d DELETE\n");
  fprintf(stderr, "where:   config is the configuration file\n");
  fprintf(stderr, "         address is the FidoNet address to scan\n");
  fprintf(stderr, "         host is the uucp host to build for\n");
  fprintf(stderr, "         DELETE will delete processed packets\n");
  fprintf(stderr, "         NODELETE will save processed packets\n");
  fprintf(stderr, "         -NoZone will ignore the ZONE in the PACKET address\n");
  exit(1);
 }

 /**/
 /* Sift out command line options */
 /**/
  delete_flag = config_file_flag = host_name_flag = address_flag = 0;
  site_flag = batch_empty = 0;
  strcpy(ext, ".HUT");

  /* Look for the config file name */
  for(ct = 1; ct < argc; ct++){
   if(strcmpi(argv[ct], "-c") == 0){
    if(config_file_flag){
     fprintf(stderr, "ERROR: Redundant '-c' switches\n");
     exit(1);
    }

    else{
     config_file = malloc(strlen(argv[++ct])+1);
     strcpy(config_file, argv[ct]);
     config_file_flag++;
    }
   }

   /* Look for the host name */
   else if(strcmpi(argv[ct], "-h") == 0){
    if(host_name_flag){
     fprintf(stderr, "ERROR: Redundant '-h' switches\n");
     exit(1);
    }

    else{
     host_name = malloc(strlen(argv[++ct])+1);
     strcpy(host_name, argv[ct]);
     host_name_flag++;
    }
   }

   /* See about the NoZone flag */
   else if(strcmpi(argv[ct], "-nozone") == 0){
    NoZone = 1;
    fprintf(stderr, "NoZone specified - ZONE will be ignored on PACKETS\n");
   }

   /* Look for the address */
   else if(strcmpi(argv[ct], "-a") == 0){
    if(address_flag){
     fprintf(stderr, "ERROR: Redundant '-a' switches\n");
     exit(1);
    }

    else{
     address = malloc(strlen(argv[++ct])+1);
     strcpy(address, argv[ct]);
     address_flag++;
     if(VerifyNode(address, &nodeaddr) == -1){
      fprintf(stderr, "ERROR: %s is an invalid address.\n", address);
      exit(1);
     }
    }
   }

   /* Look for the -d flag */
   else if(strcmpi(argv[ct], "-d") == 0){
    if(delete_flag){
     fprintf(stderr, "ERROR: Redundant '-d' switches\n");
     exit(1);
    }
    else{
     delete = malloc(strlen(argv[++ct])+1);
     strcpy(delete, argv[ct]);
     delete_flag++;
     if(strcmpi(delete, "DELETE") == 0)
      delete_files = 1;
     else
      delete_files = 0;
    }
   }

  } /* End For */

 /* Done processing command line options */

 /**/
 /* Now process the configuration file */
 /**/

 /* Try to open config file */
 cffp = fopen(config_file, "r");
 if(cffp == NULL){
  fprintf(stderr, "ERROR: Can't open config file: %s\n", config_file);
  exit(1);
 }

 buffer = malloc(128);

 f1 = malloc(64);
 f2 = malloc(64);
 f3 = malloc(64);
 f4 = malloc(64);
 f5 = malloc(64);

 while(fgets(buffer, 128, cffp) != NULL){

  /* See if it is a comment */
  if(*buffer == '#') continue;

  /* Otherwise look for interesting config statements */

  sscanf(buffer, "%s %s %s %s %s", f1, f2, f3, f4, f5);

  /* Find where the temp files go */
  if(strcmpi(f1, "tempdir") == 0){
   temp_path = malloc(strlen(f2)+1);
   strcpy(temp_path, f2);
   continue;
  }

  /* Look for UseLarge */
  if(strcmpi(f1, "uselarge") == 0){
   UseLarge = 1;
   continue;
  }

  /* Where to find the packets */
  if(strcmpi(f1, "outbound") == 0){
   outbound_path = malloc(strlen(f2)+1);
   strcpy(outbound_path, f2);
   continue;
  }

  /* The uucpname of this system */
  if(strcmpi(f1, "uucpname") == 0){
   uucpname = malloc(strlen(f2)+1);
   strcpy(uucpname, f2);
   continue;
  }

  /* What kind of system are we running */
  if(strcmpi(f1, "scanfornews") == 0){
   system = malloc(strlen(f2)+1);
   strcpy(system, f2);
   if(strcmpi(system, "qmail") == 0)
    other = 0;
   else
    other = 1;
   continue;
  }

  /* Look for a SITE line that matches the one specified */
  if(strcmpi(f1, "site") == 0){
   if(strcmpi(f2, host_name) == 0){
    site_flag++;
    nbits = atoi(f4);
    abits = malloc(strlen(f4) + 1);
    strcpy(abits, f4);
    if(strcmpi(f5, "cunbatch") == 0)
     cunbatch = 1;
    else
     cunbatch = 0;
    continue;
   }
  }

  /* Where the spool files are */
  if(strcmpi(f1, "spool") == 0){
   spool_path = malloc(strlen(f2)+1);
   strcpy(spool_path, f2);
   continue;
  }

  /* Get the extension of the PACKET to look for */
  if(strcmpi(f1, "extofhold") == 0){
    if(strlen(f2) > 4)
     fprintf(stderr, "ExtOfHold '%s' is too long (4 chars MAX)\n", f2);
    else{
     strcpy(ext, f2);
     fprintf(stderr, "--> ExtOfHold is set to '%s'\n", ext);
    }
  }

  /* Get the logfile */
  if(strcmpi(f1, "logfile") == 0){
   logfile = malloc(strlen(f2)+1);
   strcpy(logfile, f2);

   /* Try to open the logfile */
   log = fopen(logfile, "a");
   if(log == NULL){
    fprintf(stderr, "ERROR: Can't open LOGFILE %s.\n", logfile);
    exit(4);
   }
   else{
    t = time(NULL);
    fprintf(log, "\n#FREDSCAN START @TM=%s+<AD=%s><HS=%s><CF=%s><NZ=%d><DF=%d>\n",
                                                               ctime(&t),
                                                               address,
                                                               host_name,
                                                               config_file,
                                                               NoZone,
                                                               delete_files);
   }
   continue;
  }
 }

 fclose(cffp);

 if(site_flag)
  if(nbits)
   fprintf(stderr, "-- Site %s uses %d bit Compression\n", host_name, nbits);
  else
   fprintf(stderr, "-- Site %s uses NO Compression\n", host_name);
 else
  fprintf(stderr, "-- Site %s not in config file - assuming NO Compression\n",
		   host_name);

 /* Done Reading Configuration file */

 fprintf(log, "+USELARGE=%d ", UseLarge);
 fprintf(log, "SYSTEM=%s ", system);

 if(site_flag)
  fprintf(log, "SITE=%s BITS=%d\n", host_name, nbits);
 else
  fprintf(log, "SITE=%s NOCONFIG\n", host_name);

 if(other){

  fprintf(log, "+SYSCALL %s - ", system);

  fprintf(stderr, "-- Running External Interface: %s\n", system);

  result = spawnlp(P_WAIT, system, system,
			   "-c",
			   config_file,
			   "-p",
			   outbound_path,
			   "-a",
			   address,
			   "-d",
			   delete,
               "-z",
               itoa(NoZone, number, 10),
			   NULL);

  fprintf(log, "SYSRET %d\n", result);

  /* Check the result code from FREDEXT */
  if(result == 0){
   fprintf(stderr, "-- %s reports no files.\n", system);
   fprintf(stderr, "-- Scanning PACKET directory\n");
  EndIf
  else if(result == 255){
   fprintf(stderr, "ERROR: %s returned ERROR.\n", system);
   exit(2);
  EndIf
  else if(result == -1){
   fprintf(stderr, "ERROR: spawnlp() can't invoke %s.\n", system);
   fprintf(stderr, "       Check your PATH variable and/or existance.\n");
   exit(2);
  EndIf

 EndIf

 strcpy(pathname, outbound_path);

 strcpy(sub_path, pathname);

 strcat(pathname, "*");
 strcat(pathname, ext);

 /* pathname has a filename like d:\file\outbound\*.hut */
 fprintf(stderr, "-- Looking for %s\n", pathname);
 done = findfirst(pathname, &ffblk, 0);

 PktHeader = malloc(sizeof(struct PktHeader));

 while(done == 0){
  for_me = 0;

  /* Look at the file that was found */
  strcpy(filename, sub_path);
  strcat(filename, ffblk.ff_name);

  in = fopen(filename, "rb");

  Read_It:
  count = fread(PktHeader, sizeof(struct PktHeader), 1, in);
  if(count != 1){
   fprintf(stderr, "ERROR: Can't read file %s.\n", filename);
   exit(2);
  EndIf

  fclose(in);

  if(((PktHeader->DestZone == nodeaddr.zone) || NoZone) &&
      (PktHeader->DestNet  == nodeaddr.net ) &&
      (PktHeader->DestNode == nodeaddr.node)){

   for_me = 1;
   fprintf(stderr, "-- Found Packet %s -> %d:%d/%d\n", filename,
           PktHeader->DestZone, PktHeader->DestNet, PktHeader->DestNode);
  }

  /**/
  /* Feed the packet to Fred-Fu */
  /**/

  if(for_me){
   strcpy(pathname, sub_path);

   printf("Invoking Fred-Fu...\n");
   strcpy(temp_pathname, temp_path);
   strcat(temp_pathname, "tempnews");

   /* Get the sequence number from the sequence file */
   sequence = GetSequenceNumber();
   sprintf(seq, "%04d", sequence);

   strcpy(tmpname, spool_path);
   strcat(tmpname, host_name);
   strcat(tmpname, "\\");
   strcat(tmpname, "FR");
   strcat(tmpname, seq);
   strcat(tmpname, ".DAT");


   /* Attach the packet found to stdin */
   if(freopen(filename, "rb", stdin) == NULL){
    fprintf(stderr, "ERROR: Can't open %s.\n", filename);
    fprintf(log, "!FREDSCAN/freopen()/%s\n", filename);
    exit(1);
   }

   if(freopen(nbits ? temp_pathname : tmpname, "w", stdout) == NULL){
    fprintf(stderr, "ERROR: Can't open %s.\n",
		     nbits ? temp_pathname : tmpname);
    fprintf(log, "!FREDSCAN/freopen()/%s\n",
		  nbits ? temp_pathname : tmpname);
    exit(1);
   }

    fclose(log);

    if(UseLarge)
     strcpy(FredCmd, "Fred-Ful");
    else
     strcpy(FredCmd, "Fred-Fu");

    result = spawnlp(P_WAIT, FredCmd, FredCmd, "-c", config_file, NULL);

   log = fopen(logfile, "a");

   if(result == 0){
    fprintf(stderr, "-- Deleting empty batch file %s.\n",
		     nbits ? temp_pathname : tmpname);
    fprintf(log, "+DELETE_EMPTY %s\n", tmpname);

    remove(nbits ? temp_pathname : tmpname);
    batch_empty = 1;
   }
   else if(result == 1){
    fprintf(stderr, "-- %s reports NORMAL exit.\n", FredCmd);
    WriteCmdXQTFilesNews(spool_path, host_name, seq, uucpname);
   EndIf
   else if(result == -1){
    fprintf(stderr, "ERROR: spawnlp() can't invoke %s.\n", FredCmd);
    fprintf(stderr, "       Check your PATH variable and/or existance.\n");
    exit(2);
   EndIf
   else{
    fprintf(stderr, "-- %s reports ABNORMAL exit (%d)\n", FredCmd, result);
    fprintf(log, "!ERRCD %d\n", result);
    str_dup = strdup(filename);
    *(str_dup + strlen(filename) - 3) = NULL;
    strcat(str_dup, "BAD");
    fprintf(log, "!RENAME %s\n", str_dup);
    rename(filename, str_dup);
    free(str_dup);
    done = findnext(&ffblk);
    continue;
   }

   if(freopen("CON", "r", stdin) == NULL){
    fprintf(stderr, "ERROR: ??.\n");
    exit(1);
   }

   if(freopen("CON", "w", stdout) == NULL){
    fprintf(stderr, "ERROR: ??.\n");
    exit(1);
   }

   /* Now run COMPRESS if specified */
   if((nbits != 0) && (batch_empty != 1)){
    /* Attach the generated file to stdin */
    if(freopen(temp_pathname, "r", stdin) == NULL){
     fprintf(stderr, "ERROR: Can't open %s.\n", temp_pathname);
     fprintf(log, "!FREDSCAN/freopen()/%s\n", temp_pathname);
     exit(1);
    EndIf

    if(freopen(tmpname, "wb", stdout) == NULL){
     fprintf(stderr, "ERROR: Can't open %s.\n", tmpname);
     fprintf(log, "!FREDSCAN/freopen()/%s\n", tmpname);
     exit(1);
    EndIf

     if(cunbatch){
      fprintf(stdout, "#! cunbatch");
      fputchar(LF);
      fflush(stdout);
      setmode(fileno(stdin), O_TEXT);
     EndIf

     fprintf(stderr, "-- CompressBits = %s\n", abits);
     fprintf(log, "+COMPTO <F=%s> <BITS=%s>\n", tmpname, abits);

     result = spawnlp(P_WAIT, "compress.exe",
			      "compress.exe",
			      "-v",
			      "-b",
			      abits,
			      NULL);

    if(result == -1){
     fprintf(stderr, "ERROR: spawnlp() can't invoke Compress.Exe.\n");
     fprintf(stderr, "       Check your PATH variable and/or existance.\n");
     exit(2);
    EndIf

    WriteCmdXQTFilesNews(spool_path, host_name, seq, uucpname);

    if(freopen("CON", "r", stdin) == NULL){
     fprintf(stderr, "ERROR: ??.\n");
     exit(1);
    EndIf

    if(freopen("CON", "w", stdout) == NULL){
     fprintf(stderr, "ERROR: ??.\n");
     exit(1);
    EndIf

    remove(temp_pathname);

   EndIf


   /* Delete packet file if delete is specified */
   if(delete_files){
    fprintf(stderr, "Deleting %s.\n", filename);
    remove(filename);
   }

  }

  done = findnext(&ffblk);
 EndWhile

 fprintf(stderr,"-- FredScan done...\n");
 t = time(NULL);
 fprintf(log, "$FREDSCAN STOP @TM=%s\n", ctime(&t));
 fclose(log);


}

/**/
/* Verify and separate the fields in the NODE address */
/**/

int VerifyNode(char *string, struct nodeaddr *n)
{
 if(sscanf(string, "%d:%d/%d.%d", &n->zone, &n->net, &n->node, &n->point) != 4)
  return -1;
 else
 return 0;
}

/**/
/* Get the next sequence number from the file */
/**/

unsigned int GetSequenceNumber(void)
{

 FILE *seqfp;
 unsigned int sequence;

    /* Open the sequence file, read and increment the value */
    if((seqfp = fopen("./sequence", "r")) != NULL){
     if(fscanf(seqfp, "%d", &sequence) == 1){
      fclose(seqfp);
      if((seqfp = fopen("./sequence", "w")) != NULL){

       if(sequence == 10000) sequence = 0;

       fprintf(seqfp, "%d", sequence+1);
       fclose(seqfp);
      EndIf
      else{
       fprintf(stderr, "ERROR: Can't open sequence file for write.\n");
       exit(2);
      EndElse
     EndIf
     else{
      fprintf(stderr, "ERROR: Couldn't get value from sequence file.\n");
      exit(2);
     EndElse
    EndIf
    else{
     fprintf(stderr, "ERROR: Can't open sequence file.\n");
     exit(2);
    EndElse

    return sequence;
}

/**/
/* Write out the necessary files */
/**/

void WriteCmdXQTFilesNews(char *spoolpath, char *system,
			  char *seq, char *mysystem)
{
 FILE *fp;
 char *filename;


 filename = malloc(strlen(spoolpath)+strlen(system)+12);

 strcpy(filename, spoolpath);
 strcat(filename, system);
 strcat(filename, "/");
 strcat(filename, "FR");
 strcat(filename, seq);
 strcat(filename, ".CMD");

 fp = fopen(filename, "w");
 if(fp == NULL){
  fprintf(stderr, "ERROR: Can't open %s.\n", filename);
  exit(2);
 EndIf

 fprintf(fp, "S FR%s.DAT D.%s%s uucp - FR%s.DAT 0666\n", seq,
	      system, seq, seq);

 fprintf(fp, "S FR%s.XQT X.%s%s uucp - FR%s.XQT 0666\n", seq,
	      system, seq, seq);
 fclose(fp);

 strcpy(filename, spoolpath);
 strcat(filename, system);
 strcat(filename, "/");
 strcat(filename, "FR");
 strcat(filename, seq);
 strcat(filename, ".XQT");

 fp = fopen(filename, "wb");
 if(fp == NULL){
  fprintf(stderr, "ERROR: Can't open %s.\n", filename);
  exit(2);
 EndIf

 fprintf(fp, "N\n");
 fprintf(fp, "U news %s\n", mysystem);
 fprintf(fp, "F D.%s%s\n", system, seq);
 fprintf(fp, "I D.%s%s\n", system, seq);
 fprintf(fp, "C rnews\n");

 fclose(fp);


 free(filename);

}
