/* $Header:   C:/SRC/MOUSE/PVCS/GMOUSCUR.H_V   1.1   12 Jun 1989 21:38:48  $
	Dwight N. Tovey  (Adapted from the July/August 1988 issue of TURBO TECHNIX.

	Include file defining several graphics mouse cursor patterns.  All are
	statics.
	This file also contains an even handler called by the mouse device driver,
	and a global event record variable 'theEvents'
----------------------------------------------------------------------------
$Log:   C:/SRC/MOUSE/PVCS/GMOUSCUR.H_V  $
   
      Rev 1.1   12 Jun 1989 21:38:48
   Moved initialization routine out of definition file into main
   program.
   
   
      Rev 1.0   21 May 1989  6:58:38
   Initial revision.
*/
#ifndef	GMOUSCUR_H
#define	GMOUSCUR_H

#ifndef  NULL
#define  NULL  0
#endif

typedef struct {						  	/* mouse event record */
	unsigned flag, button, col, row;
	}EVENTREC;

typedef struct {							/* graphics cursor descriptor */
	unsigned *image;
	unsigned hotX, hotY;
	}GCURSREC;

/* check mark image */
static unsigned checkIm [32] = {
	0xFFF0, 0xFFE0, 0xFFC0, 0xFF81,			/* screen mask */
	0xFF03, 0x0607, 0x000F, 0x001F,
	0xC03F, 0xF07F, 0xFFFF, 0xFFFF,
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
	0x0000, 0x0006, 0x000C, 0x0018,			/* cursor mask */
	0x0030, 0x0060, 0x70C0, 0x1D80,
	0x0700, 0x0000, 0x0000, 0x0000,
	0x0000, 0x0000, 0x0000, 0x0000 };

/* left arrow image */
static unsigned LArrIm [32] = {
	0xFE1F, 0xF01F, 0x0000, 0x0000,			/* screen mask */
	0x0000, 0xF01F, 0xFE1F, 0xFFFF,
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
	0x0000, 0x00C0, 0x07C0, 0x7FFE,			/* cursor mask */
	0x07C0, 0x00C0, 0x0000, 0x0000,
	0x0000, 0x0000, 0x0000, 0x0000,
	0x0000, 0x0000, 0x0000, 0x0000 };

/* cross image */
static unsigned crossIm [32] = {
	0xFC3F, 0xFC3F, 0xFC3F, 0x0000,			/* screen mask */
	0x0000, 0x0000, 0xFC3F, 0xFC3F,
	0xFC3F, 0xFFFF, 0xFFFF, 0xFFFF,
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
	0x0000, 0x0180, 0x0180, 0x0180,			/* cursor mask */
	0x7FFE, 0x0180, 0x0180, 0x0180,
	0x0000, 0x0000, 0x0000, 0x0000,
	0x0000, 0x0000, 0x0000, 0x0000 };

/* pointing hand image */
static unsigned handIm [32] = {
	0xE1FF, 0xE1FF, 0xE1FF, 0xE1FF,         /* screen mask */
	0xE1FF, 0xE000, 0xE000, 0xE000,
	0x0000, 0x0000, 0x0000, 0x0000,
	0x0000, 0x0000, 0x0000, 0x0000,
	0x1E00, 0x1200, 0x1200, 0x1200,			/* cursor mask */
	0x1200, 0x13FF, 0x1249, 0x1249,
	0x1249, 0x9001, 0x9001, 0x9001,
	0x8001, 0x8001, 0x8001, 0xFFFF };

/* I-beam image */
static unsigned iBeamIm [32] = {
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,			/* screen mask */
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
	0xF00F, 0x0C30, 0x0240, 0x0240,
	0x0180, 0x0180, 0x0180, 0x0180,
	0x0180, 0x0180, 0x0180, 0x0180,
	0x0240, 0x0240, 0x0C30, 0xF00F };


/* Graphics cursor descriptors */
static GCURSREC check = { NULL, 6, 7 };
static GCURSREC arrow = { NULL, 0, 3 };
static GCURSREC cross = { NULL, 7, 4 };
static GCURSREC hand  = { NULL, 5, 0 };
static GCURSREC iBeam = { NULL, 7, 7 };


/*---------------------------------------------------------------*/


#endif	/* GMOUSCUR_H */

