/************************************************************************/
/*																		*/
/*		H S A _ G R . H  -  Define HSA_GRAF display routines			*/
/*																		*/
/************************************************************************/

/************************************************************************/
/*																		*/
/*		Copyright (c) Hardwood Software Associates, 1986				*/
/*																		*/
/************************************************************************/

/*************************************************************************
 *				H S A _ G R . H   E D I T   L O G 
 *
 *		Edit	Date	Person			Modification
 *		----	----	------			------------
 *
 ************************************************************************/

#ifndef GR_
#define GR_

#ifndef HSA_ATTRIBUTES
#define HSA_ATTRIBUTES
#define SCR_BASE 0xB000							/* Screen memory base address */
												/* Monochrome Attributes */
#define SCR_NORM 0x7							/* Normal characters */
#define SCR_BOLD 0xF							/* Bold characters */
#define SCR_BLINK 0x87							/* Blinking characters */
#define SCR_REVERSE 0x70						/* Reverse video characters */
#define SCR_UNDER 1								/* Underlined characters */
#define SCR_B_B 0x8F							/* Blinking bold characters */
#define SCR_B_U 0x9								/* Blinking underlined characters */
												/* Colors */
#define SCR_BLACK	0x0
#define SCR_BLUE	0x1
#define SCR_GREEN	0x2
#define SCR_CYAN	0x3
#define SCR_RED		0x4
#define SCR_MAGENTA	0x5
#define SCR_YELLOW	0x6
#define SCR_WHITE	0x7

#define SCR_INTENSE_BIT	0x08					/* Intensty bit */
#define SCR_BLINK_BIT	0x80					/* Bold bit */
												/* Create attribute byte */
#define MAKE_ATTR(fore,back)	(((back)<<4) | (fore))
												/* CRT states */
#define MONOCHROME	0x7
#define CGA			0x6
#define EGA			0x10
#endif

#ifdef LINT_ARGS
disp_graph ();
disp_text();
g_page ();
g_scale ();
g_msg_h ();
g_clr ();
g_point ();
g_line ();
gs_point ();
gs_line ();
gs_loc ();
g_loc ();
g_mode();
void g_solid (void);
void g_dash (void);
void g_dot (void);
void g_set_line (unsigned int);
gs_arc ();
char *g_gets (char *);
#else
disp_graph ();
disp_text();
g_page ();
g_scale ();
g_msg_h ();
g_clr ();
g_point ();
g_line ();
gs_point ();
gs_line ();
gs_loc ();
g_loc ();
g_mode();
void g_solid ();
void g_dash ();
void g_dot ();
void g_set_line ();
char *g_gets ();

gs_arc ();

#endif
#endif



