/*

 Compile this program under large model, with the
 default compiler options and link it with these libs:

 WindowPro large model library,
 DialogPro large model library, and
 HypeIt!   large model library

 Also, you should note that the HypeIt! libs contain some
 minor revisions to both WindowPro and DialogPro routines
 and therefore should be included as the first lib to
 be linked in order to supercede the older versions of
 certain functions contained in the WindowPro and DialogPro
 libs.

*/

#include "hypeit.h"

/*
stack requirements are generally dependent on the maximum number
of connectors allowed in each node. (defined by MAXDEFS.)

In this case we used a MAXDEFS of 35.  When we invoked hypeit
from within hypeit we ran out of stack space -- so we had to
increase it somewhat.  If you are using MS C you will need to
increase stack size at link time.
*/
#ifdef __TURBOC__
unsigned _stklen = 5000;
#endif

main(argv, argc)
int argv;
char *argc[];
{
    char *t, *i, t1[20], i1[20];

    if (argv == 1) {
       t = "hypeit.txt";
       i = "hypeit.idx";
    }
    else {
         sprintf(t1,"%s.txt",argc[1]);
         sprintf(i1,"%s.idx",argc[1]);
         t = t1;
         i = i1;
    }

    /* initializes the windowing, dialog box and help systems */
	init_help(t, i);

    /* If you are using DialogPro you would go on and establish */
    /* your dialog boxes and windows and register each dialog box */
    /* with the help system, whenever the user pressed F1 it would */
    /* enter HypeIt! by calling dispnode with the appropriate text */
    /* id given the context that the F1 key was in when it was */
    /* pressed.   In this case, since we don't really have a real */
    /* application we bypass the built in help system and go */
    /* directly to our main text node. */
	dispnode(TOPICSNODE);
}
