/* ------------------------ context sensitive help ---------------------- */
#define FIXED		0
#define INDEXED		1
#define IDXDB		2
#define IDXLIST		3

#define MAXHELP     100

typedef struct {
	void *id;
	char db_idx;
	unsigned help_id;
} HELP_CONTEXT;

extern unsigned helptable_nelem;
extern HELP_CONTEXT help_context[MAXHELP];
extern char all_avail[255];


/*---------------------------- node display stuff --------------------------*/
extern void dispnode(unsigned);

#define MAXLINELEN			120
#define MAXDEFS				35
#define TOPICSNODE			9999
#define KEYSNODE			12000
#define INITX				6
#define INITY				3
#define ROWS				19
#define COLUMNS				60
#define INIT_TITLE			"Hypeit! "
#define HELP_TITLE			"Hypeit! Tutorial "
#define NODE_ID_CHAR		'^'
#define KEYWORD_CHAR		'!'
#define END_OF_NODE			"#\n"
#define FOREGROUND			lightgray
#define BACKGROUND			black
#define NUMELEM(a)			(sizeof(a)/sizeof(a[0]))

extern char *textfilename;
extern char *indexfilename;

/*-------------------------- error message display -------------------------*/
extern int problem(char *);

/*-------------------------- invoke via F1 key ------------------------------*/
extern unsigned *help_macros[2];

extern void register_help_macros(void);
extern void init_help(char *, char *);

#define HELP_KEY		XF1

extern int register_help(void *,char,unsigned);
extern int compare_dbs(const void *, const void *);

/*--------------------------- error messages --------------------------------*/
#define MISSING_HELPFILE						0
#define MISSING_HELPIDX							1
#define NO_TEXT_NODE							2
#define NUMSTRINGS								3

extern char *strings[NUMSTRINGS];
