//==============================================================================================
//
//	Microdyne Libraries for the Object Windows Libraries
//	Version 1.00
//
//	IBUTTON.H - Icon Bar Button Class
//	Copyright  1993 by Microdyne Development Technologies.
//	All rights reserved.
//==============================================================================================

#ifndef __IBUTTON_H
#define __IBUTTON_H

#ifndef __BUTTON_H
#include <button.h>
#endif

#include "wics.h"

#pragma option -Vo-

_CLASSDEF(TIconBarButton)

class _EXPORT TIconBarButton : public TButton
{
public:
	TIconBarButton(PTWindowsObject AParent, int AnId, int X, int Y, BOOL fState = FALSE, PTModule AModule = NULL);
	TIconBarButton(PTWindowsObject AParent, int ResourceId, PTModule AModule = NULL);
	static PTStreamable build();

	virtual int  GetControlLength () { return Attr.W; }
	virtual void SetCommandCode (WORD cmd) { SendMessage(HWindow, WM_USER+102, (WPARAM) cmd, 0L); }
	virtual void SetPicture (HBITMAP hBitmap, WORD state, BOOL fRedraw)
		{ SendMessage (HWindow, WM_USER+100, (WPARAM) hBitmap, MAKELPARAM(state, fRedraw)); }
	virtual void StopRepeat () { SendMessage(HWindow, WM_USER+101, 0, 0L); } ;

protected:
	virtual LPSTR GetClassName() { return "WICSButton"; }
	TIconBarButton(StreamableInit) : TButton(streamableInit) {};

private:
	virtual const Pchar streamableName() const { return "TIconBarButton"; }
};

inline Ripstream operator >> ( Ripstream is, RTIconBarButton cl )
	{ return is >> (RTStreamable)cl; }
inline Ripstream operator >> ( Ripstream is, RPTIconBarButton cl )
	{ return is >> (RPvoid)cl; }

inline Ropstream operator << ( Ropstream os, RTIconBarButton cl )
	{ return os << (RTStreamable)cl; }
inline Ropstream operator << ( Ropstream os, PTIconBarButton cl )
	{ return os << (PTStreamable)cl; }

#pragma option -Vo.

#endif
