/*
**	INT15DEF.H - definitions.
**	IBM Personal Computer - TopView C Interface Header File.
**	Written for Borland Turbo C v1.5.
*/

/* Subroutine Call Function Code Equates: */

#define PAUSE			0	/* Pause */
#define PRINTC			3	/* Print Character/Attribute */
#define GETBIT			19	/* Allocate a 2nd Level Interrupt Bit */
#define FREEBIT			20	/* Deallocate a 2nd Level Interrupt Bit */
#define SETBIT			21	/* Post a 2nd Level Interrupt Bit */
#define ISOBJ			22	/* Check for valid object */
#define LOCATE			24	/* Locate a Window */
#define SOUND			25	/* Make a Sound */
#define OSTACK			26	/* Set system stack */
#define BEGINC			27	/* Begin Critical Section */
#define ENDC 			28	/* End Critical Section */
#define STOP 			29	/* Stop Task */
#define START			30	/* Start Task */
#define DISPEROR		31	/* Display Error Message */
#define PGMINT			33	/* Program Interrupt */
#define GETVER			34	/* Get Current Version */
#define POSWIN			35	/* Position Window */
#define GETBUF			36	/* Get Logical Window Buffer */
#define USTACK			37	/* Set User Stack */

/* Predefined Message Numbers: */

#define OBJECT_MSG		0	/* Return Object Handle */
#define NEW_MSG			1	/* Create New Object */
#define FREE_MSG		2	/* Free Object */
#define ADDR_MSG		3	/* Return Handle of Object */
#define DIR_MSG			3	/* Get Panel File Directory */
#define READ_MSG		4	/* Return Next Logical record (I/O) */
#define APPLY_MSG		4	/* Apply Panel to Window Object */
#define WRITE_MSG		5	/* Write String to Object */
#define SIZE_MSG		8	/* Return Size of Object */
#define LEN_MSG			9	/* Return Length of Object */
#define ADDTO_MSG		10	/* Add To Value of Object */
#define SUBFROM_MSG		11	/* Subtract From Value of Object */
#define OPEN_MSG		12	/* Open Object for Use (I/O) */
#define CLOSE_MSG		13	/* Close Object (I/O) */
#define ERASE_MSG		14	/* Erase Object (I/O) */
#define STATUS_MSG		15	/* Return Status of Object (I/O) */
#define EOF_MSG			16	/* Return Object End of File Status (I/O) */
#define AT_MSG			17	/* Position Object Cursor (I/O) */
#define SETSCALE_MSG	17	/* Set Pointer Scale Factor */
#define READN_MSG		18	/* Return Next n Byte from Object (I/O) */
#define GETSCALE_MSG	18	/* Get Pointer Scale Factor */
#define REDRAW_MSG		19	/* Redraw Object (WINDOW) */
#define SETICON_MSG		19	/* Specify Pointer Icon */
#define SETESC_MSG		20	/* Define User Escape */

/* Object Modifiers: */

#define TOS				0	/* Use Contents of Top of Stack as Object */
#define ME				1	/* Use Requesting Task's WINDOW as Object */
#define MAILTOS			2	/* Use MAILBOX(tos) as Object */
#define MAILME			3	/* Use MAILBOX(me) as Object */
#define KEYTOS			4	/* Use KEYBOARD(tos) as Object */
#define KEYME			5	/* Use KEYBOARD(me) as Object */
#define OBJQTOS			6	/* Use OBJECTQ(tos) as Object */
#define OBJQME			7	/* Use OBJECTQ(me) as Object */
#define WINDOW_CLASS	8	/* Use WINDOW Class as Object */
#define MAILBOX_CLASS	9	/* Use MAILBOX Class as Object */
#define KEYBOARD_CLASS	10	/* Use KEYBOARD Class as Object */
#define TIMER_CLASS		11	/* Use TIMER Class as Object */
#define POINTER_CLASS	15	/* Use POINTER Class as Object */
#define PANEL_CLASS		16	/* Use PANEL Class as Object */

/* Logical Text Attributes: */

#define NORMAL			1
#define NORMAL_HILITE	2
#define HELP			3
#define HELP_HILITE		4
#define ERROR			5
#define ERROR_HILITE	6
#define EMPHASIZED		7
#define MARK			8

/* end INT15DEF.H */
