/*
 ****************************************************************
 *                        ISAMP.H                               *
 *      isam header file for programs using the isam library    *
 ***************************************************************/

#define DUPKEY  1                       /* duplicate key error */
#define IRE     2                       /* Index read error */
#define IWE     3                       /* Index write error */
#define ICE     4                       /* Index close error */
#define KNF     5                       /* Key not found */
#define INV     6                       /* Index not valid */
#define NEM     7                       /* Not enough memory for open */
#define FNF     8                       /* File not found on open */
#define INE     9                       /* Index is empty */
#define CCF     10                      /* Cannot create file */

#ifndef EOF
#define EOF     -1
#endif

 /***************************************************************
 *      Define ERRMSG with -d to define error messages          *
 ***************************************************************/

#ifdef  ERRMSG

char    *isamer[]={
                "",
                "Duplicate Key Error.",
                "Index Read Error.",
                "Index Write Error.",
                "Index Close Error.",
                "Key Not Found.",
                "Index Not Valid.",
                "Not Enough Memory.",
                "File Not Found.",
                "Index is Empty.",
                "Cannot Create File."
};
#endif
