/*

LANGUAGE.C was created using CTEXT(C) V1.0.0
(C) Copyright 1990 by Bill Buckels

CTEXT(C) converts ascii documents to executable C language Source Code

This Source File Format was developed using Mix Power C Version 2.0
and Has also Been Tested Successfully
With Turbo C Version 2.01, Quick C Version 1.01 and Microsoft C Version 5.1

LANGUAGE.C is The C Source Code for the .Exe Version of LANGUAGE.DOC

	Thank you for using CTEXT(C).

	 Bill Buckels,  Starving Programmer
	 982 Hector Avenue
	 Winnipeg, Manitoba, Canada R3M 2G6

	Phone (204) 452-2815
*/

/* color definitions */

#define BLACK     0
#define BLUE      1
#define GREEN     2
#define CYAN      3
#define RED       4
#define MAGENTA   5
#define BROWN     6
#define WHITE     7
#define GRAY      8
#define LBLUE     9
#define LGREEN    10
#define LCYAN     11
#define LRED      12
#define LMAGENTA  13
#define YELLOW    14
#define BWHITE    15

#define ESCKEY     '\x1b' /* character generated by the Esc key            */
#define FUNCKEY    '\x00' /* first character generated by function keys    */
#define UPARROW    'H'    /* second character generated by up-arrow key    */
#define DOWNARROW  'P'    /* second character generated by down-arrow key  */
#define PGUP       'I'    /* second character generated by page up key     */
#define PGDOWN     'Q'    /* second character generated by page down key   */

#define BLANK     32
#define FAT       219
#define SINGLE    1
#define DOUBLE    2

#define CGA 3
#define HERCULES 99
int ADAPTER = CGA;

#include <dos.h>

#undef MK_FP
#undef poke

/* undefine the above if they exist      */
/* all compilers start on equal footing  */

/* macros to poke into memory */
/* dynamically cast a far pointer from segment and offset info */
#define MK_FP(seg,off) ((char far *)(((long)(seg) << 16) | (off)))
/* write an integer at a memory location */
#define poke(a,b,c) (*((int  far*)MK_FP((a),(b))) = (int)(c))


unsigned int biosequip()
{
    union REGS inregs,outregs;

    int86(0x11,&inregs,&outregs); /* get equipment list from the bios */
    return outregs.x.ax;
}



void cursoroff(void)
{
   union REGS regs;

   regs.h.ah = 0x01;
   regs.x.cx = 0x2000;
   int86(0x10,&regs,&regs);
}


void cursoron(void)
{
   union REGS regs;

   regs.h.ah = 0x01;
   regs.x.cx = 0x0607;
   int86(0x10,&regs,&regs);
}


void cls(int BACK,int FRONT)
{
    union REGS reg;

    reg.h.ah = 6;
    reg.h.al = 0;
    reg.h.ch = 0;
    reg.h.cl = 0;
    reg.h.dh = 24;
    reg.h.dl = 79;
    reg.h.bh = (BACK << 4) + FRONT;
    int86(0x10, &reg, &reg);
}


int colorset(bground, palette)
unsigned char bground, palette;
{
    union REGS rin,rout;
    
    if(ADAPTER==HERCULES) return 0;
    rin.h.ah = 11;
    rin.h.bh = 0;
    rin.h.bl = bground;
    int86(0x10,&rin,&rout);
    rin.h.bh = 1;
    rin.h.bl = palette;
    int86(0x10,&rin,&rout);
    return 0;
}




void DMC(int Row, int Column, unsigned BYTE, int BACK, int FRONT, int QUANT)
{
    /*  DMA replacement for writechs function */

    unsigned segment= 0xB000, offset;
    int One_Too_Many = (QUANT+1);
    int i, Attribute;

    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=HERCULES)segment = 0xB800;    /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    for (i=1; i< One_Too_Many ; i++){
        poke(segment,offset, BYTE|Attribute<<8);
        offset+=2;
        }
}


void DMM(char *String, int Row, int Column, int BACK, int FRONT)
{
    /*  DMA replacement for puts
        centre justified string    */

    unsigned Character, segment=0xB000, offset;
    int Attribute;

    Attribute = (BACK << 4) + FRONT;

    Column =   ((Column+1)-(.5*(strlen(String))));

    if(ADAPTER != HERCULES)segment = 0xB800;    /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    while ((Character = *String++)!=0){
        if(Character!='\n'){
        poke(segment,offset,Character|Attribute<<8);
        offset+=2;
        }
        }
}


void DML(char *String, int Row, int Column, int BACK, int FRONT)
{
    /*  DMA replacement for puts
        left justified string    */
    unsigned Character, segment=0xB000, offset;
    int Attribute;

    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=HERCULES)segment = 0xB800; /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    while ((Character = *String++)!=0){
        if(Character!='\n'){
        poke(segment,offset, Character|Attribute<<8);
        offset +=2;
        }
    }
}


void PAINT(int *cor,int bk,int fore,unsigned char Character)
{
   int trow=cor[0],tcol=cor[1],brow=cor[2],bcol=cor[3];
   int index,linelength = ((bcol+1) - (tcol));
   for (index = (trow); index < brow+1; index++)
   DMC(index,tcol,Character,bk,fore,linelength);
}

void BORDERBOX(int *cor,int bk,int fore,unsigned char BRDR)
{

int trow=cor[0],tcol=cor[1],brow=cor[2],bcol=cor[3];
    /* draws an outline only using a specified border character */
int index;
int homecol = (tcol+1);
int linelength = ((bcol) - (tcol+1));

int TLcorner,TRcorner,BLcorner,BRcorner,HORT,VERT;

          switch(BRDR){
               case DOUBLE: {
                            TLcorner = 201;
                            TRcorner = 187;
                            BLcorner = 200;
                            BRcorner = 188;
                            HORT = 205;
                            VERT = 186;
                            break;
                        }
               case SINGLE: {
                            TLcorner = 218;
                            TRcorner = 191;
                            BLcorner = 192;
                            BRcorner = 217;
                            HORT = 196;
                            VERT = 179;
                            break;
                        }
               default:    {
                            TLcorner = BRDR;
                            TRcorner = BRDR;
                            BLcorner = BRDR;
                            BRcorner = BRDR;
                            HORT = BRDR;
                            VERT = BRDR;
                        }
            }
   DMC(trow,tcol,TLcorner,bk,fore,1);         /* top */
   DMC(trow,homecol,HORT,bk,fore,linelength);
   DMC(trow,bcol,TRcorner,bk,fore,1);
   for (index = (trow+1); index < brow; index++){
       DMC(index,tcol,VERT,bk,fore,1);
       DMC(index,bcol,VERT,bk,fore,1);
       }
   DMC(brow,tcol,BLcorner,bk,fore,1);
   DMC(brow,homecol,HORT,bk,fore,linelength);
   DMC(brow,bcol,BRcorner,bk,fore,1);        /* bottom */
}



void getadaptertype(void)
{
    if(((biosequip() >>4) &3) <3)ADAPTER=CGA;
    else ADAPTER=HERCULES;

}

char *WINTALK[]=
{
/* data statements */

/*0   */"The  proliferation of modern programming languages which seem  to ",
/*1   */"have stolen countless features from each other sometimes makes it ",
/*2   */"difficult to remember which language you're using. This guide  is ",
/*3   */"offered as a public service to help programmers in such dilemmas.  ",
/*4   */"     ",
/*5   */"C: ",
/*6   */"",
/*7   */"You shoot yourself in the foot.   ",
/*8   */"",
/*9   */"Assembly:  ",
/*10  */"",
/*11  */"You  crash  the  OS  and overwrite  the  root  disk.  The  system ",
/*12  */"administrator arrives and shoots you in the foot. After a  moment ",
/*13  */"of contemplation, the administrator shoots himself in the foot and ",
/*14  */"then hops around the room rabidly shooting at everyone in sight.  ",
/*15  */"",
/*16  */"APL: ",
/*17  */"",
/*18  */"You  hear  a gunshot, and there's a hole in your  foot,  but  you ",
/*19  */"don't  remember enough linear algebra to understand what the hell ",
/*20  */"happened. ",
/*21  */"",
/*22  */"C++:  ",
/*23  */"",
/*24  */"You  accidently create a dozen instances  of  yourself  and ",
/*25  */"shoot  them all in the foot. Providing emergency medical care  is ",
/*26  */"impossible   since  you can't tell which are bitwise  copies  and ",
/*27  */"which  are just  pointing at others and saying, \"that's me,  over ",
/*28  */"there.\"  ",
/*29  */"",
/*30  */"Ada:  ",
/*31  */"",
/*32  */"If you are dumb enough to actually use this language, the  United  ",
/*33  */"States  Department  of Defense will kidnap you, stand you  up  in ",
/*34  */"front   of a firing squad, and tell the soldiers, \"Shoot  at  his ",
/*35  */"feet.\" ",
/*36  */"",
/*37  */"MODULA-2:  ",
/*38  */"",
/*39  */"After  realizing that you can't actually accomplish anything   in ",
/*40  */"the language, you shoot yourself in the head.  ",
/*41  */"",
/*42  */"Pascal:  ",
/*43  */"",
/*44  */"Same  as  Modula-2,  except the bullets are the  wrong  type  and  ",
/*45  */"won't  pass through the barrel. The gun  explodes.   sh,csh,etc.: ",
/*46  */"You  can't remember the syntax for anything, so you  spend   five ",
/*47  */"hours  reading  man pages before giving up. You  then  shoot  the  ",
/*48  */"computer and switch to C.    ",
/*49  */"",
/*50  */"Smalltalk: ",
/*51  */"",
/*52  */"You  spend so much time playing with the graphics and   windowing ",
/*53  */"system  that your boss shoots you in the foot, takes  away   your ",
/*54  */"workstation,  and  makes  you develop in  COBOL  on  a  character  ",
/*55  */"terminal.     ",
/*56  */"",
/*57  */"FORTRAN:  ",
/*58  */"",
/*59  */"You  shoot yourself in each toe, iteratively, until you run   out ",
/*60  */"of  toes, then you read in the next foot and repeat. If  you  run  ",
/*61  */"out  of  bullets,  you  continue  anyway  because  you  have   no ",
/*62  */"exception-  processing ability.    ",
/*63  */"",
/*64  */"ALGOL:  ",
/*65  */"",
/*66  */"You  shoot  yourself  in the foot with a musket.  The  musket  is  ",
/*67  */"esthetically  fascinating, and the wound baffles  the  adolescent ",
/*68  */"medic  in the emergency room.    ",
/*69  */"",
/*70  */"COBOL: ",
/*71  */"",
/*72  */"USEing  a  COLT45  HANDGUN,  AIM  gun  at  LEG.FOOT,  THEN  place  ",
/*73  */"ARM.HAND.FINGER  on  HANDGUN.TRIGGER, and  SQUEEZE.  THEN  return ",
/*74  */"HANDGUN  to HOLSTER. Check whether shoelace needs to be retied.  ",
/*75  */"",
/*76  */"BASIC:  ",
/*77  */"",
/*78  */"Shoot  self in foot with water pistol. On big  systems,  continue  ",
/*79  */"until entire lower body is waterlogged.   ",
/*80  */"",
/*81  */"PL/I:  ",
/*82  */"",
/*83  */"You  consume  all available system resources, including  all  the  ",
/*84  */"offline bullets. The Data Processing & Payroll Department doubles  ",
/*85  */"its  size, triples its budget, acquires four new mainframes,  and ",
/*86  */"drops  the original one on your foot.   ",
/*87  */"",
/*88  */"SNOBOL: ",
/*89  */"",
/*90  */"You  grab your foot with your hand, then rewrite your hand to  be  ",
/*91  */"a bullet. The act of shooting the original foot then changes your  ",
/*92  */"hand/bullet into yet another foot (a left foot).  ",
/*93  */"",
/*94  */"LISP:  ",
/*95  */"",
/*96  */"You  shoot  yourself in the appendage which holds  the  gun  with  ",
/*97  */"which  you  shoot yourself in the appendage which holds  the  gun ",
/*98  */"with   which you shoot yourself in the appendage which holds  the ",
/*99  */"gun  with   which  you  shoot yourself  in  the  appendage  which ",
/*100 */"holds...  ",
/*101 */"",
/*102 */"SCHEME:  ",
/*103 */"",
/*104 */"You  shoot  yourself in the appendage which holds  the  gun  with  ",
/*105 */"which  you  shoot yourself in the appendage which holds  the  gun ",
/*106 */"with   which you shoot yourself in the appendage which holds  the ",
/*107 */"gun  with   which  you  shoot yourself  in  the  appendage  which ",
/*108 */"holds...  ...but none  of the other appendages are aware of  this ",
/*109 */"happening.  ",
/*110 */"",
/*111 */"English: ",
/*112 */"",
/*113 */"You put your foot in your mouth, then bite it off.  ",
/*114 */"",
/*115 */""
/*       End of Data       */
};

int UPPERLIMIT=115;  /* no of array elements */
int Ls=6;            /* left side of document */

void windowtalk(void)
{

int index = 0;
int numbers;
int cor[4];

char c;

      cor[0]=0;
      cor[1]=0;
      cor[2]=24;
      cor[3]=79;

      BORDERBOX(cor,BLACK,CYAN,SINGLE);
      DMC(0,0,2,BROWN,BLACK,80);
      DMC(24,0,2,BROWN,BLACK,80);
      DMC(1,0,2,BLACK,RED,80);
      DMC(23,0,2,BLACK,RED,80);
DMM(" What Goes Around Comes Around ",0,39,BLACK,YELLOW);
DMM(" Use Arrow or Page Up and Down To View...  ESC to Exit ",24,39,0,15);

      cor[0]=2;
      cor[1]=1;
      cor[2]=22;
      cor[3]=78;

      PAINT(cor,BLACK,BWHITE,BLANK);

      for(numbers = 2; numbers<23; numbers++){
                 DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                 index++ ;
                 }

    while ((c=getch())!= ESCKEY)
        {

        if ((c) == FUNCKEY)
            {
            c = getch(); /* get second character of key */
            switch (c) {

            case DOWNARROW:{
                             if (index<UPPERLIMIT){
                                      index++;
                                      index=index-21;
                                      if(index<0){
                                         index =0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);
                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                           index++ ;
                           }
                        }
                        break;
                        }
            case UPARROW:{ index--;
                             if (index<UPPERLIMIT){
                                      index=index-21;
                                      if(index<0){
                                         index =0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);
                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                           index++ ;
                           }
                        }
                        break;
                        }
            case PGDOWN: {
                          if (index >= (UPPERLIMIT-21)){
                                      index=UPPERLIMIT-21;
                                     }
                          if(index<0){
                                      index =0;
                                     }
                          for(numbers = 2; numbers<23; numbers++){
                               DMC(numbers,1,BLANK,BLACK,BWHITE,78);
                               DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                               index++ ;
                             }
                        break;
                        }
            case PGUP:  {      index=index-42;
                               if(index<0){
                                         index =0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DMC(numbers,1,BLANK,BLACK,BWHITE,78);
                           DML(WINTALK[index],numbers,Ls,BLACK,BWHITE);
                           index++ ;
                           }
                        break;
                        }
                   }
              }
        }

}


main()
{
    getadaptertype();
    cls(0,14);
    colorset(1,0);
    cursoroff();
    windowtalk();
    cls(0,7);
 DMC(0,0,FAT,BLACK,RED,80);
 DMM("An object in motion will be heading in the wrong direction.",0,39,4,14);
 cursoron();
 exit(0);
}



