/*  LOG_DEMO.C
 *  demonstration of the use of the memory allocation log
 *  last mod.: 6-JUN-91
 */

#include <STDIO.H>
#include <STDLIB.H>
#include <FCNTL.H>
#include <CONIO.H>
#include <IO.H>

#include <L_MEM.H>

char msg[72];

void main(void)
{
Far_ptr ptr;
int err_flag, ch;
char *logfile = "LOG_DEMO.LOG";
FILE *output;

/*mem_alloc(1000,&err_flag);*/
set_mem_log(TRUE);
set_termination_log_output(PRINTER_OUTPUT,REPORT_1_ONLY);

while ( kbhit() )
    ;
printf("\nThis program prints log reports #1 and #2."
       "\nSend to printer or to disk? (P/D) ");
ch = 0;
while ( ! ( ch == 'P' || ch == 'D' ) )
    {
    ch = getch();
    if ( ch > 'Z' )
        ch -= 32;
    }
putch(ch);

_L_(mem_max(&err_flag);)     /*  write in log  */
if ( !err_flag )        /*  if no error  */
    {
    /*  allocate 1000 bytes  */
    _L_(ptr = mem_alloc(1000L,&err_flag);)
    if ( !err_flag )
        {
        /*  allocate 69632 bytes and set to '2'  */
        _L_(mem_alloc_ch(0x11000,'2',&err_flag);)
        if ( !err_flag )
            {
            /*  increase first block by 2000 bytes  */
            _L_(ptr = mem_increase(ptr,2000,TRUE,&err_flag);)
            if ( !err_flag )
                {
                /*  set bytes of first block to '1'  */
                _L_(mem_set(ptr,'1',&err_flag);)
                }
            }
        }
    }

if ( ch == 'P' )
    {
    printf("\nNow printing reports ...");
    mem_log_report(1,stdprn,1,FALSE,&err_flag);
    if ( !err_flag )        /*  if no error  */
        mem_log_report(2,stdprn,1,TRUE,&err_flag);
    }
else        /*  send reports to disk file LOG  */
    {
    printf("\nNow writing reports to file %s ...",logfile);
    if ( ( output = fopen(logfile,"wt") ) == NULL )
       printf("\nUnable to open file %s.",logfile);
    else
        {
        mem_log_report(1,output,1,FALSE,&err_flag);
        if ( !err_flag )
            mem_log_report(2,output,1,TRUE,&err_flag);
        }
    }

if ( err_flag )
    {
    printf("\nAn error occurred: %s",mem_err_msg(err_flag,msg));
    exit(1);
    }

printf("\n");
}
