// ME.CXX - Multi-Edit MDI sample program         (C) Sturmer Hauss Corp. 1991


// Include only the objects from the TIER1 Library we will be using in this
// module.
#define INCL_TIER_TYPES           // data types like LONG, HWND, HANDLE
#define INCL_TIER_T1OBJECT        // base class of the TIER1 Library and Window and Overlapped classes  
#define INCL_TIER_WINDOW          // TIER Window class
   #define INCL_TIER_WINDOWMSGS   // MS-Window compatible message #defines
   #define INCL_TIER_MDIFRAME     // MDI Frame window class  
#define INCL_TIER_STARTUP         // TIER StartUp class
#define INCL_TIER_ICON            // Icon class
#define INCL_TIER_MSGBOX          // MsgBox class  
#define INCL_TIER_USERCONTROL     // UserCtrlReg, UserCtrlWindow classes
#define INCL_TIER_MDICHILDPROC    // MDIChildProc window MsgHandler
#define INCL_TIER_RESOURCE        // Resource class
#define INCL_TIER_CHARARRAY       // CharArray class


// Module includes
#include <tier1.hxx>    // TIER Library .hxx's
#include "defines.h"    // Our modules common #defines for the .RC file and here.
#include "meframe.hxx"  // MEFrameWindow object


/////////////////////////////////////////////////////////////////////////////
// StartUp::Init()
/////////////////////////////////////////////////////////////////////////////
BOOL  StartUp :: FAR Init( HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow )
   {

      MEFrameWindow   FAR   *lpMEFrameWindow;
      int                    nRet;
      char                   szTemp[ DEF_MSGLEN+1 ];
      char                   szTemp1[ DEF_APPNAMELEN+1 ];


   // Increase the Message Queue size before creating any windows.
   // We are increasing it because this app can make a flurry use of
   // closing the child windows with a user defined message.
   if( SetMsgQueueSize( 30 ) != 30 )
      {
      Resource    res;

      res.SetInstance( hInstance );
      res.LoadStr( IDS_ERRMSGQUEUE, szTemp, 120 );
      res.LoadStr( IDS_APPNAME, szTemp1, 120 );
      MsgBox().Show( szTemp, szTemp1, MB_OK | MB_ICONHAND );
      return( FALSE );
      }


   // If this is the first instance register the Child Edit Window. 
   // This takes care of all instances and assures that the window is
   // registered, no matter how many instances of this app you run and
   // irrespecitive of the order windows are created in each instance.
   if( !hPrevInstance )
      {
      Icon              icon;
      UserCtrlReg       MDIChildTemp( hInstance, "MEChild" );

      // Override the defaults set by UserCtrlReg's constructor.
      // UserCtrlReg sets the Class WndProc up as WinProc.  This
      // should be MDIChildProc.  So here we override each before
      // registering the window class.  We also add our own icon to
      // HelloWin instead of taking a null default by UserCtrlReg.

      icon.Load( hInstance, IDI_MECHILD );
      MDIChildTemp.WinSetClassIcon( icon.GetHandle() );
      MDIChildTemp.WinSetClassWndProc( (WINDOWPROC)MDIChildProc );

      MDIChildTemp.Register();
      }


   // Create our MEFrameWindow object (which will create our apps main window)
   lpMEFrameWindow = new MEFrameWindow( hInstance, hPrevInstance, lpszCmdLine, nCmdShow );


   // If no object was allocated, exit now.
   if( lpMEFrameWindow == (MEFrameWindow FAR *)0L )
      return( FALSE );


   // Start the MDIMessageLoop()
   nRet = MDIMessageLoop();


   // When we fall out of the message loop our app. has been closed, so
   // cleanup by deleting our new'd lpMEFrameWindow.
   delete lpMEFrameWindow;


   // Exit back to Windows
   return( nRet );
   }



