# ME.MAK - Make file for the TIER MDI Multi-Edit Sample Program

# Generic MakeFile for Trace.  Handles Glockespeil 1.2E1, Glock 2.0c,  
# Zortech 2.1 and Borland C++ 2.0 compilers.

# This make file is built for use with Microsoft "C" 5.1's MAKE.EXE

DEF= $*.def

# Glock compile line for 1.2E1 Medium Mem Model
# CCXX= ccxx -Gsw -Zp -W3 -AM -Os -c -D_WINDOWS -D_GLOCK12M -NTC_$*
# LINK= link /NOD /NOE @$*.lnk
# NUM= 1

# Glock compile line for 2.0 Large Mem Model
# CCXX= ccxx -Gsw -Zp -W3 -AL -Os -c -D_WINDOWS -D_GLOCK20L -NTC_$*
# LINK= link /NOD /NOE @$*.lnk
# NUM= 2

# Zortech compile line for 2.12 Large Mem Model
# CCXX= ztc -a -br -c -g -w -W -DLINT_ARGS -ml -L -D_WINDOWS -D_ZTC201L
# LINK= link /NOD /NOE @$*.lnk
# NUM= Z

# Borland Turbo C++ 2.0c large Model (note: not using pre-compiled headers)
CCXX= bccx -c -ml -w-pia -w-par -w-obi -v- -WE -Pcxx -D_WINDOWS -D_TURBOL -zCT_$*
LINK= tlinkx @$*.lnk
NUM= T


all: mdi.exe


paramdlg.obj : $*.cxx $*.hxx defines.h
   $(CCXX) $*.cxx

collect.obj : $*.cxx $*.hxx
   $(CCXX) $*.cxx

srchdlg.obj : $*.cxx $*.hxx
   $(CCXX) $*.cxx

edparser.obj : $*.cxx $*.hxx
   $(CCXX) $*.cxx

aboutdlg.obj : $*.cxx $*.hxx defines.h
   $(CCXX) $*.cxx

savasdlg.obj : $*.cxx $*.hxx defines.h
   $(CCXX) $*.cxx

opendlg.obj : $*.cxx $*.hxx defines.h
   $(CCXX) $*.cxx

printdlg.obj : $*.cxx $*.hxx mechild.hxx defines.h
   $(CCXX) $*.cxx

mepeek.obj : $*.cxx $*.hxx
   $(CCXX) $*.cxx

meprint.obj : $*.cxx $*.hxx mepeek.hxx mechild.hxx
   $(CCXX) $*.cxx

me.obj : $*.cxx defines.h meframe.hxx
   $(CCXX) $*.cxx

mechild1.obj : $*.cxx mechild.hxx defines.h meprint.hxx printdlg.hxx
   $(CCXX) $*.cxx

mechild.obj : $*.cxx $*.hxx defines.h savasdlg.hxx srchdlg.hxx
   $(CCXX) $*.cxx

meframe.obj : $*.cxx $*.hxx defines.h aboutdlg.hxx opendlg.hxx mechild.hxx paramdlg.hxx
   $(CCXX) $*.cxx

me.res : me.rc defines.h
   rc -r -v $*.rc

me$(NUM).res : me.res
   copy me.res me$(NUM).res


me$(NUM).exe : me.obj $*.def $*.res meframe.obj mechild.obj meprint.obj\
               mepeek.obj printdlg.obj opendlg.obj savasdlg.obj mechild1.obj\
               aboutdlg.obj edparser.obj srchdlg.obj collect.obj paramdlg.obj
   $(LINK)
   rc -v me$(NUM).res


me$(NUM).exe: me.res
   rc -v me$(NUM).res
   del me$(NUM).res
