// MECHILD.HXX - Multi-Edit MDI Child Window class
//               (C) Sturmer Hauss Corp 1991


#ifndef CLASS_MDICLIENTWINDOW
class THUGE MDIClientWindow;
#endif

#ifndef CLASS_MDIFRAMEWINDOW
class THUGE MDIFrameWindow;
#endif


#ifndef CLASS_EDITWINDOW
class THUGE EditWindow;
#endif




#ifndef CLASS_MECHILDWINDOW
#define CLASS_MECHILDWINDOW


// Limits
#define  DEF_FILENAME_LEN       256
#define  DEF_SEARCHSTR_LEN      132


// nDirection flags for SetDirection()
#define  DIR_FORWARD            1
#define  DIR_BACKWARD          -1


// nType flags for GetFont()     
#define  FNT_VARIABLE           0
#define  FNT_FIXED              1




//////////////////////////////////////////////////////////////////////////////
// MEChildWindow class
//////////////////////////////////////////////////////////////////////////////
class THUGE MEChildWindow : public MDIChildWindow
   {
   private  :
            MDIClientWindow FAR       *lpClient;
            MDIFrameWindow  FAR       *lpFrame;
            EditWindow      FAR       *lpEdit;
            HANDLE                     hPrevInst;
            BOOL                       bCreated;
            BOOL                       bEdited;
            char                       szFileName[ DEF_FILENAME_LEN+1 ];
            char                       szSearch[ DEF_SEARCHSTR_LEN+1 ];
            char                       szMsgText[ DEF_MSGLEN+1 ];
            char                       szMsgTemp[ DEF_MSGLEN+1 ];
            char                       szAppName[ DEF_APPNAMELEN+1 ];
            BOOL                       bCaseSensitive;
            int                        nDirection;
            BOOL                       bAbort;
            char                       szDevice[ 160 ];
            LPSTR                      lpszDriver;
            LPSTR                      lpszPort;
            LPSTR                      lpszTitle;
            int                        iPrinter;
            HANDLE                     hSetupData;
            char                       szExtDevMode[ 14 ];
            HANDLE                     hEditData;
            BOOL                       bWrap;
            WORD                       wMaxSize;
            BOOL                       bFixedFont;
            HANDLE                     hFont;
            BOOL                       bLocalEdit;


            // Private members
            BOOL     FAR   InitDevPort( BOOL bPrnSetup = TRUE );
            void     FAR   UpdateDev( void );
            BOOL     FAR   PrintEditText( LPSTR lpszDevMode );
            void     FAR   InitMenus( HANDLE hMenu );
            BOOL     FAR   PrinterSetup( BOOL bLoadDialog = TRUE );
            BOOL     FAR   CopyPrinterData( HANDLE hData );
            HANDLE   FAR   SetEditFont( int nType );
            BOOL     FAR   GetResString( WORD wResID, LPSTR lpszStringBuff, int nMaxChars );


   public   :
            FAR      MEChildWindow( MDIFrameWindow FAR *lpFrameWindow,
                                    MDIClientWindow FAR *lpClientWindow,
                                    HANDLE hPrevInstance, LPSTR lpszClassName,
                                    BOOL bUseFixedFont, BOOL bStartIconic,
                                    HANDLE hPrinterSetupData );

            FAR     ~MEChildWindow( void );

            LONG FAR WinMessageHandler( HWND hWnd, unsigned iMessage, WORD wParam, LONG lParam );

            
            BOOL     FAR   IsCreated( void )             { return( bCreated );   }
            void     FAR   SetAbort( BOOL bNewAbort )    { bAbort = bNewAbort;   }
            BOOL     FAR   GetAbort( void )              { return( bAbort );     }

            // This member allows the initial setup data
            // to be used so only one initial call to InitDevPort
            // has to be made by all instances.
            HANDLE   FAR   GetSetupData( void )          { return( hSetupData ); }

            int      FAR   Open( LPSTR lpszFileName );
            BOOL     FAR   Close( void );
            BOOL     FAR   Save( void );
            BOOL     FAR   Print( void );

            void     FAR   Find( void );
            void     FAR   FindPrev( void );
            void     FAR   FindNext( void );

            int      FAR   GetFileName( LPSTR lpszFileName, int nMaxChars = DEF_FILENAME_LEN );
            void     FAR   SetFileName( LPSTR lpszFileName );

            int      FAR   GetSearchString( LPSTR lpszSearchStr, int nMaxChars = DEF_SEARCHSTR_LEN );
            void     FAR   SetSearchString( LPSTR lpszSearchStr );

            BOOL     FAR   GetCase( void )               { return( bCaseSensitive );  }   
            void     FAR   SetCase( BOOL bNewCase )      { bCaseSensitive = bNewCase; }   

            int      FAR   GetDirection( void )          { return( nDirection );      }
            void     FAR   SetDirection( int nNewDir )   { nDirection = nNewDir;      }

            BOOL     FAR   SetWrap( BOOL bON );
   };


#endif // CLASS_MECHILDWINDOW


