// MEFRAME.HXX - Multi-Edit MDI Frame object definition-declarations


#ifndef CLASS_CHARARRAY
class THUGE CharArray;
#endif

#ifndef CLASS_COLLECTION
class THUGE Collection;
#endif

#ifndef CLASS_MDICLIENTWINDOW
class THUGE MDIClientWindow;
#endif

#ifndef CLASS_MECHILDWINDOW
class THUGE MEChildWindow;
#endif


#ifndef CLASS_MEFRAMEWINDOW
#define CLASS_MEFRAMEWINDOW


// Limits
#define  DEF_FILENAME_LEN       256    // Filename and path max length
#define  DEF_FILEEXT_LEN        5      // Max file extension length "????.TXT"
#define  MAX_RESTOREFILES       5      // Max file names that can be appended
                                       // to the file menu for restore.




////////////////////////////////////////////////////////////////////////////
// MEFrameWindow object declaration (Multi-Edit Frame Window)
////////////////////////////////////////////////////////////////////////////
class THUGE MEFrameWindow : public MDIFrameWindow
   {
   private  :
            Collection      FAR       *lpChildList;
            CharArray                  FileList[ MAX_RESTOREFILES+1 ];
            MDIClientWindow FAR       *lpMDIClient;
            HMENU                      hMenuInit;
            HMENU                      hMenuInitWindow;
            HANDLE                     hPrevInst;
            BOOL                       bShortMenu;
            char                       szFileExts[ DEF_FILENAME_LEN+1 ];
            char                       szFileName[ DEF_FILENAME_LEN+1 ];
            char                       szMsgText[ DEF_MSGLEN+1 ];
            char                       szMsgTemp[ DEF_MSGLEN+1 ];
            char                       szAppName[ DEF_APPNAMELEN+1 ];
            HANDLE                     hPrinterSetupData;
            BOOL                       bFixedFont;
            BOOL                       bOpenInitial;
            BOOL                       bSaveParams;
            BOOL                       bSaveScreen;
            BOOL                       bIsIconic;


            // Private member functions
            MEChildWindow FAR    *GetActiveChild( void );
            BOOL          FAR    CopyPrinterData( HANDLE hData );
            BOOL          FAR    GetResString( WORD wResID, LPSTR lpszStringBuff, int nMaxChars );
            BOOL          FAR    LoadProfile( LPSTR lpszFileName );
            BOOL          FAR    SaveProfile( LPSTR lpszFileName );
            void          FAR    PushFile( LPSTR lpszFileName );
            void          FAR    TopFile( LPSTR lpszFileName );


   public   :
            FAR      MEFrameWindow( HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow );
            FAR     ~MEFrameWindow( void );

            LONG FAR WinMessageHandler( HWND hWnd, unsigned iMessage, WORD wParam, LONG lParam );

   };



#endif // CLASS_MEFRAMEWINDOW







