#include <stdio.h>
#include <time.h>
#include <ctype.h>

#define	VERSION	"@(#)memo.c 1.8 - Edward I. Comer (1988)"
#define	USAGE	"USAGE: memo [-d?][filename]"
#define	rewind(x)	fseek(x,0L,0)
#define	MAXFLAGS	10
#define	COPY_FLG	0

/*********************************************************
** create a new memo - E. Comer 1988			**
**		       Atlanta, Georgia			**
**********************************************************
*/
#define	MAXLIN	80
#define	PARAMF	"memo.prm"
#define	PROTOF	"memo.pro"
#define	LOGFILE	"memo.log"
#define	MATCH	0

char *fgets();
char *getenv();

/*
** initialized variables
*/
enum source_type {
	ascii,
	multimate
};
unsigned short Debug = 0;
enum source_type Source = ascii;
char Sccsid[] = VERSION;

/*
** uninitialized variables
*/
char *cp, Path[MAXLIN], Paramf[MAXLIN], Protof[MAXLIN];
char Logf[MAXLIN];
char From[MAXLIN], To[MAXLIN];
char Copyto[MAXLIN];
char Findex[MAXLIN];
char Wpucmd[MAXLIN];
char Wpcmd[MAXLIN];
char Wpdir[MAXLIN];
char Dtdir[MAXLIN];
char Subject[MAXLIN];
char Fname[MAXLIN];
char Source_text[MAXLIN];
char Date[MAXLIN];
char Lmonth[MAXLIN];
unsigned short Flag[MAXFLAGS];
time_t mem_time;
struct tm *mtm;
FILE *fd, *pfd;

main(argc,argv)
int argc;
char *argv[];
{
	char *to_up();
	register char *cp;
	register unsigned short n;
	static char *avp[MAXLIN/2];
	char tbuf[MAXLIN];
	char *getcwd();

	while(--argc && **(++argv) == '-')
	{
		while(*++*argv)
		{
			switch(**argv)
			{
				case 'd':	/* debug */
					Debug++;
					printf("Debug = %u\n",Debug);
					break;
				case 'n':	/* name search */
					strcpy(tbuf,*++argv);
					argc--;
					*argv = "X";
					printf("name=<%s>\n",tbuf);
					continue;
				case '?':
					usage(stdout);
					exit(-1);
				default:
					printf("%s\n%s\n",Sccsid,USAGE);
					exit(-1);
			}
		}
	}
	/*************************************************
	** 		initialize			**
	*************************************************/
	strcpy(From,"A. N. Employee");
	strcpy(Findex,"000");
	strcpy(Wpucmd,".\\WS.EXE %s");
	strcpy(Wpdir,".\\");
	strcpy(Dtdir,".\\");
	strcpy(Source_text,"ascii");
	strcpy(Path,"./");
	strcpy(Protof,PROTOF);
	strcpy(Logf,LOGFILE);
	time(&mem_time);
	mtm = localtime(&mem_time);
	sprintf(Date,"%02u/%02u/%02u",mtm->tm_mon+1,mtm->tm_mday,mtm->tm_year);
	for(n=0;n < MAXFLAGS;n++)
		Flag[n] = 0;
	/*********************************
	** get operator keyboard input	**
	*********************************/
	printf("Enter 'TO' name: ");
	gets(To);
	printf("Subject ?: ");
	gets(Subject);
	printf("Copy To ?: ");
	gets(Copyto);
	if(Copyto[0] != 0)
		Flag[COPY_FLG]++;
	/*
	** use provided filename or generate one
	*/
	if(argc)
		strcpy(Fname,to_up(*argv));
	else
		Fname[0] = 0;

	/*
	** pre-pend environment path, if any, to parameter name
	*/
	if((cp = getenv("MEMO")) != NULL)
	{
		strcpy(Path,cp);
		cp = cp+strlen(cp);
		if(*cp != '\\' && *cp != '/')
		{
			strcat(Path,"\\");
		}
	}
	/*
	** fetch parameter file
	*/
	strcpy(Paramf,Path);
	strcat(Paramf,PARAMF);

	if((fd = fopen(Paramf,"r+")) == NULL)
	{
		/*
		** no parameter file, create one
		*/
		if((fd = fopen(Paramf,"w+")) == NULL)
		{
			perror("Cannot create parameter file");
			exit(-1);
		}
		wprm();
	}

	/*
	** read in parameters
	*/
	while(fgets(tbuf,MAXLIN,fd) != NULL)
	{
		tbuf[strlen(tbuf)-1] = 0;	/* remove '\n' */
		if(tbuf[0] == '#')		/* comment ? */
			continue;
		if(strncmp(tbuf,"WPCMD=",6) == MATCH)
			strcpy(Wpucmd,&tbuf[6]);
		else if(strncmp(tbuf,"FROM=",5) == MATCH)
			strcpy(From,&tbuf[5]);
		else if(strncmp(tbuf,"WPDIR=",6) == MATCH)
			strcpy(Wpdir,&tbuf[6]);
		else if(strncmp(tbuf,"DTDIR=",6) == MATCH)
			strcpy(Dtdir,&tbuf[6]);
		else if(strncmp(tbuf,"PROTOF=",7) == MATCH)
			strcpy(Protof,&tbuf[7]);
		else if(strncmp(tbuf,"FTYPE=",6) == MATCH)
		{
			strcpy(Source_text,&tbuf[6]);
			if(strncmp(Source_text,"ascii",5) == MATCH)
				Source = ascii;
			else if(strncmp(Source_text,"multimate",9) == MATCH)
				Source = multimate;
			else
				printf("FTYPE=%s <IGNORED>\n",Source_text);
		}
		else if(strncmp(tbuf,"LMONTH=",7) == MATCH)
			strcpy(Lmonth,&tbuf[7]);
		else if(strncmp(tbuf,"FILE=",5) == MATCH)
		{
			strcpy(Findex,&tbuf[5]);
			/*
			** update index number if it is to be used
			*/
			if(Fname[0] == 0)
			{
				if(mtm->tm_mon+1 != atoi(Lmonth))
				{
					sprintf(Lmonth,"%u",mtm->tm_mon+1);
					strcpy(Findex,"000");
				}
				sprintf(Findex,"%03u",atoi(Findex)+1);
				wprm();
			}
			break;
		}
	}
	fclose(fd);

	/*
	** setup proto files now that parameter file has been read
	*/
	strcpy(tbuf,Dtdir);
	strcat(tbuf,Protof);
	strcpy(Protof,tbuf);
	strcpy(tbuf,Dtdir);
	strcat(tbuf,Logf);
	strcpy(Logf,tbuf);

	/*
	** change to wp directory for remaining operations
	*/
	chdir(Wpdir);	/* move to wp directory */
	if(Debug)
	{
		printf("Changed directory to <%s>\n",Wpdir);
		printf("Currently in <%s>\n",getcwd(NULL,MAXLIN));
	}
	/*
	** open prototype file
	*/
	if((pfd = fopen(Protof,"r")) == NULL)
	{
		/*
		** no prototype file, create one
		*/
		if((pfd = fopen(Protof,"w+")) == NULL)
		{
			perror("Cannot create prototype file");
			exit(-1);
		}
		wproto();
	}

	/*
	** check for requested filename
	*/
	if(argc)
	{
		strcpy(Fname,*argv);
	}
	else	/* provide a computer generated filename */
	{
		sprintf(Fname,"M%2u%02u%s",mtm->tm_year,mtm->tm_mon+1,Findex);
	}
	/*
	** update log
	*/
	if((fd = fopen(Logf,"a")) == NULL)
	{
		perror("Cannot open log file");
		exit(-1);
	}
	fprintf(fd,"%s,",Fname);
	fprintf(fd,"%s,",to_up(To));
	fprintf(fd,"%s\n",to_up(Subject));
	fclose(fd);

	/*
	** write the new memorandum file
	*/
	makememo();
	sprintf(Wpcmd,Wpucmd,Fname);
	cp = Wpcmd;
	/*
	** split command line into argv for exec
	*/
	for(n=0;n < (MAXLIN/2);)
	{
		if(!isspace(*cp))
			avp[n++] = cp;
		while(*cp && !isspace(*cp))
			cp++;
		while(*cp && isspace(*cp))
			*cp++ = '\0';
		if(*cp == '\0')
			break;
	}
	avp[n] = NULL;
	if(Debug)
	{
		n = 0;
		printf("Debug:execvp(");
		while(avp[n] != NULL)
			printf("%s,",avp[n++]);
		printf(")\n");
	}
	else if(execvp(avp[0],&avp[0]) < 0)
	{
		fprintf(stderr,"Can't start word processor with:%s\n",Wpcmd);
		fprintf(stderr,"You need to edit WPCMD in file 'MEMO.PRM'\n");
		exit(-1);
	}
}

/*
** write parameter file
*/
wprm()
{
	rewind(fd);
	fprintf(fd,"#Note: 'FILE' must be LAST file entry\n");
	fprintf(fd,"#Note: FTYPE=ascii|multimate\n");
	fprintf(fd,"FTYPE=%s\n",Source_text);
	fprintf(fd,"#Note: WPDIR is directory to execute in.(No '\\' at end)\n");
	fprintf(fd,"WPDIR=%s\n",Wpdir);
	fprintf(fd,"#Note: DTDIR is memo destination directory ('\\' at end)\n");
	fprintf(fd,"DTDIR=%s\n",Dtdir);
	fprintf(fd,"#Note: PROTOF is default name for prototype file\n");
	fprintf(fd,"PROTOF=%s\n",Protof);
	fprintf(fd,"#Note: WPCMD is word processor command\n");
	fprintf(fd,"WPCMD=%s\n",Wpucmd);
	fprintf(fd,"#Note: FROM is Your name\n");
	fprintf(fd,"FROM=%s\n",From);
	fprintf(fd,"#NOTE: leave the next two entries alone\n");
	fprintf(fd,"LMONTH=%s\n",Lmonth);
	fprintf(fd,"FILE=%s\n",Findex);
	rewind(fd);		/* rewind file */
}

/*
** write prototype file
*/
wproto()
{
	fprintf(pfd,"\t\t\tMEMORANDUM\n\n\n");
	fprintf(pfd,"TO:   ^T\n\n");
	fprintf(pfd,"FROM: ^F\n\n");
	fprintf(pfd,"DATE: ^D\n\n");
	fprintf(pfd,"FILE: ^M\n\n");
	fprintf(pfd,"SUBJECT: ^S\n\n");
	fprintf(pfd,"^0COPY TO: ^C\n\n^0\n\n");
	usage(pfd);
	rewind(pfd);
}

/*
** actually make the memo here
**
**	assumes that pfd is already open and rewound
*/
makememo()
{
	register int c;			/* int storage for a char */
	register char *cp;		/* character pointer */
	unsigned short sub_len;		/* substitute length */
	char fname[MAXLIN];		/* local filename copy */


	strcpy(fname,Dtdir);
	strcat(fname,Fname);
	if(Source == multimate)
		strcat(fname,".DOC");	
	printf("Working on Memo <%s>\n",fname);
	if((fd = fopen(fname,"w")) == NULL)
	{
		perror("Cannot create memo file");
		exit(-1);
	}

	while((c = getc(pfd)) != EOF)
	{
		if(c != '^')		/* if not special */
			putc(c,fd);
		else			/* process special chars */
		{
			if((c = getc(pfd)) == EOF)
			{
				fprintf(stderr,"ERROR:Bad proto ^ format\n");
				exit(-1);
			}
			/*
			** switch on special char type
			*/
			switch(c)
			{
				case '^':	/* '^' */
					cp = "^";
					break;
				case 'T':	/* TO */
					cp = To;
					break;
				case 'F':	/* FROM */
					cp = From;
					break;
				case 'D':	/* DATE */
					cp = Date;
					break;
				case 'M':	/* FILENAME */
					cp = Fname;
					break;
				case 'S':	/* Subject */
					cp = Subject;
					break;
				case 'C':	/* Copyto */
					cp = Copyto;
					break;
				case '0':	/* flag check */
					if(Flag[COPY_FLG] == 0)
					{
						while((c = getc(pfd)) != EOF)
						{
							if(c == '\n')
								break;
							if(Source==multimate)
							{
								if(c==0xae)
									break;
								if(c==0)
									break;
							}
						}
						continue;
					}
					break;
				default:	/* mistake ! */
					cp = "?";
			}
			/*
			** cp->substitute string
			*/
			sub_len = strlen(cp)-2;
			sub_len = (sub_len >= 0 ? sub_len : 0);
			/*
			** multimate does not use ascii files. The header
			** portion is a null filled structure that should have
			** nulls eaten to preserve element boundaries. Any
			** One exception is the file name, which is blank
			** filled. Otherwise any non-null data is assumed
			** to be important, and is preserved
			*/
			if(Source == multimate)
			{
				while(sub_len--)
				{
					if((c = getc(pfd)) != EOF)
					{
						if(c != 0 && c != ' ')
						{
							ungetc(c,pfd);
							break;
						}
					}
				}
			}
			while(*cp)
			{
				putc(*cp++,fd);
			}
		}/* end of special char processing */
	}
	fclose(pfd);
	fclose(fd);
}

/*
** return pointer to upper case version of passed string
*/
char *\
to_up(s)
char *s;
{
	register char *d;
	static char to_up_buf[MAXLIN];

	d = to_up_buf;
	while(*s)
		*d++ = toupper(*s++);
	*d = '\0';
	return(to_up_buf);
}

/*
** print help
*/
usage(hfd)
FILE *hfd;
{
	fprintf(hfd,"%s\n\n",Sccsid);
	fprintf(hfd,"This   program   automatically  creates   a\n\
	memorandum prototype  and  then invokes your word\n");
	fprintf(hfd,"processor. File 'memo.prm', initially created by this\n");
	fprintf(hfd,"program, contains modifiable control parameters that.\n");
	fprintf(hfd,"File 'memo.prm' is assumed to be in  the  current\n");
	fprintf(hfd,"directory unless environmental variable 'MEMO' \n");
	fprintf(hfd,"contains a path. I suggest that  the  string 'set\n");
	fprintf(hfd,"MEMO=C:\TEXT' (substitute  your path)  be  placed\n");
	fprintf(hfd,"into  the  AUTOEXEC.BAT  file.  File 'memo.pro', also\n");
	fprintf(hfd,"initially  created  by  this  program, contains  a  \n");
	fprintf(hfd,"modifiable prototype memorandum file. An index  file\n");
	fprintf(hfd,"named 'memo.log' maintains a history of the files\n");
	fprintf(hfd,"for your records.\n");
	fprintf(hfd,"\n%s\n",USAGE);
	fprintf(hfd,"\nWhere:\n");
	fprintf(hfd,"\t-? - Prints this help list\n");
	fprintf(hfd,"\t-d - Prints debug information\n");
}
