/* MIKE(C) Copyright 1990 by MindSet and MindFlux
   public domain Version 1.0

   a file viewer in Microsoft C
   with regards from 982 HECTOR AVE. WPG, MB R3M 2G6.

   "let us be mundane and ordinary and assume that all color displays
    are STANDARD CGA DISPLAYS and enable snow checking where it is
    prudent to do so. We will also ignore the 43 line display mode
    that is currently in vogue because the demand is low.

    Insofar as writing to the CGA buffer between retraces; C functions for
    snow checking are as well established as the MICROSOFT C and CGA
    STANDARDS themselves. If one is not privileged to live in a snow free
    climate, the only realistic question is the size of the shovel and not
    whether one remains inside one's shell during the blizzard.

    The width shall be set to 80 characters with the high bits stript,
    and lines shall be clipped rather than wrapped.

    Wordstar and Ascii shall be viewed with one eye and Chars below 0x20
    shall be displayed as whitespace.

    Memory blocks shall be manually aligned in 64K segments to serve as
    a text buffer for formatting the file. The default data segment will
    not be affected by this procedure and may be used for autovariables
    and other additional features.

    This approach will allow most systems to grab about 320K of formatted
    text into free ram. This is comparable to 640K of text formatted with
    attributes although it is quite beyond me why one would want to store
    a large contiguous block with attributes. Our speed is already good.
    The block move capability of combined storage of text and attributes
    does not make much difference in this application.

    The really nice feature of using the windows toolkit-type of modular
    approach is the consistent speed and polished appearance of our video.

    We may as well toss in some extra brain salad because the kid
    might need some other windows routines to use elsewhere.

    We Cannot sit idly by whilst those Eastern 'Bourgeoisie-BORLANDS'
    abandon the 'KING's C' in favor of the turtle vernacular."

       -excerpt  from   "The Compleat Works of the Cad King"
                 a.k.a. "The LOWER CANADIAN TECHNOWEENIE ROAST"

*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dos.h>
#include <bios.h>
#include <io.h>
#include <string.h>
#include <malloc.h>

#define TEXT        3
#define CGA_320     4
#define HI_RES      6
#define MONOCHROME 99

#define BLACK     0
#define BLUE      1
#define GREEN     2
#define CYAN      3
#define RED       4
#define MAGENTA   5
#define BROWN     6
#define WHITE     7
#define GRAY      8
#define LBLUE     9
#define LGREEN    10
#define LCYAN     11
#define LRED      12
#define LMAGENTA  13
#define YELLOW    14
#define BWHITE    15
#define INTENSE   16

#define SCREEN     0,0,24,79

#define CRETURN '\x0d'
#define LFEED   '\x0A'
#define CTRLZ   '\x1a'
#define DELETE  '\x7f'
#define ESCAPE  '\x1b'

#define ENTERKEY   '\x0d' /* character generated by the Enter key          */
#define ESCKEY     '\x1b' /* character generated by the Esc key            */
#define FUNCKEY    '\x00' /* first character generated by function keys    */
#define HOMEKEY    'G'    /* second character generated by Home key        */
#define ENDKEY     'O'    /* second character generated by End key         */
#define UPARROW    'H'    /* second character generated by up-arrow key    */
#define DOWNARROW  'P'    /* second character generated by down-arrow key  */
#define LEFTARROW  'K'    /* second character generated by left-arrow key  */
#define RIGHTARROW 'M'    /* second character generated by right-arrow key */
#define INSERTKEY  'R'    /* second character generated by insert key      */
#define PGUP       'I'    /* second character generated by page up key     */
#define PGDOWN     'Q'    /* second character generated by page down key   */

#define BLANK     32
#define FAT       219
#define SINGLE    1
#define DOUBLE    2

/* classic textbook snow checking macros for the CGA display. */
/* note that all CGA cards suffer from snow, not just "OLDER" */
/* style cards as certain lazy turtles might have you believe.*/
/* surface mount boards retrace as visibly as the older style.*/

#define SNOW       while((inp (0x3DA) &01) != 0);
                  /* wait until end of current retrace */
#define BLIZZARD   while((inp (0x3DA) &01) == 0);
                  /* big job... wait until next retrace
                     and follow the retrace through the crt */

#define MK_FP(seg,off) ((char far *)(((long)(seg) << 16) | (off)))
/* MK_FP macro required by peek */


int peek(unsigned segment, unsigned offset)
{
    unsigned BYTE;
    static char far *target;
    char far *packet;
            target = MK_FP(segment, offset);
            packet = target;
            BYTE = *packet;
            return BYTE;

}

void poke(unsigned segment, unsigned offset, unsigned BYTE)
{
    static char far *target;
    char far *packet;
            target = MK_FP(segment, offset);
            packet = target;
            *packet = BYTE;

}

unsigned long UPPERLIMIT=64000l;
signed long   SEGSIZE=64000l;
unsigned long BUFFERBOUNDS[8]={
              0l,64000l,128000l,192000l,256000l,320000l,384000l,448000l};
int BUFFERS=0;
signed long bigpointer=0;
char far *WINTALK[8];

int BUFFER_POINTER()
{   int index;
    for(index=0;index!=8;index++)
    if(bigpointer<SEGSIZE+BUFFERBOUNDS[index] &&
       bigpointer>=BUFFERBOUNDS[index])return index;
}
int stuffbuff(void)
{
    /* line up max number of 64K text buffers */
    int index;
    for(index=0;index!=8;index++){
        WINTALK[index]= _fmalloc(SEGSIZE+80l);
        if(WINTALK[index]==NULL){BUFFERS=index-1;
                                 UPPERLIMIT=BUFFERBOUNDS[BUFFERS];
                                 return 0;
                                }
        memset(WINTALK[index],32,64000l);
                                }
}
int freebuff(void)
{   /* free the memory used by the text buffers*/
    int index;
    for(index=0;index<BUFFERS+1;index++)_ffree(WINTALK[index]);
}
void setcrtmode(m)
unsigned char m;
{
    union REGS rin,rout;
    rin.h.ah = 0;
    rin.h.al = m;
    int86(0x10,&rin,&rout);
}
/* bios cursor controls */
void cursoroff(void)
{
   union REGS regs;

   regs.h.ah = 0x01;
   regs.x.cx = 0x2000;
   int86(0x10,&regs,&regs);
}
void cursoron(void)
{
   union REGS regs;

   regs.h.ah = 0x01;
   regs.x.cx = 0x0607;
   int86(0x10,&regs,&regs);
}
void cls(void)
{
	union REGS reg;

	reg.h.ah = 6;
	reg.h.al = 0;
	reg.h.ch = 0;
	reg.h.cl = 0;
	reg.h.dh = 24;
	reg.h.dl = 79;
	reg.h.bh = 0x07;
	int86(0x10, &reg, &reg);
}

int ADAPTER=CGA_320, screen_mode=CGA_320;
int background = BLACK, foreground = WHITE;

int check_for_CGA()
{
    /* clear the screen and try to read a whitespace from the address   */
    /* for the CGA & Compatible. if its not there assume its MONOCHROME */
    /* returns -1 if CGA and 0 if not                                   */
    unsigned char *crt =(unsigned char *) 0xB8000000l;
    setcrtmode(TEXT);
    cls();
    if(crt[0]==32)return -1;
    ADAPTER=MONOCHROME;
    screen_mode=MONOCHROME;
    return 0;
}
fieldcopy(char *outstring, char *instring, int fieldlen)
{ /* stript & formatted text strings */
  int i;
  char c;
  for(i=0;i!=fieldlen;i++){
      c=instring[i]&0x7f;
      if(c > 31 && c <127 )outstring[i]=c;
      else outstring[i]=32;
      }
}
int readfile(char *name)
{
    /* formats the file that was named on the command line and    */
    /* fills the text buffers with 80-character width scan lines  */
    /* until the end of the file or the buffer is full.           */
    FILE *f1;
    int i;
    char scratchbuf[128];
    char cleanbuf[80];
    char copybuf[128];
    int bufptr;
    unsigned long offset;

  for(i=0;i!=128;i++)copybuf[i]=0;
  memcpy(scratchbuf,copybuf,128);

  if ((f1 = fopen(name,"r")) == NULL){ cursoron();
                                       cls();
                                       freebuff();
                                       printf("File %s not found!!\n",name);
                                       exit(0);}

  while(fgets(scratchbuf,128,f1)!=NULL){
        if(bigpointer<UPPERLIMIT){
           fieldcopy(cleanbuf,scratchbuf,80);
           bufptr=BUFFER_POINTER();
           offset=(bigpointer-BUFFERBOUNDS[bufptr]);
           memmove(WINTALK[bufptr]+offset,cleanbuf,80);
           bigpointer+=80;
           memcpy(scratchbuf,copybuf,128);
           }
           }
  UPPERLIMIT=bigpointer;
  if(UPPERLIMIT<21)UPPERLIMIT=21;
  bigpointer=0l;
  fclose(f1);
  return(0);
}
void DMC(int Row, int Column, unsigned BYTE, int BACK, int FRONT, int QUANT)
{
    /*  DMA replacement for writechs function */

    unsigned segment= 0xB000, offset;
    int One_Too_Many = (QUANT+1);
    int i, Attribute;

    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=MONOCHROME)segment = 0xB800;    /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    for (i=1; i< One_Too_Many ; i++){
        if(ADAPTER!=MONOCHROME)SNOW
        poke(segment,offset, BYTE);
        offset++;
        poke(segment,offset,Attribute);
        offset++;
        }
}
void DMM(char *String, int Row, int Column, int BACK, int FRONT)
{
    /*  DMA replacement for puts
        centre justified string    */

    unsigned Character, segment=0xB000, offset;
    int Attribute;
    Attribute = (BACK << 4) + FRONT;

    Column =   ((Column+1)-(.5*(strlen(String))));

    if(ADAPTER != MONOCHROME)segment = 0xB800;    /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    while (Character = *String++){
        if(ADAPTER!=MONOCHROME)SNOW
        poke(segment,offset,Character);
        offset++;
        poke(segment,offset,Attribute);
        offset ++;
    }
}


void DML(char *String, int Row, int Column, int BACK, int FRONT)
{
    /*  DMA replacement for puts
        left justified string    */
    unsigned Character, segment=0xB000, offset;
    int Attribute;
    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=MONOCHROME)segment = 0xB800; /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    while (Character = *String++){
        if(ADAPTER!=MONOCHROME)SNOW
        poke(segment,offset, Character);
        offset ++;
        poke(segment,offset,Attribute);
        offset++;
    }
}

void PAINT(int trow,int tcol,int brow,int bcol,unsigned char Character)
{  int index,linelength = ((bcol+1) - (tcol));
   for (index = (trow); index < brow+1; index++)
   DMC(index,tcol,Character,background,foreground,linelength);
}

void DFILL(char *String,int trow,int tcol,int brow,int bcol)
{ /* DMA String Fill */
  int index,i,Count,Character,length;
  length=(strlen(String));

  for (index = (trow); index < brow+1; index++){
        for( Count = tcol ; Count <(bcol+1);Count++)
        {
         Character = *String++;
         if(Character =='\0'){  /* Repeat String */
            for (i= 0; i<length+1; i++){
                Character= *String--;
                }
                Count--;
                }
        else{ DMC(index,Count,Character,background,foreground,1);
              }
          }
          while( *String !=  '\0' ){       /* Rewind and Start a New Row */
                  Character= *String++;
                  }
          for (i= 0; i<length  ; i++){
                  Character= *String--;
                  }
        }
}


void BORDERBOX(int trow,int tcol,int brow,int bcol,unsigned char BRDR)
{

    /* draws an outline only using a specified border character */
int index;
int homerow = (brow-1);
int homecol = (tcol+1);
int linelength = ((bcol) - (tcol+1));

int TLcorner,TRcorner,BLcorner,BRcorner,HORT,VERT;

          switch(BRDR){
               case DOUBLE: {
                            TLcorner = 201;
                            TRcorner = 187;
                            BLcorner = 200;
                            BRcorner = 188;
                            HORT = 205;
                            VERT = 186;
                            break;
                        }
               case SINGLE: {
                            TLcorner = 218;
                            TRcorner = 191;
                            BLcorner = 192;
                            BRcorner = 217;
                            HORT = 196;
                            VERT = 179;
                            break;
                        }
               case FAT:    {
                            TLcorner = FAT;
                            TRcorner = FAT;
                            BLcorner = FAT;
                            BRcorner = FAT;
                            HORT = FAT;
                            VERT = FAT;
                            break;
                        }
               case BLANK: {
                            TLcorner = BLANK;
                            TRcorner = BLANK;
                            BLcorner = BLANK;
                            BRcorner = BLANK;
                            HORT = BLANK;
                            VERT = BLANK;
                            break;
                        }
               default:    {
                            TLcorner = BRDR;
                            TRcorner = BRDR;
                            BLcorner = BRDR;
                            BRcorner = BRDR;
                            HORT = BRDR;
                            VERT = BRDR;
                        }
            }
   DMC(trow,tcol,TLcorner,background,foreground,1);         /* top */
   DMC(trow,homecol,HORT,background,foreground,linelength);
   DMC(trow,bcol,TRcorner,background,foreground,1);
   for (index = (trow+1); index < brow; index++){
       DMC(index,tcol,VERT,background,foreground,1);
       DMC(index,bcol,VERT,background,foreground,1);
       }
   DMC(brow,tcol,BLcorner,background,foreground,1);
   DMC(brow,homecol,HORT,background,foreground,linelength);
   DMC(brow,bcol,BRcorner,background,foreground,1);        /* bottom */
}

void DRAWBOX(int trow,int tcol,int brow,int bcol,unsigned char BRDR)
{     /* boxes without shadows */
      PAINT(trow,tcol,brow,bcol,BLANK);
      BORDERBOX(trow,tcol,brow,bcol,BRDR);
}

void SHADOW(int trow,int tcol,int brow,int bcol,unsigned char BRDR)
{
    /* draws a shadowbox */
int index;
int shad = (bcol+1);
int shadrow = (brow+1);
int homerow = (brow-1);
int homecol = (tcol+1);
int linelength = ((bcol) - (tcol+1));
int shadlength = (linelength + 2);
int TLcorner,TRcorner,BLcorner,BRcorner,HORT,VERT;

          switch(BRDR){
               case DOUBLE: {
                            TLcorner = 201;
                            TRcorner = 187;
                            BLcorner = 200;
                            BRcorner = 188;
                            HORT = 205;
                            VERT = 186;
                            break;
                        }
               case SINGLE: {
                            TLcorner = 218;
                            TRcorner = 191;
                            BLcorner = 192;
                            BRcorner = 217;
                            HORT = 196;
                            VERT = 179;
                            break;
                        }
               case FAT:    {
                            TLcorner = FAT;
                            TRcorner = FAT;
                            BLcorner = FAT;
                            BRcorner = FAT;
                            HORT = FAT;
                            VERT = FAT;
                            break;
                        }
               case BLANK: {
                            TLcorner = BLANK;
                            TRcorner = BLANK;
                            BLcorner = BLANK;
                            BRcorner = BLANK;
                            HORT = BLANK;
                            VERT = BLANK;
                            break;
                        }
               default:    {
                            TLcorner = BRDR;
                            TRcorner = BRDR;
                            BLcorner = BRDR;
                            BRcorner = BRDR;
                            HORT = BRDR;
                            VERT = BRDR;
                        }
            }

   DMC(trow,tcol,TLcorner,background,foreground,1);            /* top */
   DMC(trow,homecol,HORT,background,foreground,linelength);
   DMC(trow,bcol,TRcorner,background,foreground,1);

   for (index = (trow+1); index < brow; index++){
       DMC(index,tcol,VERT,background,foreground,1);
       DMC(index,homecol,BLANK,background,foreground,linelength);
       DMC(index,bcol,VERT,background,foreground,1);
       DMC(index,shad,FAT,background,foreground,1);
       }

   DMC(brow,tcol,BLcorner,background,foreground,1);
   DMC(brow,homecol,HORT,background,foreground,linelength);
   DMC(brow,bcol,BRcorner,background,foreground,1);
   DMC(brow,shad,FAT,background,foreground,1);
   DMC(shadrow,homecol,FAT,background,foreground,shadlength);  /* bottom */

}

titleblock(char *name)
{
    char buffer[128];
    cursoroff();
    strcpy(buffer,"Now Loading ");
    strcat(buffer,name);
    background = RED;  foreground = YELLOW;
    DFILL("Bill Buckels, Starving Programmer ",SCREEN);
    if(ADAPTER==MONOCHROME){background = BLACK;
                            foreground = BWHITE;
                        }
    else{background=BLUE;
         foreground=LCYAN;
         }
    SHADOW(7,20,17,59,DOUBLE);
    DMM("MIKE(C) Copyright 1990",10,39,background,YELLOW);
    DMM("<Public Domain Version 1.0>",11,39,background,YELLOW);
    DMM("courtesy of Mindset and Mindflux",13,39,background,foreground);
    DMM(buffer,15,39,background,foreground);
}

void DM80(int Row,int BACK, int FRONT)
{
    unsigned Character, segment=0xB000, offset;
    int Attribute,index,Column=0;

    int bufptr=BUFFER_POINTER();
    unsigned long buffoff=bigpointer-BUFFERBOUNDS[bufptr];

    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=MONOCHROME)segment = 0xB800; /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    for(index=0;index!=80;index++){
        Character = WINTALK[bufptr][buffoff+index];
        if(ADAPTER!=MONOCHROME)SNOW
        poke(segment,offset, Character);
        offset ++;
        poke(segment,offset,Attribute);
        offset++;
    }
}

void windowtalk()
{
int numbers;
char c;
cls();
      DMC(0,0,2,BROWN,BLACK,80);
      DMC(24,0,2,BROWN,BLACK,80);
      DMC(1,0,2,BLACK,RED,80);
      DMC(23,0,2,BLACK,RED,80);
DMM(" What Goes Around Comes Around ",0,39,BLACK,YELLOW);
DMM(" HOT KEYS: ARROW & PAGE Up and Down, HOME or END, ESC to Exit ",
      24,39,BLACK,YELLOW);

      for(numbers = 2; numbers<23; numbers++){
                 DM80(numbers,background,foreground);
                 bigpointer+=80 ;
                 }

    while ((c = getch())!= ESCKEY) {

        if (c == FUNCKEY) {
            c = getch(); /* get second character of key */
            switch (c) {

            case DOWNARROW:{
                             if (bigpointer<UPPERLIMIT){
                                      bigpointer+=80;
                                      bigpointer=bigpointer-(21*80);
                                      if(bigpointer<0){
                                         bigpointer =0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DM80(numbers,background,foreground);
                           bigpointer+=80 ;
                           }
                        }
                        break;
                        }
            case UPARROW:{ bigpointer-=80;
                             if (bigpointer<UPPERLIMIT){
                                      bigpointer=bigpointer-(21*80);
                                      if(bigpointer<0){
                                         bigpointer =0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DM80(numbers,background,foreground);
                           bigpointer+=80 ;
                           }
                        }
                        break;
                        }
            case ENDKEY:  bigpointer=UPPERLIMIT;
            case PGDOWN: {
                          if (bigpointer >= (UPPERLIMIT-(21*80))){
                                      bigpointer=UPPERLIMIT-(21*80);
                                     }
                          if(bigpointer<0){
                                      bigpointer =0;
                                     }
                          for(numbers = 2; numbers<23; numbers++){
                               DM80(numbers,background,foreground);
                               bigpointer+=80 ;
                             }
                        break;
                        }
            case HOMEKEY:      bigpointer=0;
            case PGUP:  {      bigpointer=bigpointer-(42*80);
                               if(bigpointer<0){
                                         bigpointer=0;
                                         }
                           for(numbers = 2; numbers<23; numbers++){
                           DM80(numbers,background,foreground);
                           bigpointer+=80 ;
                           }
                        break;
                        }
                   }
              }
}
cursoron();
cls();
printf("\n");
DMC(0,0,FAT,BLACK,RED,80);
DMM("Be Wary Of Turtles Bearing Gifts",0,39,4,14);
}


main(int argc, char *argv[])
{
    if(argc!=2){printf("\nMIKE(C) Copyright 1990 by Bill Buckels\n");
                printf("<Public Domain Version 1.0>\n");
                printf("Yet Another Ascii File Viewer\n");
                printf("Usage: \"MIKE [textfile]\"\n");
                exit(0);
                }
    stuffbuff();
    check_for_CGA();
    titleblock(argv[1]);
    readfile(argv[1]);
    windowtalk();
    freebuff();
    exit(0);

}
