/*  NOMEMLOG.C
 *  contains dummy memory allocation log functions;
 *  to be #included if no memory log required
 *  last mod.: 01-FEB-91
 *  version no. at last mod.: 1.20
 */

/*  must be #included in some source file
 *	and be preceded by #include <L_MEM.H>;
 *  the use of this file is explained fully
 *  in Chapter 9 of the documentation
 */

void mem_log_on(void)
{
;
}

void mem_log_off(void)
{
;
}

int mem_log_is_on(void)
{
return ( FALSE );
}

Uint mem_log_entries(void)
{
return ( 0 );
}

int mem_erase_log(int *err_flag)
{
err_flag = err_flag;
/*  assignments such as this are used
 *  to preempt Turbo C warning messages
 */
return ( 0 );
}

Uint mem_log_report_1(FILE *output, Uint line_spacing,
    int formfeed, int *err_flag)
{
output = output;
line_spacing = line_spacing;
formfeed = formfeed;
err_flag = err_flag;
return ( 0 );
}

Uint mem_log_report_2(FILE *output, Uint line_spacing,
    int formfeed, int *err_flag)
{
output = output;
line_spacing = line_spacing;
formfeed = formfeed;
err_flag = err_flag;
return ( 0 );
}

void mem_log_report_3(FILE *output, Uint line_spacing,
    int formfeed, int *err_flag)
{
output = output;
line_spacing = line_spacing;
formfeed = formfeed;
err_flag = err_flag;
}

void mem_log_report_last(FILE *output, Uint line_spacing, int *err_flag)
{
output = output;
line_spacing = line_spacing;
err_flag = err_flag;
}

void compact_log(int *err_flag)
{
err_flag = err_flag;
}

void mem_log_msg(Str_ptr msg, int *err_flag)
{
msg = msg;
err_flag = err_flag;
}

Uint mem_free_all(int protected_block_id, int *err_flag)
{
protected_block_id = protected_block_id;
err_flag = err_flag;
return ( 0 );
}

int get_current_block_id(void)
{
return ( 0 );
}

void array_expansion_on(void)
{
;
}

void array_expansion_off(void)
{
;
}

int array_expansion_is_on(void)
{
return ( FALSE );
}

int lib_extend_mem_log(void)
{
return ( FALSE );
}

int lib_is_log_entry(Far_str_ptr ptr)
{
ptr = ptr;
return ( FALSE );
}
