#ifndef _NUMEDIT_H
#define _NUMEDIT_H

#include <wics.h>
#include <edit.h>

#pragma option -Vo-
#if     defined(__BCOPT__) && !defined(_ALLOW_po)
#pragma option -po-
#endif

_CLASSDEF (TNumericEdit)

class TNumericEdit : public TEdit
{
private:
	virtual const Pchar streamableName() const { return "TNumericEdit"; }

protected:
	virtual LPSTR GetClassName() { return "WICSDateEdit"; }
	virtual void SetupWindow();

    virtual void WMCommand(RTMessage) = [WM_FIRST + WM_COMMAND];

	TNumericEdit(StreamableInit) : TEdit(streamableInit) {};

public:
	TNumericEdit (PTWindowsObject AParent, int ResourceId, PTModule AModule = NULL);
	~TNumericEdit ();

	int  GetLineLength();
	BOOL GetLine(LPSTR ATextString, int StrSize);
	BOOL DeleteLine(int) { return !(BOOL) SendMessage(HWindow, WM_CLEAR, 0, 0); }

	//	Redefine the following functions to do nothing. They serve no purpose in the 
	//	Numeric Edit control.
		
	BOOL CanUndo() { return FALSE; }
	int  GetLineFromPos(int) { return 0; }
    int  GetLineIndex(int) { return 0; }
	void Scroll(int, int) { return; }
	int  Search(int, LPSTR, BOOL) { return -1; }
	void GetSubText(LPSTR, int, int) { return; }

	int  GetInt ();
	long GetLong ();
	void SetInt (int i);
	void SetLong (long l);

	static PTStreamable build();

};

inline Ripstream operator >> ( Ripstream is, RTNumericEdit cl )
    { return is >> (RTStreamable )cl; }
inline Ripstream operator >> ( Ripstream is, RPTNumericEdit cl )
    { return is >> (RPvoid)cl; }

inline Ropstream operator << ( Ropstream os, RTNumericEdit cl )
    { return os << (RTStreamable )cl; }
inline Ropstream operator << ( Ropstream os, PTNumericEdit cl )
    { return os << (PTStreamable )cl; }

#pragma option -Vo.
#if     defined(__BCOPT__) && !defined(_ALLOW_po)
#pragma option -po.
#endif

#endif