// OPENDLG.CXX - File Open Dialog object members

// Include Tier1 objects used in this module

#define INCL_TIER_TYPES                 // needed
#define INCL_TIER_T1OBJECT              // needed
#define INCL_TIER_WINDOW                // needed
   #define INCL_TIER_WINDOWMSGS         // needed
#define INCL_TIER_DIALOG                // needed
#define INCL_TIER_DLGPROC               // needed
#define INCL_TIER_CONTROLWINDOW
   #define INCL_TIER_EDIT
   #define INCL_TIER_LISTBOX
   #define INCL_TIER_LISTBOXRETURNS
   #define INCL_TIER_BUTTON
#define INCL_TIER_OVERLAPPED            // needed
#define INCL_TIER_KEYBOARD              // needed
  #define INCL_TIER_KEYVALUES           // needed
#define INCL_TIER_CURSOR                // needed
#define INCL_TIER_LISTBOXMESSAGES       // needed
#define INCL_TIER_LISTBOXRETURNS        // needed
#define INCL_TIER_EDITMESSAGES          // needed
#define INCL_TIER_MSGBOX                // needed
#define INCL_TIER_FILE                  // needed
#define INCL_TIER_MODALDLG              // needed  

#define INCL_TIER_DEBUG



// Module includes .................................
#ifdef _TURBOL
extern "C"        {
#define __MSC
#endif // _TURBOL

#ifdef _GLOCK20L
extern "C"        {
#endif // _GLOCK20L

#ifdef _ZTC201L
extern "Pascal"   {
#endif // _ZTC201L

#include <stdio.h>       // sprintf()

#ifdef _GLOCK20L
                  }
#endif // _GLOCK20L

#ifdef _ZTC201L
                  }
#endif // _ZTC201L

#ifdef _TURBOL
                  }
#endif // _TURBOL


#include <tier1.hxx>     // This gets all needed includes for a Tier2 app.
#include "defines.h"     // dialog defines.
#include "opendlg.hxx"   // Object definition associated with this module.  
                         



//////////////////////////////////////////////////////////////////////////////
// OpenDlg member functions (File Load )
//////////////////////////////////////////////////////////////////////////////
OpenDlg :: FAR OpenDlg( Window FAR *lpParentWin, int nResID, LPSTR lpszDefExt ) : (lpParentWin)
   {
   // Initialize IVAR's (instance vars.)
   lpParent       = lpParentWin;
   lpFileEdit     = (EditWindow FAR *)0L;
   lpFileList     = (ListboxWindow FAR *)0L;
   lpDirList      = (ListboxWindow FAR *)0L;
   szFile[0]      = '\0';
   szDir[0]       = '\0';
   szDrive[0]     = '\0';
   szExt[0]       = '\0';
   szFileName[0]  = '\0';
   szExts[0]      = '\0';
   nNumExts       = 0;
   
   lstrcpy( szExts, lpszDefExt );
   nNumExts = Parse( lpszDefExt );

   Create( nResID );
   }                                  



OpenDlg :: FAR OpenDlg( Window FAR *lpParentWin, LPSTR lpszResID, LPSTR lpszDefExt ) : (lpParentWin)
   {
   // Initialize IVAR's (instance vars.)
   lpParent       = lpParentWin;
   lpFileEdit     = (EditWindow FAR *)0L;
   lpFileList     = (ListboxWindow FAR *)0L;
   lpDirList      = (ListboxWindow FAR *)0L;
   szFile[0]      = '\0';
   szDir[0]       = '\0';
   szDrive[0]     = '\0';
   szExt[0]       = '\0';
   szExts[0]      = '\0';
   szFileName[0]  = '\0';
   
   lstrcpy( szExts, lpszDefExt );
   nNumExts = Parse( lpszDefExt );

   Create( lpszResID );
   }                                  



// Destructor
OpenDlg :: ~OpenDlg()
   {
   delete lpFileEdit;
   delete lpFileList;
   delete lpDirList;
   }




// Dialog message handling function.
BOOL OpenDlg :: FAR DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam )
   {
      static   char     szTemp[ DEF_FILEANDPATH+1 ];
      static   BOOL     bEditChanged = FALSE;
      static   BOOL     bDirChanged  = FALSE;
      int               nIndex;
      int               i, j;


   switch( iMessage )
      {
      case  WM_INITDIALOG:
            lpFileEdit       = new EditWindow( this, IDD_FILENAME, FALSE );
            lpFileList       = new ListboxWindow( this, IDD_FILES, FALSE );
            lpDirList        = new ListboxWindow( this, IDD_DIRS, FALSE );

            if( lpFileEdit )
               lpFileEdit->SetText( szExts );

            // Load the File listbox.
            if( lpFileList && lpDirList )
               {
               FileDir().GetCurrentDir( szTemp, DEF_FILEDIRLEN );

               if( szTemp[ lstrlen( szTemp )-1 ] != '\\' )
                  lstrcat( szTemp, "\\" );

               // Load the Dir listbox.
               DlgDirectoryList( szTemp, IDD_DIRS, IDD_PATH );

               for( i = 0; i < nNumExts; i++ )
                  {
                  lpFileList->LoadDir( READWRITE, szExtList[i] );
                  }
               RemoveDups( lpFileList );
               }
      break;

      case  WM_COMMAND:
            switch( wParam )
               {
               case  IDD_FILES:
                     switch( HIWORD( lParam ) )
                        {
                        case  LBN_SELCHANGE:
                              if( lpFileList )
                                 {
                                 nIndex = lpFileList->GetSelected();
                                 lpFileList->GetText( nIndex, szTemp );
                                 if( lpFileEdit )
                                    lpFileEdit->SetText( szTemp );
                                 bEditChanged = FALSE;
                                 }
                        break;

                        case  LBN_DBLCLK:
                              DlgPostMessage( this, WM_COMMAND, IDOK, 0L );
                        break;
                        }
               break;

               case  IDD_DIRS:
                     switch( HIWORD( lParam ) )
                        {
                        case  LBN_SELCHANGE:
                              bDirChanged = TRUE;
/******************START*******************
                              if( !bEditChanged )
                                 {
                                 lpFileEdit->SetText( szExts );
                                 bEditChanged = FALSE;
                                 }
*******************END*********************/
                        break;

                        case  LBN_DBLCLK:
                              if( lpDirList && lpFileList && lpFileEdit )
                                 {
                                 // If we have sent this message to ourselves
                                 // from IDOK then lParam = -1.
                                 if( LOWORD( lParam ) != -1 )
                                    {
                                    if( DlgDirectorySelect( szTemp, IDD_DIRS ) )
                                       {
                                       if( szTemp[ lstrlen( szTemp )-1 ] != '\\' )
                                          lstrcat( szTemp, "\\" );
                                       DlgDirectoryList( szTemp, IDD_DIRS, IDD_PATH );
                                       lpFileEdit->GetText( szTemp, DEF_FILEANDPATH );
                                       lpFileList->ResetContent();      

                                       nNumExts = Parse( szTemp );
                                       if( nNumExts < 1 )
                                          {
                                          nNumExts = Parse( szExts );
                                          szFile[0] = '\0';   
                                          }
            
                                       for( i = 0; i < nNumExts; i++ )
                                          {
                                          lpFileList->LoadDir( READWRITE, szExtList[i] );
                                          }
                                       RemoveDups( lpFileList );
                                       }
                                    }
                                 else
                                    {
                                    DlgDirectoryList( szTemp, IDD_DIRS, IDD_PATH );
                                    lpFileEdit->GetText( szTemp, DEF_FILEANDPATH );
                                    lpFileList->ResetContent();

                                    nNumExts = Parse( szTemp );
                                    if( nNumExts < 1 )
                                       {
                                       nNumExts = Parse( szExts );
                                       szFile[0] = '\0';   
                                       }
            
                                    for( i = 0; i < nNumExts; i++ )
                                       {
                                       lpFileList->LoadDir( READWRITE, szExtList[i] );
                                       }
                                    RemoveDups( lpFileList );
                                    }
                                    
                                 bDirChanged = FALSE;
                                 }      
                        break;
                        }
               break;

               case  IDD_FILENAME:
                     switch( HIWORD( lParam ) )
                        {
                        case  EN_CHANGE:
                              bEditChanged = TRUE;
                        break;
                        }
               break;

               case  IDOK:
                     // If bDirChanged ie. the user is using the keyboard
                     // to select a directory and has hit the enter key,
                     // then update our dir and relist the files and return.
                     if( bDirChanged )
                        {
                        DlgSendMessage( this, WM_COMMAND, IDD_DIRS, MAKELONG( 0, LBN_DBLCLK ) );
                        bDirChanged = FALSE;
                        return( TRUE );
                        }

                     // If bEditChanged ie. the user has edited the file edit
                     // box and we should relist the files and-or change
                     // directories if necessary.  If bEditChanged is false
                     // then we can end the dialog and update everyone.
                     if( bEditChanged )
                        {
                        if( lpFileList && lpFileEdit )
                           {
                           szDrive[0] = '\0';      
                           lpFileEdit->GetText( szTemp, 256 );
   
                           // If the user has entered a new , delimited 
                           // string, parse it and redisplay.
                           for( i = 0; i < lstrlen( szTemp ); i++ )
                              {
                              if( szTemp[i] == ',' )
                                 {
                                 nNumExts = Parse( szTemp );
                                 if( nNumExts == 0 )
                                    {
                                    nNumExts = Parse( szExts );
                                    }

                                 lpFileList->ResetContent();      
                                 for( j = 0; j < nNumExts; j++ )
                                    {
                                    lpFileList->LoadDir( READWRITE, szExtList[j] );
                                    }
                                 RemoveDups( lpFileList );
                                 return( TRUE );
                                 }
                              }

                           FileIO().SplitPath( szTemp, szDrive, szDir, szFile, szExt );

                           // Check to see if the user has typed in a drive
                           // or * or ? to specify wild cards or change of 
                           // drive. If so we need to update the dir box
                           // and relist the files in the file box.
                           if( szDrive[0] && szDrive[1] == ':' )
                              {
                              lstrcpy( szTemp, szDrive );
                              // If the user didn't put in a prefix backslash
                              // take care of it.
                              if( szDir[0] != '\\' )
                                 {
                                 lstrcat( szTemp, "\\" );
                                 }
                              lstrcat( szTemp, szDir );
                              DlgSendMessage( this, WM_COMMAND, IDD_DIRS, MAKELONG( -1, LBN_DBLCLK ) );
                              lstrcpy( szTemp, szFile );
                              lpFileEdit->SetText( szTemp );
                              return( TRUE );
                              }   

                           
                           // Check to see if the user has just changed the
                           // extension but the file name is still a * or
                           // if the string has ???'s in it.
                           for( i = 0; i < lstrlen( szTemp ); i++ )
                              {
                              if( szTemp[i] == '*' || szTemp[i] == '?' )
                                 {
                                 lpFileList->ResetContent();
                                 lpFileList->LoadDir( READWRITE, szTemp );
                                 bEditChanged = FALSE;   
                                 return( TRUE );
                                 }
                              }


                           // Check to see if the user has typed in 
                           // a filename.  If it exists load it.     
                           if( !File().Exists( szTemp ) )
                              {
                              MsgBox( this ).Show( "Filename or Pathname is incorrect!",
                                                   "Open Dialog",
                                                   MB_OK | MB_ICONQUESTION );
                              return( TRUE );
                              }
                           else
                              {
                              bEditChanged = FALSE;
                              DlgPostMessage( this, WM_COMMAND, IDOK, 0L );
                              return( TRUE );
                              }
                           lpFileList->ResetContent();
                           lpFileList->LoadDir( READWRITE, szTemp );
                           bEditChanged = FALSE;   
                           }
                        }
                     else
                        {
                        FileDir().GetCurrentDir( szDir, 120 );
                        if( szDir[ lstrlen( szDir )-1 ] != '\\' )
                           lstrcat( szDir, "\\" );


                        // NOTE: This gets around a bug in Borland's
                        //       fnmerge() function used by MakePath().

                        lstrcpy( szFileName, szDrive );
                        lstrcat( szFileName, szDir );
                        lstrcat( szFileName, szFile );
                        lstrcat( szFileName, szExt );

                        // Check for the instance where the user has not
                        // changed anything and is trying to open something
                        // like *.TXT.
                        if( !File().Exists( szFileName ) )
                           {
                           bEditChanged = TRUE;
                           DlgPostMessage( this, WM_COMMAND, IDOK, 0L );
                           return( TRUE );
                           }

                        End( TRUE );
                        }
               break;

               case  IDCANCEL:
                     End( FALSE );
               break;
               }
      break;

      default:
         return( DlgDefMessageHandler(hDlg,iMessage,wParam,lParam) );
      }

   return( TRUE  );
   }







// Retrieve the file name
int OpenDlg :: FAR GetFileName( LPSTR lpszFileName, int nMaxChars )
   {
      int   i;

   for( i = 0; i < nMaxChars; i++ )
      {
      lpszFileName[i] = szFileName[i];
      if( szFileName[i] == '\0' )
         return( i-1 );
      }

   lpszFileName[i+1] = '\0';

   return( i );
   }




int OpenDlg :: FAR Parse( LPSTR lpszExt )
   {
      int   i, j;
      int   nLen;

   // This loop is depending on ',' comma delimeters
   // to separate file specs as well as a null terminator.
   j        = 0;
   nNumExts = 0;
   nLen     = lstrlen( lpszExt );

   for( i = 0; (i < nLen+1) && (j < DEF_FILESPECLEN) && (nNumExts < DEF_MAXEXTENSIONS); i++ )
      {
      szExtList[ nNumExts ][ j++ ] = lpszExt[i];
      if( lpszExt[i] == ',' || lpszExt[i] == '\0' )
         {
         szExtList[ nNumExts ][ j-1 ] = '\0';
         nNumExts++;
         j = 0;
         }
      }
   
   return( nNumExts );
   }




// Remove any duplicate files loaded by overlapping file extension
// specs.  (EXAMPLE: *.*,*.hxx - remove duplicate *.hxx's)
void OpenDlg :: FAR RemoveDups( ListboxWindow FAR *lpList )
   {
      static char     szTemp1[ DEF_FILESPECLEN+1 ];
      static char     szTemp2[ DEF_FILESPECLEN+1 ];
      int             nCount;
      int             i, j;

   nCount = lpList->GetCount();
   for( i = 0; i < nCount; i++ )
      {
      lpList->GetText( i, szTemp1 );
      for( j = i+1; j < nCount; j++ )
         {
         lpList->GetText( j, szTemp2 );
         if( lstrcmp( szTemp1, szTemp2 ) == 0 )
            {
            lpList->DeleteString( j-- );
            nCount--;
            }
         else break;
         }
      }

   }
