// OPENDLG.HXX - File Open Dialog object


#ifndef CLASS_BUTTONWINDOW
class THUGE ButtonWindow;
#endif

#ifndef CLASS_EDITWINDOW
class THUGE EditWindow;
#endif

#ifndef CLASS_LISTBOXWINDOW
class THUGE ListboxWindow;
#endif



#ifndef CLASS_OPENDLG
#define CLASS_OPENDLG

// Limits
#define  DEF_FILENAMELEN      8
#define  DEF_FILEDIRLEN     242
#define  DEF_FILEEXTLEN       5
#define  DEF_FILEDRVLEN       2
#define  DEF_FILEANDPATH      DEF_FILENAMELEN+DEF_FILEDIRLEN+DEF_FILEEXTLEN+DEF_FILEDRVLEN
#define  DEF_MAXEXTENSIONS   10
#define  DEF_FILESPECLEN      DEF_FILENAMELEN+DEF_FILEEXTLEN  


//////////////////////////////////////////////////////////////////////////////
// Open File dialog
//////////////////////////////////////////////////////////////////////////////
class THUGE OpenDlg : public ModalDlg
   {
   private  :
      Window            FAR *lpParent;
      EditWindow        FAR *lpFileEdit;
      ListboxWindow     FAR *lpFileList;
      ListboxWindow     FAR *lpDirList;
      char              szExts[ (DEF_FILESPECLEN * DEF_MAXEXTENSIONS)+1 ];
      char              szExtList[ DEF_MAXEXTENSIONS ][ DEF_FILESPECLEN+1 ];
      char              szFile[ DEF_FILENAMELEN+1 ];
      char              szDir[ DEF_FILEDIRLEN+1 ];
      char              szExt[ DEF_FILEEXTLEN+1 ];
      char              szDrive[ DEF_FILEDRVLEN+1 ];
      char              szFileName[ DEF_FILEANDPATH+1 ];
      int               nNumExts;


      int   FAR   Parse( LPSTR lpszExts );
      void  FAR   RemoveDups( ListboxWindow FAR *lpList );

   public   :
      FAR      OpenDlg( Window FAR *lpParentWin, int nResID, LPSTR lpszDefExt );
      FAR      OpenDlg( Window FAR *lpParentWin, LPSTR lpszResID, LPSTR lpszDefExt );
      FAR     ~OpenDlg( void );

      BOOL  FAR   DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam );

      int   FAR   GetFileName( LPSTR lpszFileName, int nMaxChars = DEF_FILEANDPATH );
   };


#endif  // CLASS_OPENDLG
