// PARAMDLG.CXX - Param Dialog object members

// Include Tier1 objects used in this module

#define INCL_TIER_TYPES                 // needed
#define INCL_TIER_T1OBJECT              // needed
#define INCL_TIER_WINDOW                // needed
   #define INCL_TIER_WINDOWMSGS         // needed
#define INCL_TIER_DIALOG                // needed
#define INCL_TIER_DLGPROC               // needed
#define INCL_TIER_MODALDLG              // needed  
#define INCL_TIER_CONTROLWINDOW
   #define INCL_TIER_EDIT
   #define INCL_TIER_BUTTON




// Module includes .......................................................
#ifdef _TURBOL
extern "C"        {
#define __MSC
#endif // _TURBOL

#ifdef _GLOCK20L
extern "C"        {
#endif // _GLOCK20L

#ifdef _ZTC201L
extern "Pascal"   {
#endif // _ZTC201L

#include <stdio.h>       // sprintf(), fprintf()

#ifdef _GLOCK20L
                  }
#endif // _GLOCK20L

#ifdef _ZTC201L
                  }
#endif // _ZTC201L

#ifdef _TURBOL
                  }
#endif // _TURBOL


#include <tier1.hxx>     // This gets all needed includes for a Tier2 app.
#include "defines.h"     // TRACE app. common defines (cursors)
#include "paramdlg.hxx"  // Object definition associated with this module.  
                         



//////////////////////////////////////////////////////////////////////////////
// ParamDlg member functions (Param Edit or DblClick)
//////////////////////////////////////////////////////////////////////////////
ParamDlg :: FAR ParamDlg( Window FAR *lpParentWindow, LPSTR lpszExtensions, BOOL bFixedFont, BOOL bSaveScreenPos, BOOL bSaveParameters ) : (lpParentWindow)
   {
   // Initialize IVAR's
   lstrcpy( szExts, lpszExtensions );
   bFixed      = bFixedFont;
   bSavePos    = bSaveScreenPos;
   bSaveParams = bSaveParameters;

   Create( IDD_PARAMS );
   }                                  




// Destructor
ParamDlg :: ~ParamDlg()
   {
   // do nothing yet!
   }




// Param Dialog message handling function.
BOOL ParamDlg :: FAR DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam )
   {
   switch( iMessage )
      {
      case  WM_INITDIALOG:
            if( szExts[0] )
               {
               EditWindow  edit(this, IDD_EXTS, FALSE );
               edit.SetText( szExts );
               edit.SetTextLimit( (DEF_SPECLEN * DEF_MAXEXTS) );
               }

            if( bFixed )
               ButtonWindow( this, IDD_FIXED, FALSE ).Check();

            if( bSavePos )
               ButtonWindow( this, IDD_SAVEPOS, FALSE ).Check();

            if( bSaveParams )
               ButtonWindow( this, IDD_SAVEPARAMS, FALSE ).Check();
      break;

      case  WM_CLOSE:
            End( FALSE );
      break;

      case  WM_COMMAND:
            switch( wParam )
               {
               case  IDOK:
                     EditWindow( this, IDD_EXTS, FALSE ).GetText( szExts, (DEF_SPECLEN * DEF_MAXEXTS) );
                     bFixed      = ButtonWindow( this, IDD_FIXED, FALSE ).IsChecked();
                     bSavePos    = ButtonWindow( this, IDD_SAVEPOS, FALSE ).IsChecked();
                     bSaveParams = ButtonWindow( this, IDD_SAVEPARAMS, FALSE ).IsChecked();
                     End( TRUE );
               break;

               case  IDCANCEL:
                     End( FALSE );
               break;
               }
      break;

      default:
         return( DlgDefMessageHandler(hDlg,iMessage,wParam,lParam) );
      }

   return( TRUE  );
   }






// Retrieve the file extensions
int ParamDlg :: FAR GetFileExts( LPSTR lpszFileExts, int nMaxChars )
   {
      int   i;

   for( i = 0; i < nMaxChars; i++ )
      {
      lpszFileExts[i] = szExts[i];
      if( szExts[i] == '\0' )
         return( i-1 );
      }

   lpszFileExts[i+1] = '\0';

   return( i );
   }

