/* written in MIX power C version 2.0   */
/* a bit of a twisted puppy file viewer */
/* for PCX and BSAVED CGA Screen Dumps  */


/* writing direct to screen */
/* using bios calls to set the adapter */

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <bios.h>
#include <conio.h>
#include <direct.h>
#include <malloc.h>
#include <fcntl.h>
#include <io.h>
#include <stdlib.h>



/* a group of handy definitions */

#define BLACK   0
#define BLUE    1
#define GREEN   2
#define CYAN    3
#define RED     4
#define MAGENTA 5
#define BROWN   6
#define WHITE   7
#define GRAY      8
#define LBLUE     9
#define LGREEN    10
#define LCYAN     11
#define LRED      12
#define LMAGENTA  13
#define YELLOW    14
#define BWHITE    15

#define ESCAPE  '\x1b'
#define TEXT     3
#define CGA_320  4
#define HI_RES   6
#define HERCULES 99
#define SCREENSIZE 16385

int ADAPTER = CGA_320;
int screen_mode = CGA_320;

#define BLANK     32
#define FAT       219


#define ENTERKEY   '\x0d' /* character generated by the Enter Key          */
#define ESCKEY     '\x1b' /* character generated by the Esc key            */
#define FUNCKEY    '\x00' /* first character generated by function keys    */
#define UPARROW    'H'    /* second character generated by up-arrow key    */
#define DOWNARROW  'P'    /* second character generated by down-arrow key  */
#define LTARROW    'K'    /* second character generated by left-arrow key  */
#define RTARROW    'M'    /* second character generated by right-arrow key */
#define PGUP       'I'    /* second character generated by page up key     */
#define PGDOWN     'Q'    /* second character generated by page down key   */

/* starting at character 59*/
#define F1         ';'    /* second character generated by numerical fkeys */
#define F2         '<'
#define F3         '='
#define F4         '>'
#define F5         '?'
#define F6         '@'
#define F7         'A'
#define F8         'B'
#define F9         'C'
#define F10        'D'
/* ending at character 68  */

#define CRETURN '\x0d'
#define LFEED   '\x0A'
#define CTRLZ   '\x1a'
#define DELETE  '\x7f'

#define SINGLE    218
#define DOUBLE    201

char wildfiles[200][15];

int filecords[84][2]=
{
    2,  4,  2,  23,  2, 42,  2, 61,
    3,  4,  3,  23,  3, 42,  3, 61,
    4,  4,  4,  23,  4, 42,  4, 61,
    5,  4,  5,  23,  5, 42,  5, 61,
    6,  4,  6,  23,  6, 42,  6, 61,
    7,  4,  7,  23,  7, 42,  7, 61,
    8,  4,  8,  23,  8, 42,  8, 61,
    9,  4,  9,  23,  9, 42,  9, 61,
    10, 4, 10,  23, 10, 42, 10, 61,
    11, 4, 11,  23, 11, 42, 11, 61,
    12, 4, 12,  23, 12, 42, 12, 61,
    13, 4, 13,  23, 13, 42, 13, 61,
    14, 4, 14,  23, 14, 42, 14, 61,
    15, 4, 15,  23, 15, 42, 15, 61,
    16, 4, 16,  23, 16, 42, 16, 61,
    17, 4, 17,  23, 17, 42, 17, 61,
    18, 4, 18,  23, 18, 42, 18, 61,
    19, 4, 19,  23, 19, 42, 19, 61,
    20, 4, 20,  23, 20, 42, 20, 61,
    21, 4, 21,  23, 21, 42, 21, 61,
    22, 4, 22,  23, 22, 42, 22, 61};

int getfiles(char *filetype, char *filetype2)
{

    char buffer[15];
    int wildcounter=0;

    struct ffblk wild_card;

    memset(wildfiles,0,sizeof(wildfiles));
    sprintf(buffer,"*.%s",filetype);

    if(findfirst(buffer,&wild_card,FA_NORMAL)==0)
    {
        strcpy(wildfiles[wildcounter],wild_card.ff_name);
        wildcounter++;

    while(findnext(&wild_card)==0){
           strcpy(wildfiles[wildcounter],wild_card.ff_name);
           wildcounter++;
           }
           }

    sprintf(buffer,"*.%s",filetype2);
    if(findfirst(buffer,&wild_card,FA_NORMAL)==0)
    {
        strcpy(wildfiles[wildcounter],wild_card.ff_name);
        wildcounter++;

    while(findnext(&wild_card)==0){
           strcpy(wildfiles[wildcounter],wild_card.ff_name);
           wildcounter++;
           }
           }

           qsort(wildfiles,wildcounter,15,strcmp);
return wildcounter;
}


void cursoroff(void)
{
   union REGS regs;

   regs.h.ah = 0x01;
   regs.x.cx = 0x2000;
   int86(0x10,&regs,&regs);
}


void cursoron(void)
{
   union REGS regs;

   regs.h.ah = 0x01;
   regs.x.cx = 0x0607;
   int86(0x10,&regs,&regs);
}


void cls(int BACK,int FRONT)
{
	union REGS reg;

	reg.h.ah = 6;
	reg.h.al = 0;
	reg.h.ch = 0;
	reg.h.cl = 0;
	reg.h.dh = 24;
	reg.h.dl = 79;
    reg.h.bh = (BACK << 4) + FRONT;
	int86(0x10, &reg, &reg);
}

int colorset(bground, palette)
unsigned char bground, palette;
{
    union REGS rin,rout;
    
    if(ADAPTER==HERCULES) return 0;
    rin.h.ah = 11;
    rin.h.bh = 0;
    rin.h.bl = bground;
    int86(0x10,&rin,&rout);
    rin.h.bh = 1;
    rin.h.bl = palette;
    int86(0x10,&rin,&rout);
    return 0;
}




void DMC(int Row, int Column, unsigned BYTE, int BACK, int FRONT, int QUANT)
{
    /*  DMA replacement for writechs function */

    unsigned segment= 0xB000, offset;
    int One_Too_Many = (QUANT+1);
    int i, Attribute;

    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=HERCULES)segment = 0xB800;    /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    for (i=1; i< One_Too_Many ; i++){
        poke(segment,offset, BYTE|Attribute<<8);
        offset+=2;
        }
}


void DMM(char *String, int Row, int Column, int BACK, int FRONT)
{
    /*  DMA replacement for puts
        centre justified string    */

    unsigned Character, segment=0xB000, offset;
    int Attribute;

    Attribute = (BACK << 4) + FRONT;

    Column =   ((Column+1)-(.5*(strlen(String))));

    if(ADAPTER != HERCULES)segment = 0xB800;    /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    while ((Character = *String++)!=0){
        if(Character!='\n'){
        poke(segment,offset,Character|Attribute<<8);
        offset+=2;
        }
        }
}


void DML(char *String, int Row, int Column, int BACK, int FRONT)
{
    /*  DMA replacement for puts
        left justified string    */
    unsigned Character, segment=0xB000, offset;
    int Attribute;

    Attribute = (BACK << 4) + FRONT;

    if(ADAPTER!=HERCULES)segment = 0xB800; /* CGA or Equivalent */
    offset = 160 * Row + 2 * Column ;
    while ((Character = *String++)!=0){
        if(Character!='\n'){
        poke(segment,offset, Character|Attribute<<8);
        offset +=2;
        }
    }
}


void PAINT(int *cor,int fore, int bk,unsigned char Character)
{
   int trow=cor[0],tcol=cor[1],brow=cor[2],bcol=cor[3];
   int index,linelength = ((bcol+1) - (tcol));
   for (index = (trow); index < brow+1; index++)
   DMC(index,tcol,Character,bk,fore,linelength);
}

void BORDERBOX(int *cor,int fore, int bk,unsigned char BRDR)
{

int trow=cor[0],tcol=cor[1],brow=cor[2],bcol=cor[3];
    /* draws an outline only using a specified border character */
int index;
int homerow = (brow-1);
int homecol = (tcol+1);
int linelength = ((bcol) - (tcol+1));

int TLcorner,TRcorner,BLcorner,BRcorner,HORT,VERT;

          switch(BRDR){
               case DOUBLE: {
                            TLcorner = 201;
                            TRcorner = 187;
                            BLcorner = 200;
                            BRcorner = 188;
                            HORT = 205;
                            VERT = 186;
                            break;
                        }
               case SINGLE: {
                            TLcorner = 218;
                            TRcorner = 191;
                            BLcorner = 192;
                            BRcorner = 217;
                            HORT = 196;
                            VERT = 179;
                            break;
                        }
               default:    {
                            TLcorner = BRDR;
                            TRcorner = BRDR;
                            BLcorner = BRDR;
                            BRcorner = BRDR;
                            HORT = BRDR;
                            VERT = BRDR;
                        }
            }
   DMC(trow,tcol,TLcorner,bk,fore,1);         /* top */
   DMC(trow,homecol,HORT,bk,fore,linelength);
   DMC(trow,bcol,TRcorner,bk,fore,1);
   for (index = (trow+1); index < brow; index++){
       DMC(index,tcol,VERT,bk,fore,1);
       DMC(index,bcol,VERT,bk,fore,1);
       }
   DMC(brow,tcol,BLcorner,bk,fore,1);
   DMC(brow,homecol,HORT,bk,fore,linelength);
   DMC(brow,bcol,BRcorner,bk,fore,1);        /* bottom */
}



void getadaptertype(void)
{
    if(((biosequip() >>4) &3) <3)ADAPTER=CGA_320;
    else ADAPTER=HERCULES;

}


unsigned char far *crt    =(unsigned char *) 0xB8000000l;
unsigned char far *inleaf =(unsigned char *)0xB8000000l+0x2000;
unsigned char far *screenbuffer;
unsigned char far *textscreen;

void initgraphbuffers()
{
    int i;
    textscreen   = _fmalloc(4000);
    screenbuffer = _fmalloc(SCREENSIZE);
}

void freegraphbuffers()
{
    _ffree(textscreen);
    _ffree(screenbuffer);

}

#define HERCTEXT  0
#define HERCGRAPH 1

int       HERCLEAF[4]={0x0000,0x2000,0x4000,0x6000};

#define   HERCLINE 90
#define   CGALINE  80

void bronx(void)
{
sound(60,4);
sound(40,8);
}

void HERC_CLS(void)
{
  memset(crt,0,32767);

}

/* 6485 controller mode data */
char HERC_DAT[2][12] = { { 0x61, 0x50, 0x52, 0x0f, 0x19, 0x06,
                         0x19, 0x19, 0x02, 0x0d, 0x0b, 0x0c  },
                       { 0x35, 0x2d, 0x2e, 0x07, 0x5b, 0x02,
                         0x57, 0x57, 0x02, 0x03, 0x00 ,0x00  } };
void HERC_MODE(int ctrlmode)
{
   unsigned int reg,ctrl;
   ctrl = (ctrlmode) ? 0x82 : 0x20;
   outp(0x3bf,3)                  ;  /* allow graphics enable page 1 */
   outp(0x3b8,ctrl)               ;  /* disable video and set mode   */
   for (reg = 0; reg <= 11; reg++) { /* program the crt parameters   */
        outp(0x3b4,reg)           ;
        outp(0x3b5,HERC_DAT[ctrlmode][reg]);
        }
   outp(0x3b8,ctrl+8)             ;  /* re-enable the video          */
}


/* type conversion functions */
unsigned int byteword(unsigned char a, unsigned char b){return b<<8|a;}
unsigned char lsb(unsigned int word){ return word &0xff;}
unsigned char msb(unsigned int word){ return word >>8;}
unsigned char pcxheader[128];

int checkforpcx(char *name)
{
    FILE *fp; /* reads a ZSOFT .PCX header but ignores the color map */
    int i;    /* we only want CGA compatible full screens.           */

    unsigned int zsoft,version,codetype,pixbits;
    unsigned int xmin, ymin, xmax, ymax;
    unsigned int hres, vres;
    unsigned int no_planes, bytesperline;
    int invalid = -1, valid = 0, status=valid;

    /* read the file header */
    if((fp=fopen(name,"rb"))==NULL)return -1;
    for(i=0;i!=128;i++)pcxheader[i]=fgetc(fp);
    fclose(fp);

    zsoft   =pcxheader[0];
    version =pcxheader[1];
    codetype=pcxheader[2];
    pixbits =pcxheader[3];

    if(zsoft!=10)        status = invalid;
    if(codetype!=1)      status = invalid;
    if(pixbits != 2 )
       if(pixbits != 1)  status = invalid;

    xmin=byteword(pcxheader[4],pcxheader[5]);
    ymin=byteword(pcxheader[6],pcxheader[7]);
    xmax=byteword(pcxheader[8],pcxheader[9]);
    ymax=byteword(pcxheader[10],pcxheader[11]);
    hres=byteword(pcxheader[12],pcxheader[13]);
    vres=byteword(pcxheader[14],pcxheader[15]);
    no_planes   =pcxheader[65];
    bytesperline=byteword(pcxheader[66],pcxheader[67]);

    /* comment this out. for reference only now. */

/*    if(xmin != 0  )      status = invalid;   */
/*    if(ymin != 0  )      status = invalid;   */
/*    if(xmax != 319)                          */
/*       if(xmax!=639)     status = invalid;   */
/*    if(ymax != 199)      status = invalid;   */


    if(hres != 320){
       screen_mode=HI_RES;
       /* comment out for predefinition of display */
       /* if(hres!=640)     status = invalid;      */
       }
    else
       screen_mode=CGA_320;
    if(vres != 200)      status = invalid;
    if(no_planes!=1)     status = invalid;
    if(bytesperline !=80)status = invalid;
    /* we can ignore the color map since we        */
    /* are limiting ourselves to CGA modes         */
    /* so we will not handle over 2-bits per pixel */
    return status;

}


/* a microsoft compatible bsaved image format descriptor */
unsigned char BSAVED_header[7]={
    '\xfd','\x00','\xb8','\x00','\x00','\x00','\x40'};

int checkforbas(char *name)
{
    FILE *fp;
    char c;
    int i,status=0,invalid=-1;

    if ((fp = fopen(name,"rb")) == NULL)return invalid;
    for(i=0;i!=4;i++)
        if((c=fgetc(fp))!=BSAVED_header[i])status=invalid;
            fclose(fp);
            return status;
}

int setcrtmode(unsigned char _CRT_MODE)
{
    union REGS rin,rout;

    if ((biosequip() & 0x30) == 0x30){
        ADAPTER=HERCULES                ;
        if(_CRT_MODE == TEXT){
                HERC_CLS()              ;
                HERC_MODE(HERCTEXT)     ;
                }
           else{HERC_MODE(HERCGRAPH)    ;
                HERC_CLS()              ;
                }
            return (0)                  ;
            }

    rin.h.ah = 0;
    rin.h.al = _CRT_MODE;
    int86(0x10,&rin,&rout);
    return 0;

}

int PCXREAD(char *pcxfilename)
{
    unsigned int packet,width=0;
    FILE *fp;
    unsigned char byte,bytecount;
    long wordcount,target;
    unsigned int bufptr = 0;

    if(checkforpcx(pcxfilename)==-1)return-1;
    fp = fopen(pcxfilename,"rb");

    target = filelength(fileno(fp));
    for(wordcount=0;wordcount!=128;wordcount++)byte=fgetc(fp);

    do{ bytecount=1;                          /* start with a seed count */
        byte=fgetc(fp);
        wordcount++;
                                              /* check to see if its raw */
        if(0xC0 == (0xC0 &byte)){             /* if its not, run encoded */
                    bytecount= 0x3f &byte;
                    byte=fgetc(fp);
                    wordcount++;
                    }
        for(packet=0;packet<bytecount;packet++)
            {
             screenbuffer[bufptr]=byte;
             bufptr++;
            }

        }while(wordcount<target);
        fclose(fp);
        return(0);
}



int B_READ(char *name)
{
    FILE *fp,*fp2;
    int fh,fh2,y,i;
    char headbuf[8];
    int offset=0,interleaf=8192;        /* window the YREGs */
    long bos;                           /* bottom of screen */
    long target=16384,target2,header=7;
    /* open the file twice,eliminate the interleaf,read contiguous */

    if ((fp = fopen(name,"rb")) == NULL)return -1;
    if((fh = open(name,O_RDONLY|O_BINARY)) == -1)return 0;
    if ((fp2 = fopen(name,"rb")) == NULL)return -1;
    if((fh2 = open(name,O_RDONLY|O_BINARY)) == -1)return 0;
    read(fh,headbuf,7);
    for(i=0;i!=4;i++)if(headbuf[i]!=BSAVED_header[i]){fclose(fp);
                                                      fclose(fp2);
                                                      close(fh);
                                                      close(fh2);
                                                      return 2;}
    target2=(target/2)+header;
    lseek(fh,(long)(header),SEEK_SET);
    lseek(fh2,(long)(target2),SEEK_SET);
    bos=target/80;                           /*filesize divide by scanlines*/

          for(y=0;y<200;y++){
                read(fh,screenbuffer+offset,80);
                offset+=80;
                y++;
                if(y<200)read(fh2,screenbuffer+offset,80);
                offset+=80;
                }
            fclose(fp);
            fclose(fp2);
            close(fh);
            close(fh2);
            screen_mode=CGA_320;

            return 0;

}

int cload()
{
 unsigned int y,inset=((HERCLINE*6)+5),offset=0;
 int status;

 if(ADAPTER==HERCULES){
    HERC_CLS();
    for(y=0;y!=299;y++){
        memcpy(&crt[0]+HERCLEAF[y%4]+inset,&screenbuffer[offset],CGALINE);
        if(y%4==3)inset+=HERCLINE;
        if(y%3!=2)offset+=CGALINE;
        }
    return(0);
    }

    inset = offset;

    for(y=0;y<200;){
        memcpy(&crt[inset],&screenbuffer[offset],CGALINE);
        offset+=CGALINE;
        y++;
        memcpy(&inleaf[inset],&screenbuffer[offset],CGALINE);
        offset+=CGALINE;
        inset+=CGALINE;
        y++;
        }
     return(0);

}




int vux(char *picfile)
{
   int status = 0;
   char c;
   unsigned char palette=0, background=16;

   if((status=PCXREAD(picfile))==-1)
       if((status=B_READ(picfile))==-1)
          {
           bronx();
           return -1;
           }

   if(ADAPTER!=HERCULES)
      memcpy(textscreen,crt,4000);

   setcrtmode(screen_mode);
   colorset(background,palette);
   cload();
   while((c=getch())!=27)
   {
     switch(toupper(c))
     {
        case 'C': if(ADAPTER==HERCULES)break;
                  if(screen_mode==HI_RES)break;
                  palette++;
                  if(palette==2)
                  {
                    palette=0;
                    background++;
                   }
                   if(background==32)background=0;
                   colorset(background,palette);
                   break;

        case 'H':  if(ADAPTER==HERCULES)break;
                   if(screen_mode==CGA_320)screen_mode=HI_RES;
                   else screen_mode =CGA_320;
                   setcrtmode(screen_mode);
                   cload();
                   if(screen_mode==HI_RES)
                     colorset(7,0);
                   else
                     colorset(background, palette);
        }
    }
    setcrtmode(TEXT);
    cursoroff();
    if(ADAPTER!=HERCULES)
       memcpy(crt,textscreen,4000);

    return 0;

}

int displayfiles(char *filetype, char *filetype2)
{
   int i;
   int hotfile= 0;
   int coldfile=0;
   int filecount = getfiles(filetype,filetype2);
   char c;
   int background = BLUE, foreground = YELLOW;
   int cor[4];

   int breverse=RED,freverse=YELLOW;
   if(ADAPTER==HERCULES){
                         breverse=WHITE;
                         freverse=BLACK;
                         }

   if(filecount==0)return 0;
   cls(background, foreground);
   cursoroff();

   cor[0]=0;
   cor[1]=0;
   cor[2]=24;
   cor[3]=79;

   BORDERBOX(cor,freverse,breverse,DOUBLE);
   DMC(0,1,1,breverse,freverse,78);
   DMM(
   " PBVIEW(C) Copyright 1990 by Bill Buckels  PCX or BSAVED IMAGE Viewer ",
   0,40,breverse,freverse);
 DMM(

" Arrow Key Select | Enter To View : \"C\" Color | \"H\" Hi Res | ESCape Exit ",
        24,40,RED,YELLOW);


   if(filecount>84)filecount=84;


   for(i=0;i<filecount;i++)
       DML(wildfiles[i],filecords[i][0],filecords[i][1],
       background,foreground);
       DML(wildfiles[hotfile],filecords[hotfile][0],filecords[hotfile][1],
       breverse,freverse);

   while((c=getch())!=ESCKEY)
    {   if(c==ENTERKEY)vux(wildfiles[hotfile]);
        if(c==FUNCKEY)
        {
            c=getch();
            switch(c)
            {
              case UPARROW  : if(hotfile<4)break;
                              hotfile-=4;
                              break;

              case DOWNARROW: if(hotfile>(filecount-5))break;
                              hotfile+=4;
                              break;

              case RTARROW  :
                              if(hotfile<(filecount-1))
                              hotfile++;
                              break;

              case LTARROW  : if(hotfile==0)break;
                              hotfile--;
                              break;
              case PGUP     :
              case PGDOWN   : break;
              }
            }
              if(hotfile!=coldfile)
              {
                DML(wildfiles[coldfile],
                    filecords[coldfile][0],filecords[coldfile][1],
                    background,foreground);
                DML(wildfiles[hotfile],
                    filecords[hotfile][0],filecords[hotfile][1],
                    breverse,freverse);
                    coldfile=hotfile;
                    }
                }

   cursoron();
   cls(BLACK,WHITE);
   return 0;

}


main(int argc, char **argv)
{
    getadaptertype();
    initgraphbuffers();
    displayfiles("PCX","BAS");
    freegraphbuffers();
    exit(0);

}



