/*
File          : PG.C    (Concatenate files and print)
Author        : Thomas P. Devitt
                Pseudonym Software - Data: 818-796-4197

Updated on    : July 5, 1987
Include files : stdio.h
                ctype.h
                fcntl.h
                dos.h
                process.h
                string.h
                pg.h         (external definitions, function prototypes)

Portibility   : PC/MS-DOS only
Defined in    : UNIX (May be called MORE or P)
Synopsis      : PG [-flags] [ filename1 ] [...] [ filenameN ]
*/


#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include <dos.h>
#include <process.h>
#include <string.h>
#include "pg.h"

main(int argc, char *argv[])
{
   FILE     *fp;
   int      count, currentp, pagesize;
   int      found = 0;
   char     *psizep;

   pagesize = PAGESIZE;
   if (argv[1][0] == '-' || argv[1][0] == '/')
   {
      psizep = argv[1];
      if (tolower(*++psizep) == 'p')
      {
         psizep++;
         if (sscanf(psizep,"%d",&pagesize) != 1)
            pagesize = PAGESIZE;
      }
      argc--;
      argv++;
   }
   if (argc == 1)
   {
      print(stdin, pagesize);
      found++;
   }
   else
      if (argc == 2 && argv[1][0] == '?' && argv[1][1] == 0)
      {
         help();
         exit(0);
      }
      while (--argc)
      {
         count = getfnl(*++argv,fnames,sizeof(fnames),ANY);
         if (count > 0)
         {
            found++;
            if (strbpl(fpointers,MAXFILES,fnames) != count)
            {
               fprintf(stderr,"\nPg: Too many file names\n");
               exit(1);
            }
            else
            {
               currentp = 0;
               while (currentp < count)
               {
                  fp = fopen(fpointers[currentp],"rt");
                  print(fp, pagesize);
                  fclose(fp);
                  currentp++;
               }
            }
         }
      }
   if (found)
      exit(0);
   else
   {
      fprintf(stderr,"\nPG: No files found.\n");
      exit(1);
   }
}

void print(FILE *fp, int pagesize)
{
   static int   lines = 0;
   char         buf[BUFSIZ];

   while (fgets(buf,sizeof(buf),fp) != NULL)
      if (++lines < pagesize)
         fputs(buf,stdout);
      else
      {
         buf[strlen(buf)-1] = '\0';
         fputs(buf,stdout);
         fflush(stdout);
         (void)ki();
         fputc('\n',stdout);
         lines = 0;
      }
}

int ki(void)
{
   int result;

   _AX = 0;
   geninterrupt(0x16);
   result = _AX;
   if (result && 255)
      return (result && 255);
   else
      return ((result >> 8) + 256);
}

void help(void)
{
   register char   **dp;

   for (dp = documentation; *dp; dp++)
      printf("%s\n", *dp);
 }
