#define PAGESIZE    25
#define MAXFILES    600
#define FNASIZE     38912
#define ANY         FA_HIDDEN | FA_SYSTEM

void    print(FILE *fp, int pagesize);
int     ki(void);
void    help(void);
int     getfnl(char *fnp, char *fna, unsigned fnasize, int attr);
int     strbpl(char *fpointers[], int maxcount, char *fna);

char    fnames[FNASIZE], *fpointers[MAXFILES];

char    *documentation[] = {
"PG sucessively displays the contents of one or more files, pausing after",
"each screen is displayed.  It functions very much line the MORE command,",
"except that PG also takes its commands from command line parameters.  MORE",
"uses only the DOS redirection symbols \"<\", \">\" and \"|\".  The resulting",
"output may be directed to your terminal (default), or to a file, or to your",
"printer or may be piped to another command.  By default, the page length is",
"25 lines, but this can be changed with the -p<length> flag.",
"",
"   Usage:  PG [-flags] <file list>",
"",
"   where -flags =  -p<page length>",
"",
"The file list is a list of files (wildcards are acceptable).",
"",
"",
"Examples:",
"",
"    PG file1 file2              file1+file2 copied to stdout",
"    PG file1 file2 >file3       file1+file2 copied to file3  (CAT is better)",
"    PG file1 file2 >lpt1        file1+file2 copied to LPT1",
"    CAT file1 file2 | PG        file1+file2 piped through PG",
"    PG <longfile                Same as MORE <longfile",
0 };
