/* popen.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const char *text[] =
    {
    "one", "two", "three", "four", "five", "six", "seven", NULL
    };

int main (int argc, char *argv[])
    {
    FILE *f;
    int i;
    char buf[2048];

    if (argc < 3 || (strcmp (argv[1], "-i") != 0 && strcmp (argv[1], "-o") != 0))
        {
        (void)fputs ("Usage: popen -i <command>\n"
                     "       popen -o <command>\n", stderr);
        return (1);
        }
    buf[0] = 0;
    for (i = 2; i < argc; ++i)
        {
        if (buf[0] != 0)
            (void)strcat (buf, " ");
        (void)strcat (buf, argv[i]);
        }
    if (strcmp (argv[1], "-i") == 0)
        {
        f = popen (buf, "rt");
        if (f == NULL)
            {
            perror ("popen");
            return (2);
            }
        i = 1;
        while (fgets (buf, sizeof (buf), f) != NULL)
            (void)printf ("%4d: %s", i++, buf);
        }
    else
        {
        f = popen (buf, "wt");
        if (f == NULL)
            {
            perror ("popen");
            return (2);
            }
        for (i = 0; text[i] != NULL; ++i)
            {
            if (fputs (text[i], f) != 0)
                {
                perror ("fputs");
                return (2);
                }
            if (fputc ('\n', f) == EOF)
                {
                perror ("fputc");
                return (2);
                }
            if (fflush (f) != 0)
                {
                perror ("fflush");
                return (2);
                }
            }
        }
    i = pclose (f);
    if (i < 0)
        {
        perror ("pclose");
        return (2);
        }
    if ((i & 0xff) == 0)
        (void)printf ("Normal process termination, rc=%d\n", i >> 8);
    else if ((i & 0xff) == 127)
        (void)printf ("Process stopped by signal %d\n", i >> 8);
    else
        (void)printf ("Process terminated by signal %d\n", i & 0xff);
    return (0);
    }
