// PRINTDLG.CXX - Print cancel Dialog object members

// Include Tier1 objects used in this module

#define INCL_TIER_TYPES                 // needed
#define INCL_TIER_T1OBJECT              // needed
#define INCL_TIER_STARTUP               // needed
#define INCL_TIER_WINDOW                // needed
   #define INCL_TIER_WINDOWMSGS         // needed
   #define INCL_TIER_MDICLIENT          // MDI Client window class
   #define INCL_TIER_MDICHILD           // MDI Child window class
#define INCL_TIER_DIALOG                // needed
#define INCL_TIER_DLGPROC               // needed
#define INCL_TIER_MODELESSDLG           // needed  




#include <tier1.hxx>     // This gets all needed includes for a Tier2 app.
#include "defines.h"     // TRACE app. common defines (cursors)
#include "mechild.hxx"   // MEChildWindow class
#include "printdlg.hxx"  // Object definition associated with this module.  
                         


//////////////////////////////////////////////////////////////////////////////
// TestDlg member functions (About Edit or DblClick)
//////////////////////////////////////////////////////////////////////////////
PrintDlg :: FAR PrintDlg( MEChildWindow FAR *lpParentWindow, LPSTR lpszDevice, LPSTR lpszPort, LPSTR lpszTitle ) : (lpParentWindow)
   {
   lpParent    = lpParentWindow;
   lpszDev     = lpszDevice;
   lpszPrt     = lpszPort;
   lpszTitl    = lpszTitle;

   Create( IDD_PRINT );
   }                                  




// Destructor
PrintDlg :: ~PrintDlg()
   {
   // do nothing yet!
   }




// About Dialog message handling function.
BOOL PrintDlg :: FAR DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam )
   {
   switch( iMessage )
      {
      case  WM_INITDIALOG:
            {
            DlgSetDlgItemText( IDD_PRINTDEVICE, lpszDev );
            DlgSetDlgItemText( IDD_PRINTPORT, lpszPrt );
            DlgSetDlgItemText( IDD_PRINTTITLE, lpszTitl );
            DlgPostMessage( this, WM_SETFOCUS, IDOK, 0L );
            }
      break;

      case  WM_CLOSE:
            lpParent->SetAbort( TRUE );
      break;

      case  WM_COMMAND:
            switch( wParam )
               {
               case  IDOK:
                     lpParent->SetAbort( TRUE );
               break;
               }
      break;

      default:
         return( DlgDefMessageHandler(hDlg,iMessage,wParam,lParam) );
      }

   return( TRUE  );
   }

