/* Resolve a uucp address into a FidoNet address */

#include <stdio.h>
#include <string.h>

#include "fred.h"

int resolve(char *path, struct nodeaddr *naddr, char *user, char *domain)
{

 char tpath[256];
 char zone[10], net[10], node[10], point[10], dm[32], usr[32];
 char *pt;
 int atype;

 /* Look for a form of [p#.]f#.n#.z#.some.org!first.last */ /* Type 1 */
 /*                 or first.last@[p#.]f#.n#.z#.some.org */ /* Type 2 */
 /*                 or first.last                        */ /* Type 3 */

 /* return naddr = z:n/f.p
    user         = "first last"
    domain       = "some.org  */

 /* Make sure it has the basic elements "f", ".n", ".z" */
 if(strstr(path, "f" ) != NULL &&
    strstr(path, ".n") != NULL &&
    strstr(path, ".z") != NULL){

  /* If it also has a "!", assume type 1 */
  if(strstr(path, "!") != NULL){
   atype = 1;
  }
  /* If it also has a "@", assume type 2 */
  else if(strstr(path, "@") != NULL){
   atype = 2;
  }
  /* Otherwise, I don't know what to do with it */
  else{
   /* See if it is a local message */
   if(strstr(path, ".") != NULL &&
      strstr(path, "!") == NULL &&
      strstr(path, "@") == NULL &&
      strstr(path, ":") == NULL){
    atype = 3;
   }
   else{
    fprintf(stderr, "Pathname %s is not legal for Mail-Uf\n", path);
    return -1;
   }
  }
 }
 else{
   /* See if LOCAL */
   if(strstr(path, ".") != NULL &&
      strstr(path, "!") == NULL &&
      strstr(path, "@") == NULL &&
      strstr(path, ":") == NULL){
    atype = 3;
   }
   else{
    fprintf(stderr, "Pathname %s is not legal for Mail-Uf\n", path);
    return -1;
   }
 }

 /* Make a copy */
 strcpy(tpath, path);

  if(atype == 3){
   strcpy(usr, strtok(tpath, "."));
   strcat(usr, " ");
   strcat(usr, strtok(NULL, "."));
   strcpy(user, usr);
   return 3;
  }

  if(atype == 2){
   strcpy(usr, strtok(tpath, "@"));
  }

  /* Parse out the address */
  if(atype == 1){
   if(strncmpi(path, "p", 1) == 0){
    strcpy(point, strtok(tpath, ".")+1);
    strcpy(node, strtok(NULL, ".")+1);
   }
   else{
    strcpy(point,"0");
    strcpy(node,strtok(tpath, ".")+1);
   }
  }
  else if(atype == 2){
   pt = 1 + strstr(path, "@");
   if(strncmpi(pt, "p", 1) == 0){
    strcpy(point, strtok(NULL, ".")+1);
    strcpy(node, strtok(NULL, ".")+1);
   }
   else{
    strcpy(point, "0");
    strcpy(node, strtok(NULL, ".")+1);
   }
  }

  strcpy(net,strtok(NULL, ".")+1);
  strcpy(zone,strtok(NULL, ".")+1);

  if(atype == 1){
   strcpy(dm, strtok(NULL, "!"));
   strcpy(usr, strtok(NULL, "\0"));
  }
  else if(atype == 2){
   strcpy(dm, strtok(NULL, "\0"));
  }

  if((pt = strstr(usr, ".")) != NULL){
   *pt = SPACE;
  }

  naddr->zone  = atoi(zone);
  naddr->net   = atoi(net);
  naddr->node  = atoi(node);
  naddr->point = atoi(point);

  strcpy(domain, dm);
  strcpy(user, usr);

/*
fprintf(stderr, "%d:%d/%d.%d %s %s\n", naddr->zone, naddr->net, naddr->node,
		 naddr->point, dm, usr);
*/

  return 2;
}
