// SAVASDLG.CXX - Save As Dialog object members

// Include Tier1 objects used in this module

#define INCL_TIER_TYPES                 // needed
#define INCL_TIER_T1OBJECT              // needed
#define INCL_TIER_WINDOW                // needed
   #define INCL_TIER_WINDOWMSGS         // needed
#define INCL_TIER_DIALOG                // needed
#define INCL_TIER_DLGPROC               // needed
#define INCL_TIER_CONTROLWINDOW
   #define INCL_TIER_EDIT
   #define INCL_TIER_LISTBOX
#define INCL_TIER_KEYBOARD              // needed
  #define INCL_TIER_KEYVALUES           // needed
#define INCL_TIER_CURSOR                // needed
#define INCL_TIER_LISTBOXMESSAGES       // needed
#define INCL_TIER_LISTBOXRETURNS        // needed
#define INCL_TIER_EDITMESSAGES          // needed
#define INCL_TIER_MSGBOX                // needed
#define INCL_TIER_FILE                  // needed
#define INCL_TIER_MODALDLG              // ModalDlg class





// Module includes
#include <tier1.hxx>     // This gets all needed includes for a Tier2 app.
#include "defines.h"     // common defines (cursors)
#include "savasdlg.hxx"  // Object definition associated with this module.  
                         



//////////////////////////////////////////////////////////////////////////////
// SaveAsDlg member functions (File Load )
//////////////////////////////////////////////////////////////////////////////
SaveAsDlg :: FAR SaveAsDlg( Window FAR *lpParentWin, int nID, LPSTR lpszFileName, LPSTR lpszDefExt ) : (lpParentWin)
   {
   // Initialize instance vars.
   lpParent       = lpParentWin;
   lpFileEdit     = (EditWindow FAR *)0L;
   lpDirList      = (ListboxWindow FAR *)0L;
   szFile[0]      = '\0';
   szDir[0]       = '\0';
   szDrive[0]     = '\0';
   szExt[0]       = '\0';
   szFileName[0]  = '\0';

   if( lpszFileName[0] != '\0' )
      lstrcpy( szFileName, lpszFileName );

   if( lpszDefExt )
      lstrcpy( szExt, lpszDefExt );
   

   Create( nID );
   }                                  




SaveAsDlg :: FAR SaveAsDlg( Window FAR *lpParentWin, LPSTR lpszResID, LPSTR lpszFileName, LPSTR lpszDefExt ) : (lpParentWin)
   {
   // Initialize instance vars.
   lpParent       = lpParentWin;
   lpFileEdit     = (EditWindow FAR *)0L;
   lpDirList      = (ListboxWindow FAR *)0L;
   szFile[0]      = '\0';
   szDir[0]       = '\0';
   szDrive[0]     = '\0';
   szExt[0]       = '\0';
   szFileName[0]  = '\0';

   if( lpszFileName[0] != '\0' )
      lstrcpy( szFileName, lpszFileName );

   if( lpszDefExt )
      lstrcpy( szExt, lpszDefExt );

   Create( lpszResID );
   }                                  



// Destructor
SaveAsDlg :: ~SaveAsDlg()
   {
   delete lpFileEdit;
   delete lpDirList;
   }




// SaveAs Dialog message handling function.
BOOL SaveAsDlg :: FAR DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam )
   {
      static   char     szTemp[256];
      static   BOOL     bEditChanged = FALSE;
      static   BOOL     bDirChanged  = FALSE;
      static   char     szTempExt[ DEF_FILEEXTLEN+1 ];
      int               i;


   switch( iMessage )
      {
      case  WM_INITDIALOG:
            lpFileEdit       = new EditWindow( this, IDD_FILE, FALSE );
            lpDirList        = new ListboxWindow( this, IDD_DIRLIST, FALSE );

            // Save the default for later.
            if( szExt[0] )
               lstrcpy( szTempExt, szExt );
            else  szTempExt[0] = '\0';

            if( lpFileEdit )
               {
               if( szFileName[0] )
                  {
                  FileIO().SplitPath( szFileName, szDrive, szDir, szFile, szExt );
                  lstrcpy( szTemp, szFile );
                  lstrcat( szTemp, szExt );
                  lpFileEdit->SetText( szTemp );
                  }
               }
            

            lstrcpy( szTemp, szDrive );
            lstrcat( szTemp, szDir );

            // Load the Dir listbox.
            if( lpDirList )
               {
               if( szDir[0] == '\0' )
                  FileDir().GetCurrentDir( szTemp, DEF_FILEDIRLEN );

               if( szTemp[ lstrlen( szTemp )-1 ] != '\\' )
                  lstrcat( szTemp, "\\" );
               
               // Load the Dir listbox.
               DlgDirectoryList( szTemp, IDD_DIRLIST, IDD_DIR );
               }
      break;

      case  WM_COMMAND:
            switch( wParam )
               {
               case  IDD_DIRLIST:
                     switch( HIWORD( lParam ) )
                        {
                        case  LBN_SELCHANGE:
                              bDirChanged = TRUE;
                        break;

                        case  LBN_DBLCLK:
                              if( lpDirList && lpFileEdit )
                                 {
                                 // If we have sent this message to ourselves
                                 // from IDOK then lParam = -1.
                                 if( LOWORD( lParam ) != -1 )
                                    {
                                    if( DlgDirectorySelect( szTemp, IDD_DIRLIST ) )
                                       {
                                       if( szTemp[ lstrlen( szTemp )-1 ] != '\\' )
                                          lstrcat( szTemp, "\\" );
                                       DlgDirectoryList( szTemp, IDD_DIRLIST, IDD_DIR );
                                       lpFileEdit->GetText( szTemp, DEF_FILENAMELEN+DEF_FILEEXTLEN );
                                       }
                                    }
                                 else
                                    {
                                    DlgDirectoryList( szTemp, IDD_DIRLIST, IDD_DIR );
                                    lpFileEdit->GetText( szTemp, DEF_FILENAMELEN+DEF_FILEEXTLEN );
                                    }
                                 bDirChanged = FALSE;
                                 }      
                        break;
                        }
               break;

               case  IDD_FILE:
                     switch( HIWORD( lParam ) )
                        {
                        case  EN_CHANGE:
                              bEditChanged = TRUE;
                        break;
                        }
               break;

               case  IDOK:
                     // If bDirChanged ie. the user is using the keyboard
                     // to select a directory and has hit the enter key,
                     // then update our dir and relist the files and return.
                     if( bDirChanged )
                        {
                        DlgSendMessage( this, WM_COMMAND, IDD_DIRLIST, MAKELONG( 0, LBN_DBLCLK ) );
                        bDirChanged = FALSE;
                        return( TRUE );
                        }

                     // If bEditChanged ie. the user has edited the file edit
                     // box and we should relist the files and-or change
                     // directories if necessary.  If bEditChanged is false
                     // then we can end the dialog and update everyone.
                     if( bEditChanged )
                        {
                        if( lpFileEdit )
                           {
                           szDrive[0] = '\0';      
                           lpFileEdit->GetText( szTemp, 256 );
                           FileIO().SplitPath( szTemp, szDrive, szDir, szFile, szExt );

                           // Check to see if the user has typed in a drive
                           // or * or ? to specify wild cards or change of 
                           // drive. If so we need to update the dir box
                           // and relist the files in the file box.
                           if( szDrive[0] && szDrive[1] == ':' )
                              {
                              lstrcpy( szTemp, szDrive );
                              // If the user didn't put in a prefix backslash
                              // take care of it.
                              if( szDir[0] != '\\' )
                                 {
                                 lstrcat( szTemp, "\\" );
                                 }
                              lstrcat( szTemp, szDir );
                              lstrcat( szTemp, szFile );
                              lstrcat( szTemp, szExt );
                              lpFileEdit->SetText( szTemp );
                              }   


                           if( File().Exists( szTemp ) )
                              {
                              if( MsgBox( this ).Show( "File already exists.  Do you want to overwrite it?",
                                                   "Save As Dialog",
                                                   MB_YESNO | MB_ICONQUESTION ) == IDYES )
                                 {  
                                 bEditChanged = FALSE;
                                 bDirChanged  = FALSE;
                                 DlgPostMessage( this, WM_COMMAND, IDOK, 0L );
                                 }
                              return( TRUE );
                              }
                           else
                              {
                              bEditChanged = FALSE;
                              DlgPostMessage( this, WM_COMMAND, IDOK, 0L );
                              return( TRUE );
                              }
                           bEditChanged = FALSE;   
                           }
                        }
                     else
                        {
                        lpFileEdit->GetText( szTemp, 256 );
                        FileIO().SplitPath( szTemp, szDrive, szDir, szFile, szExt );
                        if( szDrive[0] && szDrive[1] == ':' )
                           {
                           lstrcpy( szTemp, szDrive );
                           // If the user didn't put in a prefix backslash
                           // take care of it.
                           if( szDir[0] != '\\' )
                              {
                              lstrcat( szTemp, "\\" );
                              }
                           lstrcat( szTemp, szDir );
                           lstrcpy( szDir, szTemp );
                           }
                        else
                           {
                           FileDir().GetCurrentDir( szDir, 120 );
                           i = lstrlen(szDir)-1;
                           if( szDir[ i ] != '\\' )
                              {
                              szDir[ i+1 ] = '\\';
                              szDir[ i+2 ] = '\0';
                              }
                           }

                        
                        // Validate the users selection. If we can create a
                        // dummy file in the users selected path then it 
                        // must be valid so exit TRUE.
                        lstrcpy( szTemp, szDir );
                        lstrcat( szTemp, szFile );
                        lstrcat( szTemp, ".$$$" );
                        if( File().Create( szTemp, CFILE_READWRITE ) != -1 )
                           {
                           File().Delete( szTemp );

                           // If the user did NOT supply an extension 
                           // default it to szTempExt  
                           if( (lstrcmp( szExt, "" ) == 0) && szTempExt[0] )
                              lstrcpy( szExt, szTempExt );
                                              
                           lstrcpy( szFileName, szDir );
                           lstrcat( szFileName, szFile );
                           lstrcat( szFileName, szExt );

                           End( TRUE );
                           }
                        else
                           {
                           MsgBox( this ).Show( "Filename or Path is invalid.", "Save As Dialog", MB_OK );
                           }
                        }
               break;

               case  IDCANCEL:
                     End( FALSE );
               break;
               }
      break;

      default:
         return( DlgDefMessageHandler(hDlg,iMessage,wParam,lParam) );
      }

   return( TRUE  );
   }






// Retrieve the file name
int SaveAsDlg :: FAR GetFileName( LPSTR lpszFileName, int nMaxChars )
   {
      int   i;

   for( i = 0; i < nMaxChars; i++ )
      {
      lpszFileName[i] = szFileName[i];
      if( szFileName[i] == '\0' )
         return( i-1 );
      }

   lpszFileName[i+1] = '\0';

   return( i );
   }

