//==============================================================================================
//
//	Microdyne Libraries for the Object Windows Libraries
//	Version 1.00
//
//	SBAR.H - Status Bar Class
//	Copyright  1993 by Microdyne Development Technologies.
//	All rights reserved.
//==============================================================================================

#ifndef _SBAR_H
#define _SBAR_H

#include <owl.h>

//----------------------------------------------------------------------------------------------
//	Status Bar Window Class
//----------------------------------------------------------------------------------------------

_CLASSDEF (TStatusBar)

class TStatusBar : public TWindow
{
private:
	WORD	   wHeight;
	WORD	   wAreas;
	WORD	   rArea[10];
	HANDLE	   hAreaText[11];
	COLORREF   clrText[11];

protected:
	void GetWindowClass(WNDCLASS& WndClass);

public:
	TStatusBar (PTWindowsObject AParent, WORD wHeight = 0);
	~TStatusBar ();

	virtual void Paint (HDC hdc, PAINTSTRUCT& PaintStruct);
	virtual void AppendArea (WORD wWidth, LPSTR AString, COLORREF clrRef);
	virtual BOOL RemoveArea (WORD AreaId);
	virtual BOOL SetAreaText (WORD AreaId, LPSTR NewString);
	virtual BOOL SetAreaTextColor (WORD AreaId, COLORREF clrRef);
	virtual BOOL SetAreaWidth (WORD AreaId, WORD wWidth);
	WORD GetHeight ();
};
#endif