/* sig3.c */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <setjmp.h>

static jmp_buf jump;

static void handler (int sig)
    {
    (void)printf ("Signal %d received\n", sig);
    (void)signal (sig, SIG_ACK);
    longjmp (jump, 1);
    }

int main (void)
    {
    int c;

    if (signal (SIGINT, handler) == SIG_ERR)
        {
        (void)puts ("signal failed");
        return (1);
        }
    if (setjmp (jump) != 0)
        (void)puts ("jumped");
    for (;;)
        {
        c = fgetchar ();
        if (c == EOF)
            break;
        (void)putchar (c);
        }
    (void)putchar ('\n');
    return (0);
    }
