/*
File          : strbpl.c                  (Build Pointer List)
Author        : Thomas P. Devitt
                Pseudonym Software - Data: 818-796-4197
Updated on    : May 23, 1987
Include files : None
Portibility   : PC/MS-DOS only
Defined in    : Lattice C v 3.xx (Class: Lattice)
Synopsis      : n = strbpl(spa, max, fna);

                int n;                  number of pointers
                char *spa[];            pointer to string pointer array
                int  max;               number of elements in spa[]
                char *fna;              file name array string

Description   : constructs a list of pointers to the strings contained in
                fna, which is a character array in which each string is
                terminated with a null byte and the entire array is terminated
                with another null byte (ie. the same way DOS stores strings
                in the environment).  The string pointer array will be
                terminated with a NULL pointer.

Returns       : The return value indicates how many string pointers were
                placed in the string pointer array spa[].  If the number of
                strings plus the final NULL pointer is greater than max, a
                value of -1 is returned.

******************************************************************************/

#include <stdio.h>

int strbpl(char *fpointers[], int maxcount, char *fna)
{
   int count = 0;

   while ((*fna) && (++count < maxcount))
   {
      *fpointers++ = fna;
      while (*fna++);
   }
   *fpointers = NULL;
   return count < maxcount ? count : -1;
}
