#ifndef _TIMEEDT_H
#define _TIMEEDT_H

#include <wics.h>
#include <edit.h>

#pragma option -Vo-
#if     defined(__BCOPT__) && !defined(_ALLOW_po)
#pragma option -po-
#endif

_CLASSDEF (TTimeEdit)

class TTimeEdit : public TEdit
{
private:
	virtual const Pchar streamableName() const { return "TTimeEdit"; }

protected:
	virtual LPSTR GetClassName() { return "WICSTimeEdit"; }
	virtual void SetupWindow();

    virtual void WMCommand(RTMessage) = [WM_FIRST + WM_COMMAND];

	TTimeEdit(StreamableInit) : TEdit(streamableInit) {};

public:
	TTimeEdit (PTWindowsObject AParent, int ResourceId, PTModule AModule = NULL);
	~TTimeEdit ();

	int  GetLineLength();
	BOOL GetLine(LPSTR ATextString, int StrSize);
	BOOL DeleteLine(int) { return !(BOOL) SendMessage(HWindow, WM_CLEAR, 0, 0); }

	//	Redefine the following functions to do nothing. They serve no purpose in the 
	//	Date Edit control.
		
	BOOL CanUndo() { return FALSE; }
	int  GetLineFromPos(int) { return 0; }
    int  GetLineIndex(int) { return 0; }
	void Scroll(int, int) { return; }
	int  Search(int, LPSTR, BOOL) { return -1; }
	void GetSubText(LPSTR, int, int) { return; }

	virtual void GetTime (long & lSeconds, Rint iHour, Rint iMinute, Rint iSecond);
	virtual void GetHour (Rint iHour);
	virtual void GetMinute (Rint iMinute);
	virtual void GetSecond (Rint iSecond);
	virtual void SetTime (Rint iHour, Rint iMinute, Rint iSecond);

	virtual void GetEditParams (LPDECPARMS lpep);
	virtual void SetEditParams (LPDECPARMS lpep);

	static PTStreamable build();

};

inline Ripstream operator >> ( Ripstream is, RTTimeEdit cl )
    { return is >> (RTStreamable )cl; }
inline Ripstream operator >> ( Ripstream is, RPTTimeEdit cl )
    { return is >> (RPvoid)cl; }

inline Ropstream operator << ( Ropstream os, RTTimeEdit cl )
    { return os << (RTStreamable )cl; }
inline Ropstream operator << ( Ropstream os, PTTimeEdit cl )
    { return os << (PTStreamable )cl; }

#pragma option -Vo.
#if     defined(__BCOPT__) && !defined(_ALLOW_po)
#pragma option -po.
#endif

#endif