# Makefile : Builds the viewer application
#
# Usage:     NMAKE option (build Multipad)
#    or:     NMAKE clean  (erase all compiled files)
#
# option:    DEBUG=[0|1]  (DEBUG not defined is equivalent to DEBUG=0)
#

OBJS=viewer.obj bounce.obj hello.obj filewin.obj linefile.obj bbutton.obj
HEADERS=viewer.h bounce.h hello.h filewin.h bbutton.h resource.h common.h mydlgs.h

PCH=viewer.h
# program uses Win31 #defines, but not any Win31 library entries (i.e. rc -30)
CPPFLAGS= /AM /W3 /Zp /GA /GEs /G2 /Yu$(PCH) 
LINKFLAGS=/NOD /ONERROR:NOEXE

!if "$(DEBUG)"=="1"
CPPFLAGS=/D_DEBUG $(CPPFLAGS) /Od /Zi /f
LINKFLAGS=$(LINKFLAGS) /COD
LIBS=mafxcwd libw commdlg mlibcew shell
!else
CPPFLAGS=$(CPPFLAGS) /Oselg /Gs
LINKFLAGS=$(LINKFLAGS)
LIBS=mafxcw libw commdlg mlibcew shell
!endif

viewer.exe: viewer.res viewer.def $(OBJS)
	link $(LINKFLAGS) @<<
$(OBJS),
viewer,
NUL,
$(LIBS),
viewer.def;
<<
	rc -30 /k /t viewer.res

viewer.obj : viewer.cpp $(HEADERS)
	$(CC) $(CPPFLAGS) /Yc$(PCH) /c viewer.cpp

*.obj:  viewer.h $(PCH)
viewer.res:  *.ico viewer.h

clean:
	-erase viewer.exe
	-erase viewer.res
	-erase viewer.pch
	-erase *.obj
