// File Viewing Program
// Filename: VIEWFILE.CPP
// Author: B.Zink	- CIS ID 70224,37
// (c) Copyright 1992 - All Rights Reserved
// Version: 1.00
// ---------------------------------------------------------------
// Revisions:
// ---------------------------------------------------------------
// August 27, 1992 - First Version
// ---------------------------------------------------------------
// August 28, 1992 - Added printing thru Borland Printer Class
// ---------------------------------------------------------------
//
// Remarks:
//    This program was written to help a friend with a few OWL
//    questions. It has a few features which have been requested
//    here on the bulletin board. Some of these "features" are:
//
//    1) Scrolling Text Window - read only
//    2) "Unlimited" file text based on machine memory,
//		   as memory is allocated from the heap
//    3) String Class use
//    4) Array Class use
//    5) Simple use of TFileDialog
//		6) Changing fonts in Listbox
//		7) Changing fonts in Window with LOGFONT
//		8) My favorite fixed pitch fonts with the TERMINAL face
//			(used by the MS-DOS window)
//    9) Trapping Non-client messages
//	  10) ComboBox message trapping
//   11) etc etc
//
// This was written in a few hours, so if there are bugs, and
// notices of non-existent error checking, so be it.
// ---------------------------------------------------------------
// Any comments welcome i.e., Programming is fun! This is worthless!
// etc. etc. CIS ID 70224,37
// You may use any/all of this code in any way you like provided:
// 	1) You send me a CompuServe email message saying you did.
//    2) See item #1
//    3) If you add any Wonderful stuff, let me know !
//		4) If you make a million dollars, we share!
//		5) Failure to comply with 1-4 will mean you will be haunted
// 		by the ghosts of Elvis impersonators the rest of your life, and you
//			violate the Copyright laws of the US, and I know you would'nt want
//    	to do that.
// ---------------------------------------------------------------
// Painless compiling
//
// I use the DOS subst command religiously. So, add the
// following to you CONFIG.SYS file (if not already there)
//
// LASTDRIVE=Z
//
// and now, in AUTOEXEC.BAT
//
// SUBST Q:  C:\BORLANDC
//           (of course, put YOUR real borland root directory)
//
// Now, the project file will work wonderfully. I use this technique
// all of the time as I switch projects from home, to work, to laptop.
// Saves me BUNCHES of time.
// ---------------------------------------------------------------

// ---------------------------------------------------------------
// Includes
// ---------------------------------------------------------------
#include <owl.h>
#include <bwcc.h>
#include <combobox.h>
#include <filedial.h>

// include for Basic DOS File operations
#include <stdio.h>
// Array Container class to hold individual lines
#include <array.h>
// String container class - defines strings as objects
#include <strng.h>
// For basic string functions - _fstrcpy, etc.
#include <string.h>

#include "ids.h"
// Include stuff for Borland printer class (BC3.1 or OWL VISION TAPE)
// also on CompuServe
#include "printer.h"

// ---------------------------------------------------------------
// Class includes
// ---------------------------------------------------------------

#include "viewwin.hpp"

// ---------------------------------------------------------------
// Global constants
// ---------------------------------------------------------------

const int MAXLINES = 4000;  // maxlines in file (i.e. \n's)
                            // use this to catch potential infinite loops
// ---------------------------------------------------------------
// Global variables
// ---------------------------------------------------------------

Array LinesInFile(100,0,10);	// Array to hold individual lines of text file
int numberLines;					// Total number of lines in file
POINT defaultSize = { 8,8 };  // Set default font size ( width x height )

PString thisString;

// ---------------------------------------------------------------
// Class declarations
// ---------------------------------------------------------------


// ---------------------------------------------------------------
// Application class
// ---------------------------------------------------------------

class TViewFileApp : public TApplication
{
public:
	TViewFileApp( LPSTR AName, HINSTANCE hInstance,HINSTANCE hPrevInstance,
														LPSTR lpCmdLine, int nCmdShow )
		: TApplication(AName, hInstance, hPrevInstance, lpCmdLine, nCmdShow)
	{
		// Initialize BWCC (Borland's Custom Controls)
		BWCCGetVersion();
	}
	~TViewFileApp()
	{
		// MUST delete the stuff read in, or memory DIES BIG time.
		LinesInFile.ownsElements(TShouldDelete::Delete);
		LinesInFile.flush(TShouldDelete::Delete);
   }
   virtual void InitMainWindow();
};

// ---------------------------------------------------------------
// Printer class
// ---------------------------------------------------------------

_CLASSDEF(TFileOut)
class TFileOut : public TPrintout
{
protected:
	BOOL Finished;  	// Bool to determine if multipage print is done
   int  LineNumber;  // index for Array element for multiple pages
public:
	TFileOut(Pchar ATitle) : TPrintout(ATitle)
	{
		Finished = FALSE;
      LineNumber = 0;
	}
   virtual void PrintPage(HDC DC, WORD Page, POINT Size, LPRECT Rect,
																				WORD Flags);
	void SetBanding( BOOL b ) { Banding = b; }
	virtual BOOL IsNextPage() { return !Finished;}
};

void TFileOut::PrintPage(HDC DC, WORD , POINT pageSize, LPRECT ,WORD )
{
	TEXTMETRIC tm;
	GetTextMetrics(DC, &tm);
   // could make these part of class and define them when DC is created
	int yChar = tm.tmHeight+tm.tmExternalLeading;
   int nLinesPerPage = pageSize.y / yChar;

	char lineBuffer[200];

	BOOL ok = TRUE;
	int line = 0;
	int max = LinesInFile.getItemsInContainer();
	char *ptr;

	// Print loop - prints appropriate Lines per page or will start
	// a new page if Formfeed char ( 0xC ) char is found in line

	for (int j=LineNumber;line < nLinesPerPage && ok;j++) {
   	// printed all lines
		if (j==max) {
			ok = FALSE;
			continue;
		}
		RObject AnObject = LinesInFile[j];
		if (AnObject != NOOBJECT) {
      	// Translate Object to a String variable
			String AString = *((PString)(&AnObject));
         // Get String to a char *
			_fstrcpy(lineBuffer, AString);
         // Check for a formfeed char in line
			if( (ptr=_fstrchr(lineBuffer,12)) != NULL) {            
				ok = FALSE;
				*ptr = 0;
			}
         // output the line
			TextOut(DC, 5, line*yChar, lineBuffer, lstrlen(lineBuffer));
			line++;
      }
	}
	// update the line index for next page   
	LineNumber=j;
   // if all lines printed, the set BOOL Finished to TRUE;
	if (j >= max) 
		Finished = TRUE;
}

// ---------------------------------------------------------------
// Main Window
// ---------------------------------------------------------------

class TAppWindow : public TWindow
{
public:
	PTPrinter Printer;
   char filename[80];
	TAppWindow( PTWindowsObject aParent, LPSTR aTitle )
		: TWindow( aParent, aTitle)
	{
		AssignMenu("#1");      	// Get the menu
		Attr.X = Attr.Y = 0;		// Start in upper left corner
		Printer = new TPrinter; // Attach a printer object to window
      filename[0] = 0;			// What filename to print
	}
	~TAppWindow()
	{
		delete Printer;			// must delete these type of objects
	}
	virtual void CMFileExit				( RTMessage Msg ) = [CM_FIRST + IDM_FILE_EXIT];
	virtual void CMOpen 					( RTMessage Msg ) = [CM_FIRST + IDM_FILE_OPEN];
   virtual void CMFilePrinterSetup	( RTMessage Msg ) = [CM_FIRST + IDM_FILE_PRINTERSETUP];
   virtual void CMFilePrint			( RTMessage Msg ) = [CM_FIRST + IDM_FILE_PRINT];
};

void TAppWindow::CMFilePrint(RTMessage)
{
	// Cant print if no file selected 
	if (!filename[0]) {
		BWCCMessageBox(HWindow,"No File In Use!\nUse File|Open","Print Error",
      			MB_ICONEXCLAMATION | MB_OK);
		return;
   }
	PTFileOut Printout = 0;

	if ( Printer ) {
		Printout = new TFileOut("View File - Print");
		if ( Printout ) {
			Printout->SetBanding( FALSE ); // just text - don't need it
			Printer->Print(this, Printout);
			delete Printout;
		}
	}
}

void TAppWindow::CMFilePrinterSetup(RTMessage)
{
  if ( Printer )
	Printer->Setup(this);
}

void TAppWindow::CMFileExit( RTMessage )
{
	CloseWindow();
}

// Open a file for viewing

void TAppWindow::CMOpen( RTMessage )
{
	char Filename[80];
	Filename[0]  = '\0';

	// Flush out previous file if necessary

	LinesInFile.ownsElements(TShouldDelete::Delete);
	LinesInFile.flush(TShouldDelete::Delete);

	// Get the filename to view

   if (GetApplication()->ExecDialog(new TFileDialog(this,
							  SD_FILEOPEN, Filename)) == IDOK) {
      lstrcpy(filename,Filename);
		PTViewDialog viewFile = new TViewDialog( this, "VIEWFILE", Filename);
		GetApplication()->ExecDialog( viewFile );
	}
}

void TViewFileApp::InitMainWindow()
{
	MainWindow = new TAppWindow( NULL, "File Viewer" );
}

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
		    LPSTR lpCmdLine, int nCmdShow )
{
	TViewFileApp ViewFile( "ViewFile", hInstance, hPrevInstance,lpCmdLine,
																					nCmdShow );
   ViewFile.Run();

   return ViewFile.Status;
}
